=== modified file 'DBUS-API'
--- DBUS-API	2019-02-10 04:20:26 +0000
+++ DBUS-API	2017-02-23 19:11:11 +0000
@@ -27,9 +27,9 @@
     Removes a client
    
 ** Signals:
-*** ClientNotFound(s: KeyID, s: Address)
-    A client connected from Address using KeyID, but was
-    rejected because it was not found in the server.  The key ID
+*** ClientNotFound(s: Fingerprint, s: Address)
+    A client connected from Address using Fingerprint, but was
+    rejected because it was not found in the server.  The fingerprint
     is represented as a string of hexadecimal digits.  The address is
     an IPv4 or IPv6 address in its normal string format.
 
@@ -66,7 +66,6 @@
    | Expires (f)             | s    | Read       | N/A                 |
    | ExtendedTimeout (a)     | t    | Read/Write | extended_timeout    |
    | Fingerprint             | s    | Read       | fingerprint         |
-   | KeyID                   | s    | Read       | key_id              |
    | Host                    | s    | Read/Write | host                |
    | Interval (a)            | t    | Read/Write | interval            |
    | LastApprovalRequest (g) | s    | Read       | N/A                 |
@@ -131,25 +130,24 @@
 
 * Copyright
 
-    Copyright © 2010-2019 Teddy Hogeborn
-    Copyright © 2010-2019 Björn Påhlsson
+    Copyright © 2010-2017 Teddy Hogeborn
+    Copyright © 2010-2017 Björn Påhlsson
   
 ** License:
-
-   This file is part of Mandos.
-
-   Mandos is free software: you can redistribute it and/or modify it
-   under the terms of the GNU General Public License as published by
-   the Free Software Foundation, either version 3 of the License, or
-   (at your option) any later version.
-
-   Mandos is distributed in the hope that it will be useful, but
+   
+   This program is free software: you can redistribute it and/or
+   modify it under the terms of the GNU General Public License as
+   published by the Free Software Foundation, either version 3 of the
+   License, or (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+   along with this program.  If not, see
+   <http://www.gnu.org/licenses/>.
 
 
 #+STARTUP: showall

=== modified file 'INSTALL'
--- INSTALL	2019-02-09 23:23:26 +0000
+++ INSTALL	2016-07-03 03:32:28 +0000
@@ -39,7 +39,6 @@
     
 *** Mandos Server
     + GnuTLS 3.3          https://www.gnutls.org/
-      (but not 3.6.0 or later, until 3.6.6, which works)
     + Avahi 0.6.16        http://www.avahi.org/
     + Python 2.7          https://www.python.org/
     + dbus-python 0.82.4 https://dbus.freedesktop.org/doc/dbus-python/
@@ -61,7 +60,6 @@
     + initramfs-tools 0.85i
                         https://tracker.debian.org/pkg/initramfs-tools
     + GnuTLS 3.3        https://www.gnutls.org/
-      (but not 3.6.0 or later, until 3.6.6 which works)
     + Avahi 0.6.16      http://www.avahi.org/
     + GnuPG 1.4.9       https://www.gnupg.org/
     + GPGME 1.1.6       https://www.gnupg.org/related_software/gpgme/
@@ -71,7 +69,7 @@
     + OpenSSH           http://www.openssh.com/
     
     Package names:
-    initramfs-tools libgnutls-dev gnutls-bin libavahi-core-dev gnupg
+    initramfs-tools libgnutls-dev libavahi-core-dev gnupg
     libgpgme11-dev pkg-config ssh
 
 * Installing the Mandos server
@@ -125,9 +123,7 @@
      
 	# /usr/lib/mandos/plugins.d/mandos-client \
 		--pubkey=/etc/keys/mandos/pubkey.txt \
-		--seckey=/etc/keys/mandos/seckey.txt \
-		--tls-privkey=/etc/keys/mandos/tls-privkey.pem \
-		--tls-pubkey=/etc/keys/mandos/tls-pubkey.pem; echo
+		--seckey=/etc/keys/mandos/seckey.txt; echo
      
      This command should retrieve the password from the server,
      decrypt it, and output it to standard output.

=== modified file 'Makefile'
--- Makefile	2019-02-11 06:31:42 +0000
+++ Makefile	2017-02-23 20:35:20 +0000
@@ -1,4 +1,4 @@
-WARN:=-O -Wall -Wextra -Wdouble-promotion -Wformat=2 -Winit-self \
+WARN=-O -Wall -Wextra -Wdouble-promotion -Wformat=2 -Winit-self \
 	-Wmissing-include-dirs -Wswitch-default -Wswitch-enum \
 	-Wunused -Wuninitialized -Wstrict-overflow=5 \
 	-Wsuggest-attribute=pure -Wsuggest-attribute=const \
@@ -10,10 +10,10 @@
 	-Wmissing-format-attribute -Wnormalized=nfc -Wpacked \
 	-Wredundant-decls -Wnested-externs -Winline -Wvla \
 	-Wvolatile-register-var -Woverlength-strings
-#DEBUG:=-ggdb3 -fsanitize=address 
+#DEBUG=-ggdb3 -fsanitize=address 
 # For info about _FORTIFY_SOURCE, see feature_test_macros(7)
 # and <https://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
-FORTIFY:=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
+FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
 # <https://developerblog.redhat.com/2014/10/16/gcc-undefined-behavior-sanitizer-ubsan/>
 ALL_SANITIZE_OPTIONS:=-fsanitize=leak -fsanitize=undefined \
         -fsanitize=shift -fsanitize=integer-divide-by-zero \
@@ -28,8 +28,8 @@
 SANITIZE:=$(foreach option,$(ALL_SANITIZE_OPTIONS),$(shell \
 	echo 'int main(){}' | $(CC) --language=c $(option) /dev/stdin \
 	-o /dev/null >/dev/null 2>&1 && echo $(option)))
-LINK_FORTIFY_LD:=-z relro -z now
-LINK_FORTIFY:=
+LINK_FORTIFY_LD=-z relro -z now
+LINK_FORTIFY=
 
 # If BROKEN_PIE is set, do not build with -pie
 ifndef BROKEN_PIE
@@ -37,33 +37,33 @@
 LINK_FORTIFY += -pie
 endif
 #COVERAGE=--coverage
-OPTIMIZE:=-Os -fno-strict-aliasing
-LANGUAGE:=-std=gnu11
-htmldir:=man
-version:=1.8.3
-SED:=sed
+OPTIMIZE=-Os -fno-strict-aliasing
+LANGUAGE=-std=gnu11
+htmldir=man
+version=1.7.15
+SED=sed
 
-USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
-GROUP:=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nogroup || echo 65534)))
+USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
+GROUP=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nogroup || echo 65534)))
 
 ## Use these settings for a traditional /usr/local install
-# PREFIX:=$(DESTDIR)/usr/local
-# CONFDIR:=$(DESTDIR)/etc/mandos
-# KEYDIR:=$(DESTDIR)/etc/mandos/keys
-# MANDIR:=$(PREFIX)/man
-# INITRAMFSTOOLS:=$(DESTDIR)/etc/initramfs-tools
-# STATEDIR:=$(DESTDIR)/var/lib/mandos
-# LIBDIR:=$(PREFIX)/lib
+# PREFIX=$(DESTDIR)/usr/local
+# CONFDIR=$(DESTDIR)/etc/mandos
+# KEYDIR=$(DESTDIR)/etc/mandos/keys
+# MANDIR=$(PREFIX)/man
+# INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
+# STATEDIR=$(DESTDIR)/var/lib/mandos
+# LIBDIR=$(PREFIX)/lib
 ##
 
 ## These settings are for a package-type install
-PREFIX:=$(DESTDIR)/usr
-CONFDIR:=$(DESTDIR)/etc/mandos
-KEYDIR:=$(DESTDIR)/etc/keys/mandos
-MANDIR:=$(PREFIX)/share/man
-INITRAMFSTOOLS:=$(DESTDIR)/usr/share/initramfs-tools
-STATEDIR:=$(DESTDIR)/var/lib/mandos
-LIBDIR:=$(shell \
+PREFIX=$(DESTDIR)/usr
+CONFDIR=$(DESTDIR)/etc/mandos
+KEYDIR=$(DESTDIR)/etc/keys/mandos
+MANDIR=$(PREFIX)/share/man
+INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
+STATEDIR=$(DESTDIR)/var/lib/mandos
+LIBDIR=$(shell \
 	for d in \
 	"/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
 	"`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/lib; do \
@@ -74,22 +74,23 @@
 	done)
 ##
 
-SYSTEMD:=$(DESTDIR)$(shell pkg-config systemd --variable=systemdsystemunitdir)
-TMPFILES:=$(DESTDIR)$(shell pkg-config systemd --variable=tmpfilesdir)
+SYSTEMD=$(DESTDIR)$(shell pkg-config systemd --variable=systemdsystemunitdir)
+TMPFILES=$(DESTDIR)$(shell pkg-config systemd --variable=tmpfilesdir)
 
-GNUTLS_CFLAGS:=$(shell pkg-config --cflags-only-I gnutls)
-GNUTLS_LIBS:=$(shell pkg-config --libs gnutls)
-AVAHI_CFLAGS:=$(shell pkg-config --cflags-only-I avahi-core)
-AVAHI_LIBS:=$(shell pkg-config --libs avahi-core)
-GPGME_CFLAGS:=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
-GPGME_LIBS:=$(shell gpgme-config --libs; getconf LFS_LIBS; \
+GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
+GNUTLS_LIBS=$(shell pkg-config --libs gnutls)
+AVAHI_CFLAGS=$(shell pkg-config --cflags-only-I avahi-core)
+AVAHI_LIBS=$(shell pkg-config --libs avahi-core)
+GPGME_CFLAGS=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
+GPGME_LIBS=$(shell gpgme-config --libs; getconf LFS_LIBS; \
 	getconf LFS_LDFLAGS)
-LIBNL3_CFLAGS:=$(shell pkg-config --cflags-only-I libnl-route-3.0)
-LIBNL3_LIBS:=$(shell pkg-config --libs libnl-route-3.0)
+LIBNL3_CFLAGS=$(shell pkg-config --cflags-only-I libnl-route-3.0)
+LIBNL3_LIBS=$(shell pkg-config --libs libnl-route-3.0)
 
 # Do not change these two
 CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(SANITIZE) $(COVERAGE) \
-	$(OPTIMIZE) $(LANGUAGE) -DVERSION='"$(version)"'
+	$(OPTIMIZE) $(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) \
+	$(GPGME_CFLAGS) -DVERSION='"$(version)"'
 LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
@@ -116,25 +117,25 @@
 	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
 	$<; $(HTMLPOST) $@)
 # Fix citerefentry links
-HTMLPOST:=$(SED) --in-place \
+HTMLPOST=$(SED) --in-place \
 	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'
 
-PLUGINS:=plugins.d/password-prompt plugins.d/mandos-client \
+PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
 	plugins.d/plymouth
-PLUGIN_HELPERS:=plugin-helpers/mandos-client-iprouteadddel
-CPROGS:=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
-PROGS:=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
-DOCS:=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
+PLUGIN_HELPERS=plugin-helpers/mandos-client-iprouteadddel
+CPROGS=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
+PROGS=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
+DOCS=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
 	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
 	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
 	plugins.d/plymouth.8mandos intro.8mandos
 
-htmldocs:=$(addsuffix .xhtml,$(DOCS))
+htmldocs=$(addsuffix .xhtml,$(DOCS))
 
-objects:=$(addsuffix .o,$(CPROGS))
+objects=$(addsuffix .o,$(CPROGS))
 
 all: $(PROGS) mandos.lsm
 
@@ -252,13 +253,8 @@
 		--expression='s/\(mandos_\)[0-9.]\+\(\.orig\.tar\.gz\)/\1$(version)\2/' \
 		$@)
 
-# Need to add the GnuTLS, Avahi and GPGME libraries, and can't use
-# -fsanitize=leak because GnuTLS and GPGME both leak memory.
 plugins.d/mandos-client: plugins.d/mandos-client.c
-	$(CC) $(filter-out -fsanitize=leak,$(CFLAGS)) $(strip\
-	) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) $(strip\
-		) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH) $^ $(strip\
-		) -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
+	$(LINK.c) $^ -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
 		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@
 
 plugin-helpers/mandos-client-iprouteadddel: plugin-helpers/mandos-client-iprouteadddel.c
@@ -284,7 +280,7 @@
 	./mandos-ctl --check
 
 # Run the client with a local config and key
-run-client: all keydir/seckey.txt keydir/pubkey.txt keydir/tls-privkey.pem keydir/tls-pubkey.pem
+run-client: all keydir/seckey.txt keydir/pubkey.txt
 	@echo "###################################################################"
 	@echo "# The following error messages are harmless and can be safely     #"
 	@echo "# ignored:                                                        #"
@@ -303,12 +299,12 @@
 	./plugin-runner --plugin-dir=plugins.d \
 		--plugin-helper-dir=plugin-helpers \
 		--config-file=plugin-runner.conf \
-		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--tls-privkey=keydir/tls-privkey.pem,--tls-pubkey=keydir/tls-pubkey.pem,--network-hook-dir=network-hooks.d \
+		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
 		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
 		$(CLIENTARGS)
 
 # Used by run-client
-keydir/seckey.txt keydir/pubkey.txt keydir/tls-privkey.pem keydir/tls-pubkey.pem: mandos-keygen
+keydir/seckey.txt keydir/pubkey.txt: mandos-keygen
 	install --directory keydir
 	./mandos-keygen --dir keydir --force
 
@@ -321,7 +317,7 @@
 confdir/mandos.conf: mandos.conf
 	install --directory confdir
 	install --mode=u=rw,go=r $^ $@
-confdir/clients.conf: clients.conf keydir/seckey.txt keydir/tls-pubkey.pem
+confdir/clients.conf: clients.conf keydir/seckey.txt
 	install --directory confdir
 	install --mode=u=rw $< $@
 # Add a client password
@@ -396,8 +392,6 @@
 		"$(CONFDIR)/network-hooks.d"
 	install --mode=u=rwx,go=rx \
 		--target-directory=$(LIBDIR)/mandos plugin-runner
-	install --mode=u=rwx,go=rx \
-		--target-directory=$(LIBDIR)/mandos mandos-to-cryptroot-unlock
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-keygen
 	install --mode=u=rwx,go=rx \
@@ -423,12 +417,10 @@
 		plugin-helpers/mandos-client-iprouteadddel
 	install initramfs-tools-hook \
 		$(INITRAMFSTOOLS)/hooks/mandos
-	install --mode=u=rw,go=r initramfs-tools-conf \
-		$(INITRAMFSTOOLS)/conf.d/mandos-conf
+	install --mode=u=rw,go=r initramfs-tools-hook-conf \
+		$(INITRAMFSTOOLS)/conf-hooks.d/mandos
 	install initramfs-tools-script \
 		$(INITRAMFSTOOLS)/scripts/init-premount/mandos
-	install initramfs-tools-script-stop \
-		$(INITRAMFSTOOLS)/scripts/local-premount/mandos
 	install --mode=u=rw,go=r plugin-runner.conf $(CONFDIR)
 	gzip --best --to-stdout mandos-keygen.8 \
 		> $(MANDIR)/man8/mandos-keygen.8.gz
@@ -508,8 +500,7 @@
 	-rmdir $(CONFDIR)
 
 purge-client: uninstall-client
-	-shred --remove $(KEYDIR)/seckey.txt $(KEYDIR)/tls-privkey.pem
+	-shred --remove $(KEYDIR)/seckey.txt
 	-rm --force $(CONFDIR)/plugin-runner.conf \
-		$(KEYDIR)/pubkey.txt $(KEYDIR)/seckey.txt \
-		$(KEYDIR)/tls-pubkey.txt $(KEYDIR)/tls-privkey.txt
+		$(KEYDIR)/pubkey.txt $(KEYDIR)/seckey.txt
 	-rmdir $(KEYDIR) $(CONFDIR)/plugins.d $(CONFDIR)

=== modified file 'NEWS'
--- NEWS	2019-02-11 06:31:42 +0000
+++ NEWS	2017-02-23 20:35:20 +0000
@@ -1,77 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.8.3 (2019-02-11)
-* No user-visible changes.
-
-Version 1.8.2 (2019-02-10)
-* Client
-** In mandos-keygen, ignore failures to remove files in some cases.
-
-Version 1.8.1 (2019-02-10)
-* Client
-** Only generate TLS keys using GnuTLS' certtool, of sufficient
-   version.  Key generation of TLS keys will not happen until a
-   version of GnuTLS is installed with support for raw public keys.
-** Remove any bad keys created by 1.8.0 and openssl.
-* Server
-** On installation, edit clients.conf and remove the same bad key ID
-   which was erroneously reported by all 1.8.0 clients.  Also do not
-   trust this key ID in the server.
-
-Version 1.8.0 (2019-02-10)
-* Client
-** Use new TLS keys for server communication and identification.
-   With GnuTLS 3.6 or later, OpenPGP keys are no longer supported.
-   The client can now use the new "raw public keys" (RFC 7250) API
-   instead, using GnuTLS 3.6.6.  Please note: This *requires* new key
-   IDs to be added to server's client.conf file.
-** New --tls-privkey and --tls-pubkey options to load TLS key files.
-   If GnuTLS is too old, these options do nothing.
-* Server
-** Supports either old or new GnuTLS.
-   The server now supports using GnuTLS 3.6.6 and clients connecting
-   with "raw public keys" as identification.  The server will read
-   both fingerprints and key IDs from clients.conf file, and will use
-   either one or the other, depending on what is supported by GnuTLS
-   on the system.  Please note: both are *not* supported at once; if
-   one type is supported by GnuTLS, all values of the other type from
-   clients.conf are ignored.
-
-Version 1.7.20 (2018-08-19)
-* Client
-** Fix: Adapt to the Debian cryptsetup package 2.0.3 or later.
-   Important: in that version or later, the plugins "askpass-fifo",
-   "password-prompt", and "plymouth" will no longer be run, since they
-   would conflict with what cryptsetup is doing.  Other plugins, such
-   as mandos-client and any user-supplied plugins, will still run.
-** Better error message if failing to decrypt secret data
-** Check for (and report) any key import failure from GPGME
-** Better error message if self-signature verification fails
-** Set system clock if not set; required by GnuPG for key import
-** When debugging plugin-runner, it will now show starting plugins
-
-Version 1.7.19 (2018-02-22)
-* Client
-** Do not print "unlink(...): No such file or directory".
-** Bug fixes: Fix file descriptor leaks.
-** Bug fix: Don't use leak sanitizer with leaking libraries.
-
-Version 1.7.18 (2018-02-12)
-* Client
-** Bug fix: Revert faulty fix for a nonexistent bug in the
-   plugin-runner
-
-Version 1.7.17 (2018-02-10)
-* Client
-** Bug fix: Fix a memory leak in the plugin-runner
-** Bug fix: Fix memory leaks in the plymouth plugin
-
-Version 1.7.16 (2017-08-20)
-* Client
-** Bug fix: ignore "resumedev" entries in initramfs' cryptroot file
-** Bug fix in plymouth plugin: fix memory leak, avoid warning output
-
 Version 1.7.15 (2017-02-23)
 * Server
 ** Bug fix: Respect the mandos.conf "zeroconf" and "restore" options

=== modified file 'TODO'
--- TODO	2019-02-13 08:45:09 +0000
+++ TODO	2017-02-22 21:45:35 +0000
@@ -14,7 +14,6 @@
 ** TODO [#C] Make start_mandos_communication() take "struct server".
 ** TODO [#C] --interfaces=regex,eth*,noregex (bridge-utils-interfaces(5))
 ** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
-** TODO [#B] Use reallocarray() with GNU LibC 2.29 or later.
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -34,7 +33,6 @@
 
 * plymouth
 ** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
-** TODO [#B] Use reallocarray() with GNU LibC 2.29 or later.
 
 * TODO [#B] passdev
 
@@ -121,5 +119,16 @@
 
 * [[http://www.undeadly.org/cgi?action=article&sid=20110530221728][OpenBSD]]
 
+* TODO Use raw public keys (RFC 7250) for TLS communications 		  :2:
+** Support for this is planned for GnuTLS version 3.6
+   https://gitlab.com/gnutls/gnutls/issues/26
+** Rationale
+*** The client key is used both for communication and encryption
+    Using raw keys in GnuTLS instead uses separate keys for
+    communication and password decryption.
+*** GnuTLS 3.5.9 has deprecated the OpenPGP functions
+    The functions are still available, but deprecated:
+    https://gitlab.com/gnutls/gnutls/issues/102
+
 
 #+STARTUP: showall

=== modified file 'clients.conf'
--- clients.conf	2019-02-09 23:34:15 +0000
+++ clients.conf	2012-06-23 00:58:49 +0000
@@ -38,9 +38,6 @@
 ;# Example client
 ;[foo]
 ;
-;# TLS public key ID
-;key_id = f33fcbed11ed5e03073f6a55b86ffe92af0e24c045fb6e3b40547b3dc0c030ed
-;
 ;# OpenPGP key fingerprint
 ;fingerprint =  7788 2722 5BA7 DE53 9C5A  7CFA 59CF F7CD BD9A 5920
 ;
@@ -71,14 +68,11 @@
 ;####
 ;# Another example client, named "bar".
 ;[bar]
-;# The key ID is not space or case sensitive
-;key_id = F33FCBED11ED5E03073F6A55B86FFE92 AF0E24C045FB6E3B40547B3DC0C030ED
-;
 ;# The fingerprint is not space or case sensitive
 ;fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
 ;
 ;# If "secret" is not specified, a file can be read for the data.
-;secfile = /etc/keys/mandos/bar-secret.bin
+;secfile = /etc/mandos/bar-secret.bin
 ;
 ;# An IP address for host is also fine, if the checker accepts it.
 ;host = 192.0.2.3

=== modified file 'common.ent'
--- common.ent	2019-02-11 06:31:42 +0000
+++ common.ent	2017-02-23 20:35:20 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.8.3">
+<!ENTITY version "1.7.15">

=== modified file 'debian/changelog'
--- debian/changelog	2019-02-11 11:52:07 +0000
+++ debian/changelog	2017-02-23 20:35:20 +0000
@@ -1,153 +1,3 @@
-mandos (1.8.3-2) unstable; urgency=medium
-
-  * debian/rules (override_dh_shlibdeps-arch): New; conditionally edit
-    debian/control before running dh_shlibdeps.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Mon, 11 Feb 2019 12:49:57 +0100
-
-mandos (1.8.3-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/watch: Make the ".orig" file name suffix non-optional;
-    otherwise uscan thinks that ".orig" is part of the version number.
-  * debian/control (Build-Depends): Changed GnuTLS dependencies; move
-    3.6.6 alternative to first in list, and remove dependencies on the
-    virtual package "gnutls-dev", since we need the version restrictions.
-    (Package: mandos/Depends): Remove dependency on libgnutls28-dev
-    package.
-    (Package: mandos/Suggests): New; set to "libc6-dev, c-compiler". (Used
-    to find value of "SO_BINDTODEVICE").
-    (Package: mandos-client/Depends): Don't depend on openssl anymore;
-    instead depend on either a gnutls-bin (>= 3.6.6) (in which case TLS
-    key generation will work), or on libgnutls30 (<< 3.6.0) (in which case
-    TLS key generation will not be needed).
-
- -- Teddy Hogeborn <teddy@recompile.se>  Mon, 11 Feb 2019 07:30:32 +0100
-
-mandos (1.8.2-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/mandos-client.postinst (create_keys): Ignore failure to remove
-                                                 bad keys.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 10 Feb 2019 11:44:56 +0100
-
-mandos (1.8.1-1) unstable; urgency=high
-
-  * New upstream release.
-  * debian/mandos-client.postinst (create_keys): Remove any bad keys
-    created by 1.8.0-1. Only create TLS keys if certtool succeeds.
-  * debian/mandos.postinst (configure): Remove any bad keys from
-    clients.conf, and inform the user if any were found.
-  * debian/mandos.templates (mandos/removed_bad_key_ids): New message.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 10 Feb 2019 10:00:21 +0100
-
-mandos (1.8.0-1) unstable; urgency=medium
-
-  * New upstream release.
-  * Fix "(tries to) use GnuTLS OpenPGP support" by using raw public keys
-    when available (Closes: #879538)
-  * Fix "mandos : Depends: libgnutls30 (< 3.6.0) but 3.6.5-2 is to be
-    installed" by now also allowing GnuTLS >= 3.6.6 (Closes: #916673)
-  * debian/control (Standards-Version): Update to "4.3.0".
-    (Package: mandos-client/Depends): Change from "cryptsetup" to
-    "cryptsetup (<< 2:2.0.3-1) | cryptsetup-initramfs".  Add "debconf (>=
-    1.5.5) | debconf-2.0".
-    (Source: mandos/Build-Depends): Also allow libgnutls30 (>= 3.6.6).
-    (Package: mandos/Depends): - '' - and add debconf (>= 1.5.5) |
-    debconf-2.0".
-    (Package: mandos/Description): Alter description to match new design.
-    (Package: mandos-client/Description): - '' -
-    (Package: mandos-client/Depends): Move "gnutls-bin | openssl" to here
-    from "Recommends".
-  * debian/mandos-client.README.Debian: Add --tls-privkey and --tls-pubkey
-    options to test command.
-  * debian/mandos-client.postinst (create_key): Renamed to "create_keys"
-    - all callers changed - and also create TLS key files.  Show notice if
-    new TLS key files were created.
-  * debian/mandos-client.postrm (purge): Also remove TLS key files.
-  * debian/mandos-client.lintian-overrides: Override warnings.
-  * debian/mandos-client.templates: New.
-  * debian/mandos.lintian-overrides: Override warnings.
-  * debian/mandos.postinst (configure): If GnuTLS 3.6.6 or later is
-    detected, show an important notice (once) about the new key_id option
-    required in clients.conf.
-  * debian/mandos.templates: New.
-  * debian/copyright: Update copyright year to 2019.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 10 Feb 2019 05:52:49 +0100
-
-mandos (1.7.20-1) unstable; urgency=medium
-
-  * New upstream release.
-  * Fix "[tethys] mandos-client: Mandos client fails while booting but
-    works from chroot into unpacked initramfs" by setting system clock if
-    necessary (Closes: #894495)
-  * Fix "initramfs boot script assumes internal cryptsetup implementation
-    details and is now broken" by only using documented
-    interfaces (Closes: #904899)
-  * debian/mandos-client.dirs: Add
-    "usr/share/initramfs-tools/scripts/local-premount" and
-    "usr/share/initramfs-tools/conf.d", and remove
-    "usr/share/initramfs-tools/conf-hooks.d".
-  * debian/control (mandos-client/Depends): Add "(>= 0.99)" to dependency
-    on "initramfs-tools".
-  * debian/control (Source: mandos/Rules-Requires-Root): New; set to
-    "binary-targets".
-    (Standards-Version): Update to "4.2.0".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 19 Aug 2018 22:14:04 +0200
-
-mandos (1.7.19-1) unstable; urgency=medium
-
-  * New upstream release.
-  * Fix "fails with "LeakSanitizer has encountered a fatal error"" by not
-    using LeakSanitizer in affected binary (Closes: #886595)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Thu, 22 Feb 2018 19:47:59 +0100
-
-mandos (1.7.18-1) unstable; urgency=medium
-
-  * New upstream release.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Mon, 12 Feb 2018 16:00:11 +0100
-
-mandos (1.7.17-1) unstable; urgency=medium
-
-  * New upstream release.
-  * Fix "fails with "LeakSanitizer has encountered a fatal error""
-    by fixing memory leak in plugin-runner (Closes: #886595)
-  * debian/control (Build-Depends): Also depend on "libgnutls28-dev (<<
-    3.6.0) | libgnutls30 (<< 3.6.0)".
-    (Package: mandos/Depends): - '' -
-  * debian/compat: Change to "10".
-  * debian/watch (version): Change to "4".
-    (opts/pgpsigurlmangle): Remove.
-    (opts/pgpmode): New; set to "auto".
-    (URL): Change to "https://ftp.recompile.se/pub/@PACKAGE@/@PACKAGE@
-    @ANY_VERSION@(?:\.orig)?@ARCHIVE_EXT@".
-  * debian/copyright: Update copyright year to 2018.
-  * debian/rules: Support the "noopt" and "parallel" DEB_BUILD_OPTIONS.
-    (override_dh_fixperms-arch): Use the DEB_HOST_MULTIARCH
-    variable directly instead of shelling out to "dpkg-architecture".
-  * debian/control (Standards-Version): Update to "4.1.3".
-    (Build-Depends): Change version of debhelper dependency to ">= 10".
-  * debian/mandos.lintian-overrides
-    (init.d-script-needs-depends-on-lsb-base): Change line number to "46".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sat, 10 Feb 2018 19:09:50 +0100
-
-mandos (1.7.16-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/copyright (License): Use program name explicitly.
-    (Format): Use https in URL.
-  * debian/control (Priority): Change from "extra" to "optional".
-    (Standards-Version): Update to "4.0.1".
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 20 Aug 2017 21:05:26 +0200
-
 mandos (1.7.15-1) unstable; urgency=medium
 
   * New upstream release.

=== modified file 'debian/compat'
--- debian/compat	2018-02-06 20:03:50 +0000
+++ debian/compat	2013-10-20 15:25:09 +0000
@@ -1,1 +1,1 @@
-10
+9

=== modified file 'debian/control'
--- debian/control	2019-02-11 06:14:29 +0000
+++ debian/control	2017-01-21 22:22:44 +0000
@@ -1,32 +1,27 @@
 Source: mandos
 Section: admin
-Priority: optional
+Priority: extra
 Maintainer: Mandos Maintainers <mandos@recompile.se>
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
-Build-Depends: debhelper (>= 10), docbook-xml, docbook-xsl,
+Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme-dev | libgpgme11-dev,
-	libgnutls28-dev (>= 3.3.0),
-	libgnutls28-dev (>= 3.6.6) | libgnutls28-dev (<< 3.6.0),
+	libgnutls28-dev (>= 3.3.0) | gnutls-dev (>= 3.3.0),
 	xsltproc, pkg-config, libnl-route-3-dev
 Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
 	python-dbus, python-gi
-Standards-Version: 4.3.0
+Standards-Version: 3.9.8
 Vcs-Bzr: https://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: https://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: https://www.recompile.se/mandos
-Rules-Requires-Root: binary-targets
 
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>= 2.7), python (<< 3),
-	libgnutls30 (>= 3.3.0),
-	libgnutls30 (>= 3.6.6) | libgnutls30 (<< 3.6.0),
+	libgnutls28-dev (>= 3.3.0) | libgnutls30 (>= 3.3.0),
 	python-dbus, python-gi, avahi-daemon, adduser, python-urwid,
-	gnupg2 | gnupg, systemd-sysv | lsb-base (>= 3.0-6),
-	debconf (>= 1.5.5) | debconf-2.0
+	gnupg2 | gnupg, systemd-sysv | lsb-base (>= 3.0-6)
 Recommends: ssh-client | fping
-Suggests: libc6-dev | libc-dev, c-compiler
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
@@ -35,21 +30,18 @@
  The computers run a small client program in the initial RAM
  disk environment which will communicate with a server over a
  network.  All network communication is encrypted using TLS.
- The clients are identified by the server using a TLS public
+ The clients are identified by the server using an OpenPGP
  key; each client has one unique to it.  The server sends the
  clients an encrypted password.  The encrypted password is
- decrypted by the clients using an OpenPGP key, and the
+ decrypted by the clients using the same OpenPGP key, and the
  password is then used to unlock the root file system,
  whereupon the computers can continue booting normally.
 
 Package: mandos-client
 Architecture: linux-any
-Depends: ${shlibs:Depends}, ${misc:Depends}, adduser,
-	cryptsetup (<< 2:2.0.3-1) | cryptsetup-initramfs,
-	initramfs-tools (>= 0.99), dpkg-dev (>=1.16.0),
-	gnutls-bin (>= 3.6.6) | libgnutls30 (<< 3.6.0),
-	debconf (>= 1.5.5) | debconf-2.0
-Recommends: ssh
+Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
+	initramfs-tools, dpkg-dev (>=1.16.0)
+Recommends: ssh, gnutls-bin | openssl
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
@@ -60,9 +52,9 @@
  The computers run a small client program in the initial RAM
  disk environment which will communicate with a server over a
  network.  All network communication is encrypted using TLS.
- The clients are identified by the server using a TLS public
+ The clients are identified by the server using an OpenPGP
  key; each client has one unique to it.  The server sends the
  clients an encrypted password.  The encrypted password is
- decrypted by the clients using an OpenPGP key, and the
+ decrypted by the clients using the same OpenPGP key, and the
  password is then used to unlock the root file system,
  whereupon the computers can continue booting normally.

=== modified file 'debian/copyright'
--- debian/copyright	2019-02-10 04:20:26 +0000
+++ debian/copyright	2017-02-23 19:11:11 +0000
@@ -1,26 +1,25 @@
-Format: https://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
+Format: http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
 Upstream-Name: Mandos
 Upstream-Contact: Mandos <mandos@recompile.se>
 Source: <https://www.recompile.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2019 Teddy Hogeborn
-	   Copyright © 2008-2019 Björn Påhlsson
+Copyright: Copyright © 2008-2017 Teddy Hogeborn
+	   Copyright © 2008-2017 Björn Påhlsson
 License: GPL-3+
-    This file is part of Mandos.
-    .
-    Mandos is free software: you can redistribute it and/or modify it
-    under the terms of the GNU General Public License as published by
-    the Free Software Foundation, either version 3 of the License, or
-    (at your option) any later version.
-    .
-    Mandos is distributed in the hope that it will be useful, but
-    WITHOUT ANY WARRANTY; without even the implied warranty of
+    This program is free software: you can redistribute it and/or
+    modify it under the terms of the GNU General Public License as
+    published by the Free Software Foundation, either version 3 of the
+    License, or (at your option) any later version.
+    .
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     General Public License for more details.
     .
     You should have received a copy of the GNU General Public License
-    along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+    along with this program.  If not, see
+    <http://www.gnu.org/licenses/>.
     .
     On Debian systems, the complete text of the GNU General Public
     License can be found in "/usr/share/common-licenses/GPL-3".

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2019-02-09 23:23:26 +0000
+++ debian/mandos-client.README.Debian	2016-06-21 19:47:08 +0000
@@ -25,9 +25,7 @@
 	/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH \
 	)/mandos/plugins.d/mandos-client \
 		--pubkey=/etc/keys/mandos/pubkey.txt \
-		--seckey=/etc/keys/mandos/seckey.txt \
-		--tls-privkey=/etc/keys/mandos/tls-privkey.pem \
-		--tls-pubkey=/etc/keys/mandos/tls-pubkey.pem; echo
+		--seckey=/etc/keys/mandos/seckey.txt; echo
   
   This command should retrieve the password from the server, decrypt
   it, and output it to standard output.  There it can be verified to
@@ -108,4 +106,4 @@
   policy or other reasons, simply replace the existing dhparams.pem
   file and update the initital RAM disk image.
 
- -- Teddy Hogeborn <teddy@recompile.se>, Sat,  9 Feb 2019 15:08:04 +0100
+ -- Teddy Hogeborn <teddy@recompile.se>, Tue, 21 Jun 2016 21:43:49 +0200

=== modified file 'debian/mandos-client.dirs'
--- debian/mandos-client.dirs	2018-08-19 14:32:00 +0000
+++ debian/mandos-client.dirs	2009-02-07 04:50:39 +0000
@@ -1,6 +1,5 @@
 usr/share/man/man8
 usr/sbin
 usr/share/initramfs-tools/hooks
-usr/share/initramfs-tools/conf.d
+usr/share/initramfs-tools/conf-hooks.d
 usr/share/initramfs-tools/scripts/init-premount
-usr/share/initramfs-tools/scripts/local-premount

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2019-02-10 03:50:20 +0000
+++ debian/mandos-client.lintian-overrides	2016-03-19 04:21:00 +0000
@@ -30,14 +30,3 @@
 mandos-client binary: non-standard-dir-perm etc/mandos/plugins.d/ 0700 != 0755
 # Likewise for plugin-helpers directory
 mandos-client binary: non-standard-dir-perm etc/mandos/plugin-helpers/ 0700 != 0755
-
-# The debconf templates is only used for displaying information
-# detected in the postinst, not for saving answers to questions, so we
-# don't need a .config file.
-mandos-client binary: no-debconf-config
-
-# The notice displayed from the postinst script really is critical
-mandos-client binary: postinst-uses-db-input
-
-# It is a really long line
-mandos-client binary: manpage-has-errors-from-man usr/share/man/man8/plugin-runner.8mandos.gz *: warning *: can't break line

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2019-02-10 10:39:26 +0000
+++ debian/mandos-client.postinst	2016-10-09 22:35:41 +0000
@@ -15,8 +15,6 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
-. /usr/share/debconf/confmodule
-
 set -e
 
 # Update the initial RAM file system image
@@ -52,79 +50,14 @@
     fi
 }
 
-# Create client key pairs
-create_keys(){
-    # If the OpenPGP key files do not exist, generate all keys using
-    # mandos-keygen
-    if ! [ -r /etc/keys/mandos/pubkey.txt \
-	      -a -r /etc/keys/mandos/seckey.txt ]; then
-	mandos-keygen
-	gpg-connect-agent KILLAGENT /bye || :
-	return 0
-    fi
-
-    # Remove any bad TLS keys by 1.8.0-1
-    if dpkg --compare-versions "$2" eq "1.8.0-1" \
-       || dpkg --compare-versions "$2" eq "1.8.0-1~bpo9+1"; then
-	# Is the key bad?
-	if ! certtool --password='' \
-	     --load-privkey=/etc/keys/mandos/tls-privkey.pem \
-	     --outfile=/dev/null --pubkey-info --no-text \
-	     2>/dev/null; then
-	    shred --remove -- /etc/keys/mandos/tls-privkey.pem \
-		  2>/dev/null || :
-	    rm --force -- /etc/keys/mandos/tls-pubkey.pem
-	fi
-    fi
-
-    # If the TLS keys already exists, do nothing
-    if [ -r /etc/keys/mandos/tls-privkey.pem \
-	    -a -r /etc/keys/mandos/tls-pubkey.pem ]; then
-	return 0
-    fi
-
-    # Try to create the TLS keys
-
-    TLS_PRIVKEYTMP="`mktemp -t mandos-client-privkey.XXXXXXXXXX`"
-
-    if certtool --generate-privkey --password='' \
-		--outfile "$TLS_PRIVKEYTMP" --sec-param ultra \
-		--key-type=ed25519 --pkcs8 --no-text 2>/dev/null; then
-
-	local umask=$(umask)
-	umask 077
-	cp --archive "$TLS_PRIVKEYTMP" /etc/keys/mandos/tls-privkey.pem
-	shred --remove -- "$TLS_PRIVKEYTMP" 2>/dev/null || :
-
-	# First try certtool from GnuTLS
-	if ! certtool --password='' \
-	     --load-privkey=/etc/keys/mandos/tls-privkey.pem \
-	     --outfile=/etc/keys/mandos/tls-pubkey.pem --pubkey-info \
-	     --no-text 2>/dev/null; then
-	    # Otherwise try OpenSSL
-	    if ! openssl pkey -in /etc/keys/mandos/tls-privkey.pem \
-		 -out /etc/keys/mandos/tls-pubkey.pem -pubout; then
-		rm --force /etc/keys/mandos/tls-pubkey.pem
-		# None of the commands succeded; give up
-		umask $umask
-		return 1
-	    fi
-	fi
-	umask $umask
-
-	key_id=$(mandos-keygen --passfile=/dev/null \
-		     | grep --regexp="^key_id[ =]")
-
-	db_version 2.0
-	db_fset mandos-client/key_id seen false
-	db_reset mandos-client/key_id
-	db_subst mandos-client/key_id key_id $key_id
-	db_input critical mandos-client/key_id || true
-	db_go
-	db_stop
-    else
-	shred --remove -- "$TLS_PRIVKEYTMP" 2>/dev/null || :
-    fi
+# Create client key pair
+create_key(){
+    if [ -r /etc/keys/mandos/pubkey.txt \
+	-a -r /etc/keys/mandos/seckey.txt ]; then
+	return 0
+    fi
+    mandos-keygen
+    gpg-connect-agent KILLAGENT /bye || :
 }
 
 create_dh_params(){
@@ -155,7 +88,7 @@
 case "$1" in
     configure)
 	add_mandos_user "$@"
-	create_keys "$@"
+	create_key "$@"
 	create_dh_params "$@" || :
 	update_initramfs "$@"
 	if dpkg --compare-versions "$2" lt-nl "1.7.10-1"; then

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2019-02-09 23:23:26 +0000
+++ debian/mandos-client.postrm	2015-07-27 09:23:56 +0000
@@ -44,8 +44,6 @@
 	rm --force /etc/mandos/plugin-runner.conf \
 	    /etc/keys/mandos/pubkey.txt \
 	    /etc/keys/mandos/seckey.txt \
-	    /etc/keys/mandos/tls-privkey.pem \
-	    /etc/keys/mandos/tls-pubkey.pem \
 	    /etc/keys/mandos/dhparams.pem 2>/dev/null
 	update_initramfs
 	;;

=== removed file 'debian/mandos-client.templates'
--- debian/mandos-client.templates	2019-02-10 03:50:20 +0000
+++ debian/mandos-client.templates	1970-01-01 00:00:00 +0000
@@ -1,10 +0,0 @@
-Template: mandos-client/key_id
-Type: note
-Description: New client option "${key_id}" is REQUIRED on server
- A new "key_id" client option is REQUIRED in the server's clients.conf file, otherwise this computer most likely will not reboot unattended.  This option:
- .
- ${key_id}
- .
- must be added (all on one line!) on the Mandos server host, in the file /etc/mandos/clients.conf, right before the "fingerprint" option for this Mandos client.  You must edit that file on that server and add this option.
- .
- With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS session keys.  A new TLS key pair has been generated and will be used as identification, but the key ID of the public key needs to be added to the server, since this will now be used to identify the client to the server.

=== modified file 'debian/mandos.lintian-overrides'
--- debian/mandos.lintian-overrides	2019-02-10 03:50:20 +0000
+++ debian/mandos.lintian-overrides	2017-02-21 18:23:54 +0000
@@ -2,12 +2,4 @@
 # it, so it must be kept unreadable for non-root users.
 #
 mandos binary: non-standard-file-perm etc/mandos/clients.conf 0600 != 0644
-mandos: init.d-script-needs-depends-on-lsb-base etc/init.d/mandos (line 46)
-
-# The debconf templates is only used for displaying information
-# detected in the postinst, not for saving answers to questions, so we
-# don't need a .config file.
-mandos binary: no-debconf-config
-
-# The notice displayed from the postinst script really is critical
-mandos binary: postinst-uses-db-input
+mandos: init.d-script-needs-depends-on-lsb-base etc/init.d/mandos (line 49)

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2019-02-10 08:41:14 +0000
+++ debian/mandos.postinst	2016-03-19 03:48:56 +0000
@@ -15,8 +15,6 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
-. /usr/share/debconf/confmodule
-
 set -e
 
 case "$1" in
@@ -55,33 +53,6 @@
 	    chown _mandos:_mandos /var/lib/mandos
 	    chmod u=rwx,go= /var/lib/mandos
 	fi
-
-	if dpkg --compare-versions "$2" eq "1.8.0-1" \
-		|| dpkg --compare-versions "$2" eq "1.8.0-1~bpo9+1"; then
-	    if grep --quiet --regexp='^[[:space:]]*key_id[[:space:]]*=[[:space:]]*[Ee]3[Bb]0[Cc]44298[Ff][Cc]1[Cc]149[Aa][Ff][Bb][Ff]4[Cc]8996[Ff][Bb]92427[Aa][Ee]41[Ee]4649[Bb]934[Cc][Aa]495991[Bb]7852[Bb]855[[:space:]]*$' /etc/mandos/clients.conf; then
-		sed --in-place \
-		    --expression='/^[[:space:]]*key_id[[:space:]]*=[[:space:]]*[Ee]3[Bb]0[Cc]44298[Ff][Cc]1[Cc]149[Aa][Ff][Bb][Ff]4[Cc]8996[Ff][Bb]92427[Aa][Ee]41[Ee]4649[Bb]934[Cc][Aa]495991[Bb]7852[Bb]855[[:space:]]*$/d' \
-		    /etc/mandos/clients.conf
-		invoke-rc.d mandos restart
-		db_version 2.0
-		db_fset mandos/removed_bad_key_ids seen false
-		db_reset mandos/removed_bad_key_ids
-		db_input critical mandos/removed_bad_key_ids || true
-		db_go
-		db_stop
-	    fi
-	fi
-
-	gnutls_version=$(dpkg-query --showformat='${Version}' \
-				    --show libgnutls30 \
-				    2>/dev/null || :)
-	if [ -n "$gnutls_version" ] \
-	       && dpkg --compare-versions $gnutls_version ge 3.6.6; then
-	    db_version 2.0
-	    db_input critical mandos/key_id || true
-	    db_go
-	    db_stop
-	fi
 	;;
     
     abort-upgrade|abort-deconfigure|abort-remove)

=== removed file 'debian/mandos.templates'
--- debian/mandos.templates	2019-02-10 08:41:14 +0000
+++ debian/mandos.templates	1970-01-01 00:00:00 +0000
@@ -1,19 +0,0 @@
-Template: mandos/key_id
-Type: note
-Description: New client option "key_id" is REQUIRED on server
- A new "key_id" client option is REQUIRED in the clients.conf file, otherwise the client most likely will not reboot unattended.  This option:
- .
- key_id = <HEXSTRING>
- .
- must be added in the file /etc/mandos/clients.conf, right before the "fingerprint" option, for each Mandos client.  You must edit that file and add this option for all clients.  To see the correct key ID for each client, run this command (on each client):
- .
- mandos-keygen -F/dev/null|grep ^key_id
- .
- Note: the client must all also be using GnuTLS 3.6.6 or later; the server cannot serve passwords for both old and new clients!
- .
- Rationale: With GnuTLS 3.6.6, Mandos has been forced to stop using OpenPGP keys as TLS session keys.  A new TLS key pair will be generated on each client and will be used as identification, but the key ID of the public key needs to be added to this server, since this will now be used to identify the client to the server.
-
-Template: mandos/removed_bad_key_ids
-Type: note
-Description: Bad key IDs have been removed from clients.conf
- Bad key IDs, which were reported by a bug in Mandos client 1.8.0, have been removed from /etc/mandos/clients.conf

=== modified file 'debian/rules'
--- debian/rules	2019-02-13 08:45:09 +0000
+++ debian/rules	2016-06-23 19:46:41 +0000
@@ -1,14 +1,4 @@
 #!/usr/bin/make -f
-
-ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
-    MAKEFLAGS += OPTIMIZE=-O0
-endif
-
-ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-    MAKEFLAGS += -j$(NUMJOBS)
-endif
-
 %:
 	dh $@
 
@@ -33,8 +23,8 @@
 	dh_fixperms --exclude etc/keys/mandos \
 		--exclude etc/mandos/plugins.d \
 		--exclude etc/mandos/plugin-helpers \
-		--exclude usr/lib/$(DEB_HOST_MULTIARCH)/mandos/plugins.d \
-		--exclude usr/lib/$(DEB_HOST_MULTIARCH)/mandos/plugin-helpers \
+		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugins.d \
+		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugin-helpers \
 		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
 	chmod --recursive g-w -- \
 	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"
@@ -43,19 +33,3 @@
 	dh_fixperms --exclude etc/mandos/clients.conf
 
 override_dh_auto_test-arch: ;
-
-#bpo## dpkg-shlibdeps sees the "libgnutls28-dev (>= 3.6.6) |
-#bpo## libgnutls28-dev (<< 3.6.0)," in the build-dependencies not as two
-#bpo## alternatives, but as an absolute dependency on libgnutls30 >= 3.6.6.
-#bpo## So we have to do this ugly hack to hide this build dependency if we
-#bpo## compiled with libgnutls30 << 3.6.0.
-#bpo#override_dh_shlibdeps-arch:
-#bpo#	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
-#bpo#		--show libgnutls30); \
-#bpo#	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
-#bpo#		&& { cp --archive debian/control debian/control.orig; sed --expression='s/libgnutls28-dev (>= 3\.6\.6) |//' debian/control; }
-#bpo#	dh_shlibdeps
-#bpo#	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
-#bpo#		--show libgnutls30); \
-#bpo#	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
-#bpo#		&& mv debian/control.orig debian/control

=== modified file 'debian/watch'
--- debian/watch	2019-02-11 05:15:24 +0000
+++ debian/watch	2014-02-16 02:42:42 +0000
@@ -1,3 +1,3 @@
-version=4
-opts=pgpmode=auto \
- https://ftp.recompile.se/pub/@PACKAGE@/@PACKAGE@@ANY_VERSION@\.orig@ARCHIVE_EXT@
+version=3
+opts=pgpsigurlmangle=s/$/.asc/ \
+ ftp://ftp.recompile.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)

=== modified file 'init.d-mandos'
--- init.d-mandos	2018-02-10 13:23:58 +0000
+++ init.d-mandos	2016-03-13 00:37:02 +0000
@@ -11,6 +11,9 @@
 
 # Author: Teddy Hogeborn <teddy@recompile.se>
 # Author: Björn Påhlsson <belorn@recompile.se>
+#
+# Please remove the "Author" lines above and replace them
+# with your own name if you copy and modify this script.
 
 # Do NOT "set -e"
 

=== removed file 'initramfs-tools-conf'
--- initramfs-tools-conf	2018-08-19 14:06:55 +0000
+++ initramfs-tools-conf	1970-01-01 00:00:00 +0000
@@ -1,17 +0,0 @@
-# -*- shell-script -*-
-
-# Since the initramfs image will contain key files, we need to
-# restrict permissions on it by setting UMASK here.
-# 
-# The proper place to set UMASK is (according to
-# /etc/cryptsetup-initramfs/conf-hook), in
-# /etc/initramfs-tools/initramfs.conf, which we shouldn't edit.  The
-# corresponding directory for drop-in files from packages is
-# /usr/share/initramfs-tools/conf.d, and this file will be installed
-# there as "mandos-conf".
-# 
-# This setting of UMASK will have unfortunate unintended side effects
-# on the files *inside* the initramfs, but these are later fixed by
-# "initramfs-tools-hook", installed as
-# "/usr/share/initramfs-tools/hooks/mandos".
-UMASK=0027

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2018-08-19 14:06:55 +0000
+++ initramfs-tools-hook	2017-02-21 22:15:43 +0000
@@ -80,8 +80,6 @@
 	--mode=u=rwx "${DESTDIR}${PLUGINDIR}" \
 	"${DESTDIR}${PLUGINHELPERDIR}"
 
-copy_exec "$libdir"/mandos/mandos-to-cryptroot-unlock "${MANDOSDIR}"
-
 # Copy the Mandos plugin runner
 copy_exec "$libdir"/mandos/plugin-runner "${MANDOSDIR}"
 
@@ -252,8 +250,8 @@
 # initrd; it is intended to affect the initrd.img file itself, since
 # it now contains secret key files.  There is, however, no other way
 # to set the permission of the initrd.img file without a race
-# condition.  This umask is set by "initramfs-tools-conf", installed
-# as "/usr/share/initramfs-tools/conf.d/mandos-conf".)
+# condition.  This umask is set by "initramfs-tools-hook-conf",
+# installed as "/usr/share/initramfs-tools/conf-hooks.d/mandos".)
 # 
 for full in "${MANDOSDIR}" "${CONFDIR}"; do
     while [ "$full" != "/" ]; do

=== added file 'initramfs-tools-hook-conf'
--- initramfs-tools-hook-conf	1970-01-01 00:00:00 +0000
+++ initramfs-tools-hook-conf	2009-05-17 00:50:09 +0000
@@ -0,0 +1,13 @@
+# -*- shell-script -*-
+
+# if mkinitramfs is started by mkinitramfs-kpkg, mkinitramfs-kpkg has
+# already touched the initrd file with umask 022 before we had a
+# chance to affect it.  We cannot allow a readable initrd file,
+# therefore we must fix this now.
+if [ -e "${outfile}" ] \
+    && [ `stat --format=%s "${outfile}"` -eq 0 ]; then
+    rm "${outfile}"
+    (umask 027; touch "${outfile}")
+fi
+
+UMASK=027

=== modified file 'initramfs-tools-script'
--- initramfs-tools-script	2018-08-19 01:35:11 +0000
+++ initramfs-tools-script	2017-02-21 21:42:08 +0000
@@ -51,6 +51,9 @@
 
 chmod a=rwxt /tmp
 
+test -r /conf/conf.d/cryptroot
+test -w /conf/conf.d
+
 # Get DEVICE from /conf/initramfs.conf and other files
 . /conf/initramfs.conf
 for conf in /conf/conf.d/*; do
@@ -102,80 +105,50 @@
     fi
 fi
 
-if [ -r /conf/conf.d/cryptroot ]; then
-    test -w /conf/conf.d
-
-    # Do not replace cryptroot file unless we need to.
-    replace_cryptroot=no
-
-    # Our keyscript
-    mandos=/lib/mandos/plugin-runner
-    test -x "$mandos"
-
-    # parse /conf/conf.d/cryptroot.  Format:
-    # target=sda2_crypt,source=/dev/sda2,rootdev,key=none,keyscript=/foo/bar/baz
-    # Is the root device specially marked?
-    changeall=yes
-    while read -r options; do
-	case "$options" in
-	    rootdev,*|*,rootdev,*|*,rootdev)
-		# If the root device is specially marked, don't change all
-		# lines in crypttab by default.
-		changeall=no
+# Do not replace cryptroot file unless we need to.
+replace_cryptroot=no
+
+# Our keyscript
+mandos=/lib/mandos/plugin-runner
+test -x "$mandos"
+
+# parse /conf/conf.d/cryptroot.  Format:
+# target=sda2_crypt,source=/dev/sda2,key=none,keyscript=/foo/bar/baz
+exec 3>/conf/conf.d/cryptroot.mandos
+while read -r options; do
+    newopts=""
+    # Split option line on commas
+    old_ifs="$IFS"
+    IFS="$IFS,"
+    for opt in $options; do
+	# Find the keyscript option, if any
+	case "$opt" in
+	    keyscript=*)
+		keyscript="${opt#keyscript=}"
+		newopts="$newopts,$opt"
+		;;
+	    "") : ;;
+	    *)
+		newopts="$newopts,$opt"
 		;;
 	esac
-    done < /conf/conf.d/cryptroot
-
-    exec 3>/conf/conf.d/cryptroot.mandos
-    while read -r options; do
-	newopts=""
-	keyscript=""
-	changethis="$changeall"
-	# Split option line on commas
-	old_ifs="$IFS"
-	IFS="$IFS,"
-	for opt in $options; do
-	    # Find the keyscript option, if any
-	    case "$opt" in
-		keyscript=*)
-		    keyscript="${opt#keyscript=}"
-		    newopts="$newopts,$opt"
-		    ;;
-		"") : ;;
-		# Always use Mandos on the root device, if marked
-		rootdev)
-		    changethis=yes
-		    newopts="$newopts,$opt"
-		    ;;
-		# Don't use Mandos on resume device, if marked
-		resumedev)
-		    changethis=no
-		    newopts="$newopts,$opt"
-		    ;;
-		*)
-		    newopts="$newopts,$opt"
-		    ;;
-	    esac
-	done
-	IFS="$old_ifs"
-	unset old_ifs
-	# If there was no keyscript option, add one.
-	if [ "$changethis" = yes ] && [ -z "$keyscript" ]; then
-	    replace_cryptroot=yes
-	    newopts="$newopts,keyscript=$mandos"
-	fi
-	newopts="${newopts#,}"
-	echo "$newopts" >&3
-    done < /conf/conf.d/cryptroot
-    exec 3>&-
-
-    # If we need to, replace the old cryptroot file with the new file.
-    if [ "$replace_cryptroot" = yes ]; then
-	mv /conf/conf.d/cryptroot /conf/conf.d/cryptroot.mandos-old
-	mv /conf/conf.d/cryptroot.mandos /conf/conf.d/cryptroot
-    else
-	rm -f /conf/conf.d/cryptroot.mandos
+    done
+    IFS="$old_ifs"
+    unset old_ifs
+    # If there was no keyscript option, add one.
+    if [ -z "$keyscript" ]; then
+	replace_cryptroot=yes
+	newopts="$newopts,keyscript=$mandos"
     fi
-elif [ -x /usr/bin/cryptroot-unlock ]; then
-    setsid /lib/mandos/mandos-to-cryptroot-unlock &
+    newopts="${newopts#,}"
+    echo "$newopts" >&3
+done < /conf/conf.d/cryptroot
+exec 3>&-
+
+# If we need to, replace the old cryptroot file with the new file.
+if [ "$replace_cryptroot" = yes ]; then
+    mv /conf/conf.d/cryptroot /conf/conf.d/cryptroot.mandos-old
+    mv /conf/conf.d/cryptroot.mandos /conf/conf.d/cryptroot
+else
+    rm /conf/conf.d/cryptroot.mandos
 fi

=== removed file 'initramfs-tools-script-stop'
--- initramfs-tools-script-stop	2018-08-19 14:58:40 +0000
+++ initramfs-tools-script-stop	1970-01-01 00:00:00 +0000
@@ -1,65 +0,0 @@
-#!/bin/sh -e
-# 
-# Script to wait for plugin-runner to exit before continuing boot
-# 
-# Copyright © 2018 Teddy Hogeborn
-# Copyright © 2018 Björn Påhlsson
-# 
-# This file is part of Mandos.
-# 
-# Mandos is free software: you can redistribute it and/or modify it
-# under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-# 
-#     Mandos is distributed in the hope that it will be useful, but
-#     WITHOUT ANY WARRANTY; without even the implied warranty of
-#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#     GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <mandos@recompile.se>.
-# 
-# This script will run in the initrd environment at boot and remove
-# the file keeping the dummy plugin running, forcing plugin-runner to
-# exit if it is still running.
-
-# This script should be installed as
-# "/usr/share/initramfs-tools/scripts/local-premount/mandos" which will
-# eventually be "/scripts/local-premount/mandos" in the initrd.img
-# file.
-
-PREREQ=""
-prereqs()
-{
-    echo "$PREREQ"
-}
-
-case $1 in
-prereqs)
-	prereqs
-	exit 0
-	;;
-esac
-
-. /scripts/functions
-
-pid=$(cat /run/mandos-plugin-runner.pid 2>/dev/null)
-
-# If the dummy plugin is running, removing this file should force the
-# dummy plugin to exit successfully, thereby making plugin-runner shut
-# down all its other plugins and then exit itself.
-rm -f /run/mandos-keep-running >/dev/null 2>&1
-
-# Wait for exit of plugin-runner, if still running
-if [ -n "$pid" ]; then
-    while :; do
-	case "$(readlink /proc/"$pid"/exe 2>/dev/null)" in
-	    */plugin-runner) sleep 1;;
-	    *) break;;
-	esac
-    done
-    rm -f /run/mandos-plugin-runner.pid >/dev/null 2>&1
-fi

=== modified file 'initramfs-unpack'
--- initramfs-unpack	2018-02-08 10:23:55 +0000
+++ initramfs-unpack	2013-10-13 15:43:42 +0000
@@ -2,23 +2,21 @@
 # 
 # Initramfs unpacker - unpacks initramfs images into /tmp
 # 
-# Copyright © 2013-2018 Teddy Hogeborn
-# Copyright © 2013-2018 Björn Påhlsson
+# Copyright © 2013 Teddy Hogeborn
+# Copyright © 2013 Björn Påhlsson
 # 
-# This file is part of Mandos.
-#
-# Mandos is free software: you can redistribute it and/or modify it
-# under the terms of the GNU General Public License as published by
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
-#     Mandos is distributed in the hope that it will be useful,
+#     This program is distributed in the hope that it will be useful,
 #     but WITHOUT ANY WARRANTY; without even the implied warranty of
 #     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #     GNU General Public License for more details.
-#
+# 
 # You should have received a copy of the GNU General Public License
-# along with Mandos.  If not, see
+# along with this program.  If not, see
 # <http://www.gnu.org/licenses/>.
 # 
 # Contact the authors at <mandos@recompile.se>.

=== modified file 'intro.xml'
--- intro.xml	2019-02-10 04:20:26 +0000
+++ intro.xml	2017-02-23 19:11:11 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -37,8 +37,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -68,10 +66,10 @@
       The computers run a small client program in the initial RAM disk
       environment which will communicate with a server over a network.
       All network communication is encrypted using TLS.  The clients
-      are identified by the server using a TLS public key; each client
+      are identified by the server using an OpenPGP key; each client
       has one unique to it.  The server sends the clients an encrypted
       password.  The encrypted password is decrypted by the clients
-      using a separate OpenPGP key, and the password is then used to
+      using the same OpenPGP key, and the password is then used to
       unlock the root file system, whereupon the computers can
       continue booting normally.
     </para>
@@ -201,8 +199,8 @@
       <para>
 	No.  The server only gives out the passwords to clients which
 	have <emphasis>in the TLS handshake</emphasis> proven that
-	they do indeed hold the private key corresponding to that
-	client.
+	they do indeed hold the OpenPGP private key corresponding to
+	that client.
       </para>
     </refsect2>
     

=== modified file 'legalnotice.xml'
--- legalnotice.xml	2017-08-20 16:20:54 +0000
+++ legalnotice.xml	2008-09-06 17:24:58 +0000
@@ -3,26 +3,25 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd">
 <legalnotice>
   <para>
-    This manual page is part of Mandos.
-  </para>
-  
-  <para>
-    Mandos is free software: you can redistribute it and/or modify it
-    under the terms of the <acronym>GNU</acronym> General Public
-    License as published by the Free Software Foundation, either
-    version 3 of the License, or (at your option) any later version.
-  </para>
-  
-  <para>
-    Mandos is distributed in the hope that it will be useful, but
-    WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    <acronym>GNU</acronym> General Public License for more details.
+    This manual page is free software: you can redistribute it and/or
+    modify it under the terms of the <acronym>GNU</acronym> General
+    Public License as published by the Free Software Foundation,
+    either version 3 of the License, or (at your option) any later
+    version.
+  </para>
+  
+  <para>
+    This manual page is distributed in the hope that it will be
+    useful, but WITHOUT ANY WARRANTY; without even the implied
+    warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+    See the <acronym>GNU</acronym> General Public License for more
+    details.
   </para>
   
   <para>
     You should have received a copy of the <acronym>GNU</acronym>
-    General Public License along with Mandos.  If not, see <ulink
+    General Public License along with this program.  If not, see
+    <ulink
     url="http://www.gnu.org/licenses/">http://www.gnu.org/licenses/</ulink>.
   </para>
 </legalnotice>

=== modified file 'mandos'
--- mandos	2019-02-11 06:31:42 +0000
+++ mandos	2017-02-23 20:35:20 +0000
@@ -11,23 +11,22 @@
 # "AvahiService" class, and some lines in "main".
 #
 # Everything else is
-# Copyright © 2008-2019 Teddy Hogeborn
-# Copyright © 2008-2019 Björn Påhlsson
-#
-# This file is part of Mandos.
-#
-# Mandos is free software: you can redistribute it and/or modify it
-# under the terms of the GNU General Public License as published by
+# Copyright © 2008-2017 Teddy Hogeborn
+# Copyright © 2008-2017 Björn Påhlsson
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
-#     Mandos is distributed in the hope that it will be useful, but
-#     WITHOUT ANY WARRANTY; without even the implied warranty of
+#     This program is distributed in the hope that it will be useful,
+#     but WITHOUT ANY WARRANTY; without even the implied warranty of
 #     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #     GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
-# along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+# along with this program.  If not, see
+# <http://www.gnu.org/licenses/>.
 #
 # Contact the authors at <mandos@recompile.se>.
 #
@@ -115,7 +114,7 @@
 if sys.version_info.major == 2:
     str = unicode
 
-version = "1.8.3"
+version = "1.7.15"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -496,7 +495,7 @@
 class AvahiServiceToSyslog(AvahiService):
     def rename(self, *args, **kwargs):
         """Add the new name to the syslog messages"""
-        ret = super(AvahiServiceToSyslog, self).rename(*args, **kwargs)
+        ret = AvahiService.rename(self, *args, **kwargs)
         syslogger.setFormatter(logging.Formatter(
             'Mandos ({}) [%(process)d]: %(levelname)s: %(message)s'
             .format(self.name)))
@@ -514,7 +513,6 @@
     _library = ctypes.cdll.LoadLibrary(library)
     del library
     _need_version = b"3.3.0"
-    _tls_rawpk_version = b"3.6.6"
 
     def __init__(self):
         # Need to use "self" here, since this method is called before
@@ -531,16 +529,10 @@
     E_INTERRUPTED = -52
     E_AGAIN = -28
     CRT_OPENPGP = 2
-    CRT_RAWPK = 3
     CLIENT = 2
     SHUT_RDWR = 0
     CRD_CERTIFICATE = 1
     E_NO_CERTIFICATE_FOUND = -49
-    X509_FMT_DER = 0
-    NO_TICKETS = 1<<10
-    ENABLE_RAWPK = 1<<18
-    CTYPE_PEERS = 3
-    KEYID_USE_SHA256 = 1        # gnutls/x509.h
     OPENPGP_FMT_RAW = 0         # gnutls/openpgp.h
 
     # Types
@@ -600,13 +592,7 @@
     class ClientSession(object):
         def __init__(self, socket, credentials=None):
             self._c_object = gnutls.session_t()
-            gnutls_flags = gnutls.CLIENT
-            if gnutls.check_version("3.5.6"):
-                gnutls_flags |= gnutls.NO_TICKETS
-            if gnutls.has_rawpk:
-                gnutls_flags |= gnutls.ENABLE_RAWPK
-            gnutls.init(ctypes.byref(self._c_object), gnutls_flags)
-            del gnutls_flags
+            gnutls.init(ctypes.byref(self._c_object), gnutls.CLIENT)
             gnutls.set_default_priority(self._c_object)
             gnutls.transport_set_ptr(self._c_object, socket.fileno())
             gnutls.handshake_set_private_extensions(self._c_object,
@@ -744,69 +730,34 @@
     check_version.argtypes = [ctypes.c_char_p]
     check_version.restype = ctypes.c_char_p
 
-    has_rawpk = bool(check_version(_tls_rawpk_version))
-
-    if has_rawpk:
-        # Types
-        class pubkey_st(ctypes.Structure):
-            _fields = []
-        pubkey_t = ctypes.POINTER(pubkey_st)
-
-        x509_crt_fmt_t = ctypes.c_int
-
-        # All the function declarations below are from gnutls/abstract.h
-        pubkey_init = _library.gnutls_pubkey_init
-        pubkey_init.argtypes = [ctypes.POINTER(pubkey_t)]
-        pubkey_init.restype = _error_code
-
-        pubkey_import = _library.gnutls_pubkey_import
-        pubkey_import.argtypes = [pubkey_t, ctypes.POINTER(datum_t),
-                                  x509_crt_fmt_t]
-        pubkey_import.restype = _error_code
-
-        pubkey_get_key_id = _library.gnutls_pubkey_get_key_id
-        pubkey_get_key_id.argtypes = [pubkey_t, ctypes.c_int,
-                                      ctypes.POINTER(ctypes.c_ubyte),
-                                      ctypes.POINTER(ctypes.c_size_t)]
-        pubkey_get_key_id.restype = _error_code
-
-        pubkey_deinit = _library.gnutls_pubkey_deinit
-        pubkey_deinit.argtypes = [pubkey_t]
-        pubkey_deinit.restype = None
-    else:
-        # All the function declarations below are from gnutls/openpgp.h
-
-        openpgp_crt_init = _library.gnutls_openpgp_crt_init
-        openpgp_crt_init.argtypes = [ctypes.POINTER(openpgp_crt_t)]
-        openpgp_crt_init.restype = _error_code
-
-        openpgp_crt_import = _library.gnutls_openpgp_crt_import
-        openpgp_crt_import.argtypes = [openpgp_crt_t,
-                                       ctypes.POINTER(datum_t),
-                                       openpgp_crt_fmt_t]
-        openpgp_crt_import.restype = _error_code
-
-        openpgp_crt_verify_self = _library.gnutls_openpgp_crt_verify_self
-        openpgp_crt_verify_self.argtypes = [openpgp_crt_t, ctypes.c_uint,
-                                            ctypes.POINTER(ctypes.c_uint)]
-        openpgp_crt_verify_self.restype = _error_code
-
-        openpgp_crt_deinit = _library.gnutls_openpgp_crt_deinit
-        openpgp_crt_deinit.argtypes = [openpgp_crt_t]
-        openpgp_crt_deinit.restype = None
-
-        openpgp_crt_get_fingerprint = (
-            _library.gnutls_openpgp_crt_get_fingerprint)
-        openpgp_crt_get_fingerprint.argtypes = [openpgp_crt_t,
-                                                ctypes.c_void_p,
-                                                ctypes.POINTER(
-                                                    ctypes.c_size_t)]
-        openpgp_crt_get_fingerprint.restype = _error_code
-
-    if check_version("3.6.4"):
-        certificate_type_get2 = _library.gnutls_certificate_type_get2
-        certificate_type_get2.argtypes = [session_t, ctypes.c_int]
-        certificate_type_get2.restype = _error_code
+    # All the function declarations below are from gnutls/openpgp.h
+
+    openpgp_crt_init = _library.gnutls_openpgp_crt_init
+    openpgp_crt_init.argtypes = [ctypes.POINTER(openpgp_crt_t)]
+    openpgp_crt_init.restype = _error_code
+
+    openpgp_crt_import = _library.gnutls_openpgp_crt_import
+    openpgp_crt_import.argtypes = [openpgp_crt_t,
+                                   ctypes.POINTER(datum_t),
+                                   openpgp_crt_fmt_t]
+    openpgp_crt_import.restype = _error_code
+
+    openpgp_crt_verify_self = _library.gnutls_openpgp_crt_verify_self
+    openpgp_crt_verify_self.argtypes = [openpgp_crt_t, ctypes.c_uint,
+                                        ctypes.POINTER(ctypes.c_uint)]
+    openpgp_crt_verify_self.restype = _error_code
+
+    openpgp_crt_deinit = _library.gnutls_openpgp_crt_deinit
+    openpgp_crt_deinit.argtypes = [openpgp_crt_t]
+    openpgp_crt_deinit.restype = None
+
+    openpgp_crt_get_fingerprint = (
+        _library.gnutls_openpgp_crt_get_fingerprint)
+    openpgp_crt_get_fingerprint.argtypes = [openpgp_crt_t,
+                                            ctypes.c_void_p,
+                                            ctypes.POINTER(
+                                                ctypes.c_size_t)]
+    openpgp_crt_get_fingerprint.restype = _error_code
 
     # Remove non-public functions
     del _error_code, _retry_on_error
@@ -848,9 +799,7 @@
     disable_initiator_tag: a GLib event source tag, or None
     enabled:    bool()
     fingerprint: string (40 or 32 hexadecimal digits); used to
-                 uniquely identify an OpenPGP client
-    key_id: string (64 hexadecimal digits); used to uniquely identify
-            a client using raw public keys
+                 uniquely identify the client
     host:       string; available for use by the checker command
     interval:   datetime.timedelta(); How often to start a new checker
     last_approval_request: datetime.datetime(); (UTC) or None
@@ -874,7 +823,7 @@
     """
 
     runtime_expansions = ("approval_delay", "approval_duration",
-                          "created", "enabled", "expires", "key_id",
+                          "created", "enabled", "expires",
                           "fingerprint", "host", "interval",
                           "last_approval_request", "last_checked_ok",
                           "last_enabled", "name", "timeout")
@@ -910,11 +859,9 @@
             client["enabled"] = config.getboolean(client_name,
                                                   "enabled")
 
-            # Uppercase and remove spaces from key_id and fingerprint
-            # for later comparison purposes with return value from the
-            # key_id() and fingerprint() functions
-            client["key_id"] = (section.get("key_id", "").upper()
-                                .replace(" ", ""))
+            # Uppercase and remove spaces from fingerprint for later
+            # comparison purposes with return value from the
+            # fingerprint() function
             client["fingerprint"] = (section["fingerprint"].upper()
                                      .replace(" ", ""))
             if "secret" in section:
@@ -964,7 +911,6 @@
             self.expires = None
 
         logger.debug("Creating client %r", self.name)
-        logger.debug("  Key ID: %s", self.key_id)
         logger.debug("  Fingerprint: %s", self.fingerprint)
         self.created = settings.get("created",
                                     datetime.datetime.utcnow())
@@ -2052,13 +1998,6 @@
     def Name_dbus_property(self):
         return dbus.String(self.name)
 
-    # KeyID - property
-    @dbus_annotations(
-        {"org.freedesktop.DBus.Property.EmitsChangedSignal": "const"})
-    @dbus_service_property(_interface, signature="s", access="read")
-    def KeyID_dbus_property(self):
-        return dbus.String(self.key_id)
-
     # Fingerprint - property
     @dbus_annotations(
         {"org.freedesktop.DBus.Property.EmitsChangedSignal": "const"})
@@ -2220,11 +2159,11 @@
 
 
 class ProxyClient(object):
-    def __init__(self, child_pipe, key_id, fpr, address):
+    def __init__(self, child_pipe, fpr, address):
         self._pipe = child_pipe
-        self._pipe.send(('init', key_id, fpr, address))
+        self._pipe.send(('init', fpr, address))
         if not self._pipe.recv():
-            raise KeyError(key_id or fpr)
+            raise KeyError(fpr)
 
     def __getattribute__(self, name):
         if name == '_pipe':
@@ -2297,28 +2236,16 @@
 
             approval_required = False
             try:
-                if gnutls.has_rawpk:
-                    fpr = ""
-                    try:
-                        key_id = self.key_id(
-                            self.peer_certificate(session))
-                    except (TypeError, gnutls.Error) as error:
-                        logger.warning("Bad certificate: %s", error)
-                        return
-                    logger.debug("Key ID: %s", key_id)
-
-                else:
-                    key_id = ""
-                    try:
-                        fpr = self.fingerprint(
-                            self.peer_certificate(session))
-                    except (TypeError, gnutls.Error) as error:
-                        logger.warning("Bad certificate: %s", error)
-                        return
-                    logger.debug("Fingerprint: %s", fpr)
-
-                try:
-                    client = ProxyClient(child_pipe, key_id, fpr,
+                try:
+                    fpr = self.fingerprint(
+                        self.peer_certificate(session))
+                except (TypeError, gnutls.Error) as error:
+                    logger.warning("Bad certificate: %s", error)
+                    return
+                logger.debug("Fingerprint: %s", fpr)
+
+                try:
+                    client = ProxyClient(child_pipe, fpr,
                                          self.client_address)
                 except KeyError:
                     return
@@ -2401,20 +2328,10 @@
 
     @staticmethod
     def peer_certificate(session):
-        "Return the peer's certificate as a bytestring"
-        try:
-            cert_type = gnutls.certificate_type_get2(session._c_object,
-                                                     gnutls.CTYPE_PEERS)
-        except AttributeError:
-            cert_type = gnutls.certificate_type_get(session._c_object)
-        if gnutls.has_rawpk:
-            valid_cert_types = frozenset((gnutls.CRT_RAWPK,))
-        else:
-            valid_cert_types = frozenset((gnutls.CRT_OPENPGP,))
-        # If not a valid certificate type...
-        if cert_type not in valid_cert_types:
-            logger.info("Cert type %r not in %r", cert_type,
-                        valid_cert_types)
+        "Return the peer's OpenPGP certificate as a bytestring"
+        # If not an OpenPGP certificate...
+        if (gnutls.certificate_type_get(session._c_object)
+            != gnutls.CRT_OPENPGP):
             # ...return invalid data
             return b""
         list_size = ctypes.c_uint(1)
@@ -2428,40 +2345,6 @@
         return ctypes.string_at(cert.data, cert.size)
 
     @staticmethod
-    def key_id(certificate):
-        "Convert a certificate bytestring to a hexdigit key ID"
-        # New GnuTLS "datum" with the public key
-        datum = gnutls.datum_t(
-            ctypes.cast(ctypes.c_char_p(certificate),
-                        ctypes.POINTER(ctypes.c_ubyte)),
-            ctypes.c_uint(len(certificate)))
-        # XXX all these need to be created in the gnutls "module"
-        # New empty GnuTLS certificate
-        pubkey = gnutls.pubkey_t()
-        gnutls.pubkey_init(ctypes.byref(pubkey))
-        # Import the raw public key into the certificate
-        gnutls.pubkey_import(pubkey,
-                             ctypes.byref(datum),
-                             gnutls.X509_FMT_DER)
-        # New buffer for the key ID
-        buf = ctypes.create_string_buffer(32)
-        buf_len = ctypes.c_size_t(len(buf))
-        # Get the key ID from the raw public key into the buffer
-        gnutls.pubkey_get_key_id(pubkey,
-                                 gnutls.KEYID_USE_SHA256,
-                                 ctypes.cast(ctypes.byref(buf),
-                                             ctypes.POINTER(ctypes.c_ubyte)),
-                                 ctypes.byref(buf_len))
-        # Deinit the certificate
-        gnutls.pubkey_deinit(pubkey)
-
-        # Convert the buffer to a Python bytestring
-        key_id = ctypes.string_at(buf, buf_len.value)
-        # Convert the bytestring to hexadecimal notation
-        hex_key_id = binascii.hexlify(key_id).upper()
-        return hex_key_id
-
-    @staticmethod
     def fingerprint(openpgp):
         "Convert an OpenPGP bytestring to a hexdigit fingerprint"
         # New GnuTLS "datum" with the OpenPGP public key
@@ -2481,8 +2364,7 @@
                                        ctypes.byref(crtverify))
         if crtverify.value != 0:
             gnutls.openpgp_crt_deinit(crt)
-            raise gnutls.CertificateSecurityError(code
-                                                  =crtverify.value)
+            raise gnutls.CertificateSecurityError("Verify failed")
         # New buffer for the fingerprint
         buf = ctypes.create_string_buffer(20)
         buf_len = ctypes.c_size_t()
@@ -2695,25 +2577,19 @@
         command = request[0]
 
         if command == 'init':
-            key_id = request[1].decode("ascii")
-            fpr = request[2].decode("ascii")
-            address = request[3]
+            fpr = request[1]
+            address = request[2]
 
             for c in self.clients.values():
-                if key_id == "E3B0C44298FC1C149AFBF4C8996FB92427AE41E4649B934CA495991B7852B855":
-                    continue
-                if key_id and c.key_id == key_id:
-                    client = c
-                    break
-                if fpr and c.fingerprint == fpr:
+                if c.fingerprint == fpr:
                     client = c
                     break
             else:
-                logger.info("Client not found for key ID: %s, address"
-                            ": %s", key_id or fpr, address)
+                logger.info("Client not found for fingerprint: %s, ad"
+                            "dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(key_id or fpr,
+                    mandos_dbus_service.ClientNotFound(fpr,
                                                        address[0])
                 parent_pipe.send(False)
                 return False
@@ -2982,17 +2858,13 @@
         sys.exit(os.EX_OK if fail_count == 0 else 1)
 
     # Default values for config file for server-global settings
-    if gnutls.has_rawpk:
-        priority = ("SECURE128:!CTYPE-X.509:+CTYPE-RAWPK:!RSA"
-                    ":!VERS-ALL:+VERS-TLS1.3:%PROFILE_ULTRA")
-    else:
-        priority = ("SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA"
-                    ":+SIGN-DSA-SHA256")
     server_defaults = {"interface": "",
                        "address": "",
                        "port": "",
                        "debug": "False",
-                       "priority": priority,
+                       "priority":
+                       "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA"
+                       ":+SIGN-DSA-SHA256",
                        "servicename": "Mandos",
                        "use_dbus": "True",
                        "use_ipv6": "True",
@@ -3003,7 +2875,6 @@
                        "foreground": "False",
                        "zeroconf": "True",
                        }
-    del priority
 
     # Parse config file for server-global settings
     server_config = configparser.SafeConfigParser(server_defaults)
@@ -3253,10 +3124,6 @@
                         for k in ("name", "host"):
                             if isinstance(value[k], bytes):
                                 value[k] = value[k].decode("utf-8")
-                        if not value.has_key("key_id"):
-                            value["key_id"] = ""
-                        elif not value.has_key("fingerprint"):
-                            value["fingerprint"] = ""
                     #  old_client_settings
                     # .keys()
                     old_client_settings = {
@@ -3399,7 +3266,7 @@
                 pass
 
             @dbus.service.signal(_interface, signature="ss")
-            def ClientNotFound(self, key_id, address):
+            def ClientNotFound(self, fingerprint, address):
                 "D-Bus signal"
                 pass
 

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2019-02-10 04:20:26 +0000
+++ mandos-clients.conf.xml	2017-02-23 19:11:11 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -42,8 +42,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -187,9 +185,9 @@
 	    >--</option> %%(host)s</literal></quote>.  Note that
 	    <command>mandos-keygen</command>, when generating output
 	    to be inserted into this file, normally looks for an SSH
-	    server on the Mandos client, and, if it finds one, outputs
+	    server on the Mandos client, and, if it find one, outputs
 	    a <option>checker</option> option to check for the
-	    client’s SSH key fingerprint – this is more secure against
+	    client’s key fingerprint – this is more secure against
 	    spoofing.
 	  </para>
 	  <para>
@@ -240,22 +238,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>key_id<literal> = </literal
-	><replaceable>HEXSTRING</replaceable></option></term>
-	<listitem>
-	  <para>
-	    This option is <emphasis>optional</emphasis>.
-	  </para>
-	  <para>
-	    This option sets the certificate key ID that identifies
-	    the public key that clients authenticate themselves with
-	    through TLS.  The string needs to be in hexadecimal form,
-	    but spaces or upper/lower case are not significant.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option><literal>host = </literal><replaceable
 	>STRING</replaceable></option></term>
 	<listitem>
@@ -331,9 +313,9 @@
 	  <para>
 	    If present, this option must be set to a string of
 	    base64-encoded binary data.  It will be decoded and sent
-	    to the client matching the above <option>key_id</option>
-	    or <option>fingerprint</option>.  This should, of course,
-	    be OpenPGP encrypted data, decryptable only by the client.
+	    to the client matching the above
+	    <option>fingerprint</option>.  This should, of course, be
+	    OpenPGP encrypted data, decryptable only by the client.
 	    The program <citerefentry><refentrytitle><command
 	    >mandos-keygen</command></refentrytitle><manvolnum
 	    >8</manvolnum></citerefentry> can, using its
@@ -434,7 +416,6 @@
 	<quote><literal>created</literal></quote>,
 	<quote><literal>enabled</literal></quote>,
 	<quote><literal>expires</literal></quote>,
-	<quote><literal>key_id</literal></quote>,
 	<quote><literal>fingerprint</literal></quote>,
 	<quote><literal>host</literal></quote>,
 	<quote><literal>interval</literal></quote>,
@@ -497,7 +478,6 @@
 
 # Client "foo"
 [foo]
-key_id = 788cd77115cd0bb7b2d5e0ae8496f6b48149d5e712c652076b1fd2d957ef7c1f
 fingerprint =  7788 2722 5BA7 DE53 9C5A  7CFA 59CF F7CD BD9A 5920
 secret =
         hQIOA6QdEjBs2L/HEAf/TCyrDe5Xnm9esa+Pb/vWF9CUqfn4srzVgSu234
@@ -520,7 +500,6 @@
 
 # Client "bar"
 [bar]
-key_id = F90C7A81D72D1EA69A51031A91FF8885F36C8B46D155C8C58709A4C99AE9E361
 fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
 secfile = /etc/mandos/bar-secret
 timeout = PT15M

=== modified file 'mandos-ctl'
--- mandos-ctl	2019-03-09 15:47:52 +0000
+++ mandos-ctl	2017-08-20 13:50:57 +0000
@@ -1,25 +1,24 @@
 #!/usr/bin/python
-# -*- mode: python; coding: utf-8; after-save-hook: (lambda () (let ((command (if (and (boundp 'tramp-file-name-structure) (string-match (car tramp-file-name-structure) (buffer-file-name))) (tramp-file-name-localname (tramp-dissect-file-name (buffer-file-name))) (buffer-file-name)))) (if (= (shell-command (format "%s --check" (shell-quote-argument command)) "*Test*") 0) (let ((w (get-buffer-window "*Test*"))) (if w (delete-window w)) (kill-buffer "*Test*")) (display-buffer "*Test*")))); -*-
+# -*- mode: python; coding: utf-8 -*-
 #
 # Mandos Monitor - Control and monitor the Mandos server
 #
-# Copyright © 2008-2019 Teddy Hogeborn
-# Copyright © 2008-2019 Björn Påhlsson
-#
-# This file is part of Mandos.
-#
-# Mandos is free software: you can redistribute it and/or modify it
-# under the terms of the GNU General Public License as published by
+# Copyright © 2008-2017 Teddy Hogeborn
+# Copyright © 2008-2017 Björn Påhlsson
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
-#     Mandos is distributed in the hope that it will be useful, but
-#     WITHOUT ANY WARRANTY; without even the implied warranty of
+#     This program is distributed in the hope that it will be useful,
+#     but WITHOUT ANY WARRANTY; without even the implied warranty of
 #     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #     GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
-# along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+# along with this program.  If not, see
+# <http://www.gnu.org/licenses/>.
 #
 # Contact the authors at <mandos@recompile.se>.
 #
@@ -40,36 +39,42 @@
 import os
 import collections
 import json
-import unittest
-import logging
-import io
-import tempfile
-import contextlib
 
 import dbus
 
-# Show warnings by default
-if not sys.warnoptions:
-    import warnings
-    warnings.simplefilter("default")
-
-log = logging.getLogger(sys.argv[0])
-logging.basicConfig(level="INFO", # Show info level messages
-                    format="%(message)s") # Show basic log messages
-
-logging.captureWarnings(True)   # Show warnings via the logging system
-
 if sys.version_info.major == 2:
     str = unicode
 
 locale.setlocale(locale.LC_ALL, "")
 
+tablewords = {
+    "Name": "Name",
+    "Enabled": "Enabled",
+    "Timeout": "Timeout",
+    "LastCheckedOK": "Last Successful Check",
+    "LastApprovalRequest": "Last Approval Request",
+    "Created": "Created",
+    "Interval": "Interval",
+    "Host": "Host",
+    "Fingerprint": "Fingerprint",
+    "CheckerRunning": "Check Is Running",
+    "LastEnabled": "Last Enabled",
+    "ApprovalPending": "Approval Is Pending",
+    "ApprovedByDefault": "Approved By Default",
+    "ApprovalDelay": "Approval Delay",
+    "ApprovalDuration": "Approval Duration",
+    "Checker": "Checker",
+    "ExtendedTimeout": "Extended Timeout",
+    "Expires": "Expires",
+    "LastCheckerStatus": "Last Checker Status",
+}
+defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
 domain = "se.recompile"
 busname = domain + ".Mandos"
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.8.3"
+version = "1.7.15"
 
 
 try:
@@ -96,8 +101,6 @@
     datetime.timedelta(0, 60)
     >>> rfc3339_duration_to_delta("PT60M")
     datetime.timedelta(0, 3600)
-    >>> rfc3339_duration_to_delta("P60M")
-    datetime.timedelta(1680)
     >>> rfc3339_duration_to_delta("PT24H")
     datetime.timedelta(1)
     >>> rfc3339_duration_to_delta("P1W")
@@ -106,35 +109,6 @@
     datetime.timedelta(0, 330)
     >>> rfc3339_duration_to_delta("P1DT3M20S")
     datetime.timedelta(1, 200)
-    >>> # Can not be empty:
-    >>> rfc3339_duration_to_delta("")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u''
-    >>> # Must start with "P":
-    >>> rfc3339_duration_to_delta("1D")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u'1D'
-    >>> # Must use correct order
-    >>> rfc3339_duration_to_delta("PT1S2M")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u'PT1S2M'
-    >>> # Time needs time marker
-    >>> rfc3339_duration_to_delta("P1H2S")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u'P1H2S'
-    >>> # Weeks can not be combined with anything else
-    >>> rfc3339_duration_to_delta("P1D2W")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u'P1D2W'
-    >>> rfc3339_duration_to_delta("P2W2H")
-    Traceback (most recent call last):
-    ...
-    ValueError: Invalid RFC 3339 duration: u'P2W2H'
     """
 
     # Parsing an RFC 3339 duration with regular expressions is not
@@ -218,39 +192,26 @@
 
 
 def string_to_delta(interval):
-    """Parse a string and return a datetime.timedelta"""
+    """Parse a string and return a datetime.timedelta
+
+    >>> string_to_delta('7d')
+    datetime.timedelta(7)
+    >>> string_to_delta('60s')
+    datetime.timedelta(0, 60)
+    >>> string_to_delta('60m')
+    datetime.timedelta(0, 3600)
+    >>> string_to_delta('24h')
+    datetime.timedelta(1)
+    >>> string_to_delta('1w')
+    datetime.timedelta(7)
+    >>> string_to_delta('5m 30s')
+    datetime.timedelta(0, 330)
+    """
 
     try:
         return rfc3339_duration_to_delta(interval)
-    except ValueError as e:
-        log.warning("%s - Parsing as pre-1.6.1 interval instead",
-                    ' '.join(e.args))
-    return parse_pre_1_6_1_interval(interval)
-
-
-def parse_pre_1_6_1_interval(interval):
-    """Parse an interval string as documented by Mandos before 1.6.1,
-    and return a datetime.timedelta
-
-    >>> parse_pre_1_6_1_interval('7d')
-    datetime.timedelta(7)
-    >>> parse_pre_1_6_1_interval('60s')
-    datetime.timedelta(0, 60)
-    >>> parse_pre_1_6_1_interval('60m')
-    datetime.timedelta(0, 3600)
-    >>> parse_pre_1_6_1_interval('24h')
-    datetime.timedelta(1)
-    >>> parse_pre_1_6_1_interval('1w')
-    datetime.timedelta(7)
-    >>> parse_pre_1_6_1_interval('5m 30s')
-    datetime.timedelta(0, 330)
-    >>> parse_pre_1_6_1_interval('')
-    datetime.timedelta(0)
-    >>> # Ignore unknown characters, allow any order and repetitions
-    >>> parse_pre_1_6_1_interval('2dxy7zz11y3m5m')
-    datetime.timedelta(2, 480, 18000)
-
-    """
+    except ValueError:
+        pass
 
     value = datetime.timedelta(0)
     regexp = re.compile(r"(\d+)([dsmhw]?)")
@@ -271,260 +232,53 @@
     return value
 
 
-## Classes for commands.
-
-# Abstract classes first
-class Command(object):
-    """Abstract class for commands"""
-    def run(self, mandos, mandos_objmgr, clients):
-        """Normal commands should implement run_on_one_client(), but
-        commands which want to operate on all clients at the same time
-        can override this run() method instead."""
-        self.mandos = mandos
-        for client, properties in clients.items():
-            self.run_on_one_client(client, properties)
-
-class PrintCmd(Command):
-    """Abstract class for commands printing client details"""
-    all_keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK",
-                    "Created", "Interval", "Host", "KeyID",
-                    "Fingerprint", "CheckerRunning", "LastEnabled",
-                    "ApprovalPending", "ApprovedByDefault",
-                    "LastApprovalRequest", "ApprovalDelay",
-                    "ApprovalDuration", "Checker", "ExtendedTimeout",
-                    "Expires", "LastCheckerStatus")
-    def run(self, mandos, mandos_objmgr, clients):
-        print(self.output(mandos_objmgr, clients.values()))
-
-class PropertyCmd(Command):
-    """Abstract class for Actions for setting one client property"""
-    def run_on_one_client(self, client, properties):
-        """Set the Client's D-Bus property"""
-        log.debug("D-Bus: %s:%s:%s.Set(%r, %r, %r)", busname,
-                  client.__dbus_object_path__,
-                  dbus.PROPERTIES_IFACE, client_interface,
-                  self.property, self.value_to_set
-                  if not isinstance(self.value_to_set, dbus.Boolean)
-                  else bool(self.value_to_set))
-        client.Set(client_interface, self.property, self.value_to_set,
-                   dbus_interface=dbus.PROPERTIES_IFACE)
-
-class ValueArgumentMixIn(object):
-    """Mixin class for commands taking a value as argument"""
-    def __init__(self, value):
-        self.value_to_set = value
-
-class MillisecondsValueArgumentMixIn(ValueArgumentMixIn):
-    """Mixin class for commands taking a value argument as
-    milliseconds."""
-    @property
-    def value_to_set(self):
-        return self._vts
-    @value_to_set.setter
-    def value_to_set(self, value):
-        """When setting, convert value to a datetime.timedelta"""
-        self._vts = int(round(value.total_seconds() * 1000))
-
-# Actual (non-abstract) command classes
-
-class PrintTableCmd(PrintCmd):
-    def __init__(self, verbose=False):
-        self.verbose = verbose
-
-    def output(self, mandos_objmgr, clients):
-        default_keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
-        keywords = default_keywords
-        if self.verbose:
-            keywords = self.all_keywords
-        return str(self.TableOfClients(clients, keywords))
-
-    class TableOfClients(object):
-        tableheaders = {
-            "Name": "Name",
-            "Enabled": "Enabled",
-            "Timeout": "Timeout",
-            "LastCheckedOK": "Last Successful Check",
-            "LastApprovalRequest": "Last Approval Request",
-            "Created": "Created",
-            "Interval": "Interval",
-            "Host": "Host",
-            "Fingerprint": "Fingerprint",
-            "KeyID": "Key ID",
-            "CheckerRunning": "Check Is Running",
-            "LastEnabled": "Last Enabled",
-            "ApprovalPending": "Approval Is Pending",
-            "ApprovedByDefault": "Approved By Default",
-            "ApprovalDelay": "Approval Delay",
-            "ApprovalDuration": "Approval Duration",
-            "Checker": "Checker",
-            "ExtendedTimeout": "Extended Timeout",
-            "Expires": "Expires",
-            "LastCheckerStatus": "Last Checker Status",
-        }
-
-        def __init__(self, clients, keywords, tableheaders=None):
-            self.clients = clients
-            self.keywords = keywords
-            if tableheaders is not None:
-                self.tableheaders = tableheaders
-
-        def __str__(self):
-            return "\n".join(self.rows())
-
-        if sys.version_info.major == 2:
-            __unicode__ = __str__
-            def __str__(self):
-                return str(self).encode(locale.getpreferredencoding())
-
-        def rows(self):
-            format_string = self.row_formatting_string()
-            rows = [self.header_line(format_string)]
-            rows.extend(self.client_line(client, format_string)
-                        for client in self.clients)
-            return rows
-
-        def row_formatting_string(self):
-            "Format string used to format table rows"
-            return " ".join("{{{key}:{width}}}".format(
-                width=max(len(self.tableheaders[key]),
-                          *(len(self.string_from_client(client, key))
-                            for client in self.clients)),
-                key=key)
-                            for key in self.keywords)
-
-        def string_from_client(self, client, key):
-            return self.valuetostring(client[key], key)
-
-        @staticmethod
-        def valuetostring(value, keyword):
-            if isinstance(value, dbus.Boolean):
-                return "Yes" if value else "No"
-            if keyword in ("Timeout", "Interval", "ApprovalDelay",
-                           "ApprovalDuration", "ExtendedTimeout"):
-                return milliseconds_to_string(value)
-            return str(value)
-
-        def header_line(self, format_string):
-            return format_string.format(**self.tableheaders)
-
-        def client_line(self, client, format_string):
-            return format_string.format(
-                **{key: self.string_from_client(client, key)
-                   for key in self.keywords})
-
-
-
-class DumpJSONCmd(PrintCmd):
-    def output(self, mandos_objmgr, clients):
-        data = {client["Name"]:
-                {key: self.dbus_boolean_to_bool(client[key])
-                 for key in self.all_keywords}
-                for client in clients.values()}
-        return json.dumps(data, indent=4, separators=(',', ': '))
-    @staticmethod
-    def dbus_boolean_to_bool(value):
-        if isinstance(value, dbus.Boolean):
-            value = bool(value)
-        return value
-
-class IsEnabledCmd(Command):
-    def run_on_one_client(self, client, properties):
-        if self.is_enabled(client, properties):
-            sys.exit(0)
-        sys.exit(1)
-    def is_enabled(self, client, properties):
-        log.debug("D-Bus: %s:%s:%s.Get(%r, %r)", busname,
-                  client.__dbus_object_path__,
-                  dbus.PROPERTIES_IFACE, client_interface,
-                  "Enabled")
-        return bool(client.Get(client_interface, "Enabled",
-                               dbus_interface=dbus.PROPERTIES_IFACE))
-
-class RemoveCmd(Command):
-    def run_on_one_client(self, client, properties):
-        log.debug("D-Bus: %s:%s:%s.RemoveClient(%r)", busname,
-                  server_path, server_interface,
-                  str(client.__dbus_object_path__))
-        self.mandos.RemoveClient(client.__dbus_object_path__)
-
-class ApproveCmd(Command):
-    def run_on_one_client(self, client, properties):
-        log.debug("D-Bus: %s:%s.Approve(True)",
-                  client.__dbus_object_path__, client_interface)
-        client.Approve(dbus.Boolean(True),
-                       dbus_interface=client_interface)
-
-class DenyCmd(Command):
-    def run_on_one_client(self, client, properties):
-        log.debug("D-Bus: %s:%s.Approve(False)",
-                  client.__dbus_object_path__, client_interface)
-        client.Approve(dbus.Boolean(False),
-                       dbus_interface=client_interface)
-
-class EnableCmd(PropertyCmd):
-    property = "Enabled"
-    value_to_set = dbus.Boolean(True)
-
-class DisableCmd(PropertyCmd):
-    property = "Enabled"
-    value_to_set = dbus.Boolean(False)
-
-class BumpTimeoutCmd(PropertyCmd):
-    property = "LastCheckedOK"
-    value_to_set = ""
-
-class StartCheckerCmd(PropertyCmd):
-    property = "CheckerRunning"
-    value_to_set = dbus.Boolean(True)
-
-class StopCheckerCmd(PropertyCmd):
-    property = "CheckerRunning"
-    value_to_set = dbus.Boolean(False)
-
-class ApproveByDefaultCmd(PropertyCmd):
-    property = "ApprovedByDefault"
-    value_to_set = dbus.Boolean(True)
-
-class DenyByDefaultCmd(PropertyCmd):
-    property = "ApprovedByDefault"
-    value_to_set = dbus.Boolean(False)
-
-class SetCheckerCmd(PropertyCmd, ValueArgumentMixIn):
-    property = "Checker"
-
-class SetHostCmd(PropertyCmd, ValueArgumentMixIn):
-    property = "Host"
-
-class SetSecretCmd(PropertyCmd, ValueArgumentMixIn):
-    @property
-    def value_to_set(self):
-        return self._vts
-    @value_to_set.setter
-    def value_to_set(self, value):
-        """When setting, read data from supplied file object"""
-        self._vts = value.read()
-        value.close()
-    property = "Secret"
-
-class SetTimeoutCmd(PropertyCmd, MillisecondsValueArgumentMixIn):
-    property = "Timeout"
-
-class SetExtendedTimeoutCmd(PropertyCmd,
-                            MillisecondsValueArgumentMixIn):
-    property = "ExtendedTimeout"
-
-class SetIntervalCmd(PropertyCmd, MillisecondsValueArgumentMixIn):
-    property = "Interval"
-
-class SetApprovalDelayCmd(PropertyCmd,
-                          MillisecondsValueArgumentMixIn):
-    property = "ApprovalDelay"
-
-class SetApprovalDurationCmd(PropertyCmd,
-                             MillisecondsValueArgumentMixIn):
-    property = "ApprovalDuration"
-
-def add_command_line_options(parser):
+def print_clients(clients, keywords):
+    def valuetostring(value, keyword):
+        if type(value) is dbus.Boolean:
+            return "Yes" if value else "No"
+        if keyword in ("Timeout", "Interval", "ApprovalDelay",
+                       "ApprovalDuration", "ExtendedTimeout"):
+            return milliseconds_to_string(value)
+        return str(value)
+
+    # Create format string to print table rows
+    format_string = " ".join("{{{key}:{width}}}".format(
+        width=max(len(tablewords[key]),
+                  max(len(valuetostring(client[key], key))
+                      for client in clients)),
+        key=key)
+                             for key in keywords)
+    # Print header line
+    print(format_string.format(**tablewords))
+    for client in clients:
+        print(format_string
+              .format(**{key: valuetostring(client[key], key)
+                         for key in keywords}))
+
+
+def has_actions(options):
+    return any((options.enable,
+                options.disable,
+                options.bump_timeout,
+                options.start_checker,
+                options.stop_checker,
+                options.is_enabled,
+                options.remove,
+                options.checker is not None,
+                options.timeout is not None,
+                options.extended_timeout is not None,
+                options.interval is not None,
+                options.approved_by_default is not None,
+                options.approval_delay is not None,
+                options.approval_duration is not None,
+                options.host is not None,
+                options.secret is not None,
+                options.approve,
+                options.deny))
+
+
+def main():
+    parser = argparse.ArgumentParser()
     parser.add_argument("--version", action="version",
                         version="%(prog)s {}".format(version),
                         help="show version number and exit")
@@ -534,160 +288,50 @@
                         help="Print all fields")
     parser.add_argument("-j", "--dump-json", action="store_true",
                         help="Dump client data in JSON format")
-    enable_disable = parser.add_mutually_exclusive_group()
-    enable_disable.add_argument("-e", "--enable", action="store_true",
-                                help="Enable client")
-    enable_disable.add_argument("-d", "--disable",
-                                action="store_true",
-                                help="disable client")
+    parser.add_argument("-e", "--enable", action="store_true",
+                        help="Enable client")
+    parser.add_argument("-d", "--disable", action="store_true",
+                        help="disable client")
     parser.add_argument("-b", "--bump-timeout", action="store_true",
                         help="Bump timeout for client")
-    start_stop_checker = parser.add_mutually_exclusive_group()
-    start_stop_checker.add_argument("--start-checker",
-                                    action="store_true",
-                                    help="Start checker for client")
-    start_stop_checker.add_argument("--stop-checker",
-                                    action="store_true",
-                                    help="Stop checker for client")
+    parser.add_argument("--start-checker", action="store_true",
+                        help="Start checker for client")
+    parser.add_argument("--stop-checker", action="store_true",
+                        help="Stop checker for client")
     parser.add_argument("-V", "--is-enabled", action="store_true",
                         help="Check if client is enabled")
     parser.add_argument("-r", "--remove", action="store_true",
                         help="Remove client")
     parser.add_argument("-c", "--checker",
                         help="Set checker command for client")
-    parser.add_argument("-t", "--timeout", type=string_to_delta,
+    parser.add_argument("-t", "--timeout",
                         help="Set timeout for client")
-    parser.add_argument("--extended-timeout", type=string_to_delta,
+    parser.add_argument("--extended-timeout",
                         help="Set extended timeout for client")
-    parser.add_argument("-i", "--interval", type=string_to_delta,
+    parser.add_argument("-i", "--interval",
                         help="Set checker interval for client")
-    approve_deny_default = parser.add_mutually_exclusive_group()
-    approve_deny_default.add_argument(
-        "--approve-by-default", action="store_true",
-        default=None, dest="approved_by_default",
-        help="Set client to be approved by default")
-    approve_deny_default.add_argument(
-        "--deny-by-default", action="store_false",
-        dest="approved_by_default",
-        help="Set client to be denied by default")
-    parser.add_argument("--approval-delay", type=string_to_delta,
+    parser.add_argument("--approve-by-default", action="store_true",
+                        default=None, dest="approved_by_default",
+                        help="Set client to be approved by default")
+    parser.add_argument("--deny-by-default", action="store_false",
+                        dest="approved_by_default",
+                        help="Set client to be denied by default")
+    parser.add_argument("--approval-delay",
                         help="Set delay before client approve/deny")
-    parser.add_argument("--approval-duration", type=string_to_delta,
+    parser.add_argument("--approval-duration",
                         help="Set duration of one client approval")
     parser.add_argument("-H", "--host", help="Set host for client")
     parser.add_argument("-s", "--secret",
                         type=argparse.FileType(mode="rb"),
                         help="Set password blob (file) for client")
-    approve_deny = parser.add_mutually_exclusive_group()
-    approve_deny.add_argument(
-        "-A", "--approve", action="store_true",
-        help="Approve any current client request")
-    approve_deny.add_argument("-D", "--deny", action="store_true",
-                              help="Deny any current client request")
-    parser.add_argument("--debug", action="store_true",
-                        help="Debug mode (show D-Bus commands)")
+    parser.add_argument("-A", "--approve", action="store_true",
+                        help="Approve any current client request")
+    parser.add_argument("-D", "--deny", action="store_true",
+                        help="Deny any current client request")
     parser.add_argument("--check", action="store_true",
                         help="Run self-test")
     parser.add_argument("client", nargs="*", help="Client name")
-
-
-def commands_from_options(options):
-
-    commands = []
-
-    if options.dump_json:
-        commands.append(DumpJSONCmd())
-
-    if options.enable:
-        commands.append(EnableCmd())
-
-    if options.disable:
-        commands.append(DisableCmd())
-
-    if options.bump_timeout:
-        commands.append(BumpTimeoutCmd())
-
-    if options.start_checker:
-        commands.append(StartCheckerCmd())
-
-    if options.stop_checker:
-        commands.append(StopCheckerCmd())
-
-    if options.is_enabled:
-        commands.append(IsEnabledCmd())
-
-    if options.checker is not None:
-        commands.append(SetCheckerCmd(options.checker))
-
-    if options.timeout is not None:
-        commands.append(SetTimeoutCmd(options.timeout))
-
-    if options.extended_timeout:
-        commands.append(
-            SetExtendedTimeoutCmd(options.extended_timeout))
-
-    if options.interval is not None:
-        commands.append(SetIntervalCmd(options.interval))
-
-    if options.approved_by_default is not None:
-        if options.approved_by_default:
-            commands.append(ApproveByDefaultCmd())
-        else:
-            commands.append(DenyByDefaultCmd())
-
-    if options.approval_delay is not None:
-        commands.append(SetApprovalDelayCmd(options.approval_delay))
-
-    if options.approval_duration is not None:
-        commands.append(
-            SetApprovalDurationCmd(options.approval_duration))
-
-    if options.host is not None:
-        commands.append(SetHostCmd(options.host))
-
-    if options.secret is not None:
-        commands.append(SetSecretCmd(options.secret))
-
-    if options.approve:
-        commands.append(ApproveCmd())
-
-    if options.deny:
-        commands.append(DenyCmd())
-
-    if options.remove:
-        commands.append(RemoveCmd())
-
-    # If no command option has been given, show table of clients,
-    # optionally verbosely
-    if not commands:
-        commands.append(PrintTableCmd(verbose=options.verbose))
-
-    return commands
-
-
-def check_option_syntax(parser, options):
-    """Apply additional restrictions on options, not expressible in
-argparse"""
-
-    def has_actions(options):
-        return any((options.enable,
-                    options.disable,
-                    options.bump_timeout,
-                    options.start_checker,
-                    options.stop_checker,
-                    options.is_enabled,
-                    options.remove,
-                    options.checker is not None,
-                    options.timeout is not None,
-                    options.extended_timeout is not None,
-                    options.interval is not None,
-                    options.approved_by_default is not None,
-                    options.approval_delay is not None,
-                    options.approval_duration is not None,
-                    options.host is not None,
-                    options.secret is not None,
-                    options.approve,
-                    options.deny))
+    options = parser.parse_args()
 
     if has_actions(options) and not (options.client or options.all):
         parser.error("Options require clients names or --all.")
@@ -698,36 +342,17 @@
         parser.error("--dump-json can only be used alone.")
     if options.all and not has_actions(options):
         parser.error("--all requires an action.")
-    if options.is_enabled and len(options.client) > 1:
-        parser.error("--is-enabled requires exactly one client")
-    if options.remove:
-        options.remove = False
-        if has_actions(options) and not options.deny:
-            parser.error("--remove can only be combined with --deny")
-        options.remove = True
-
-
-def main():
-    parser = argparse.ArgumentParser()
-
-    add_command_line_options(parser)
-
-    options = parser.parse_args()
-
-    check_option_syntax(parser, options)
-
-    clientnames = options.client
-
-    if options.debug:
-        log.setLevel(logging.DEBUG)
+
+    if options.check:
+        import doctest
+        fail_count, test_count = doctest.testmod()
+        sys.exit(os.EX_OK if fail_count == 0 else 1)
 
     try:
         bus = dbus.SystemBus()
-        log.debug("D-Bus: Connect to: (name=%r, path=%r)", busname,
-                  server_path)
         mandos_dbus_objc = bus.get_object(busname, server_path)
     except dbus.exceptions.DBusException:
-        log.critical("Could not connect to Mandos server")
+        print("Could not connect to Mandos server", file=sys.stderr)
         sys.exit(1)
 
     mandos_serv = dbus.Interface(mandos_dbus_objc,
@@ -735,806 +360,137 @@
     mandos_serv_object_manager = dbus.Interface(
         mandos_dbus_objc, dbus_interface=dbus.OBJECT_MANAGER_IFACE)
 
-    # Filter out log message from dbus module
-    dbus_logger = logging.getLogger("dbus.proxies")
-    class NullFilter(logging.Filter):
-        def filter(self, record):
-            return False
-    dbus_filter = NullFilter()
+    # block stderr since dbus library prints to stderr
+    null = os.open(os.path.devnull, os.O_RDWR)
+    stderrcopy = os.dup(sys.stderr.fileno())
+    os.dup2(null, sys.stderr.fileno())
+    os.close(null)
     try:
-        dbus_logger.addFilter(dbus_filter)
-        log.debug("D-Bus: %s:%s:%s.GetManagedObjects()", busname,
-                  server_path, dbus.OBJECT_MANAGER_IFACE)
-        mandos_clients = {path: ifs_and_props[client_interface]
-                          for path, ifs_and_props in
-                          mandos_serv_object_manager
-                          .GetManagedObjects().items()
-                          if client_interface in ifs_and_props}
+        try:
+            mandos_clients = {path: ifs_and_props[client_interface]
+                              for path, ifs_and_props in
+                              mandos_serv_object_manager
+                              .GetManagedObjects().items()
+                              if client_interface in ifs_and_props}
+        finally:
+            # restore stderr
+            os.dup2(stderrcopy, sys.stderr.fileno())
+            os.close(stderrcopy)
     except dbus.exceptions.DBusException as e:
-        log.critical("Failed to access Mandos server through D-Bus:"
-                     "\n%s", e)
+        print("Access denied: "
+              "Accessing mandos server through D-Bus: {}".format(e),
+              file=sys.stderr)
         sys.exit(1)
-    finally:
-        # restore dbus logger
-        dbus_logger.removeFilter(dbus_filter)
 
     # Compile dict of (clients: properties) to process
     clients = {}
 
-    if not clientnames:
+    if options.all or not options.client:
         clients = {bus.get_object(busname, path): properties
                    for path, properties in mandos_clients.items()}
     else:
-        for name in clientnames:
+        for name in options.client:
             for path, client in mandos_clients.items():
                 if client["Name"] == name:
                     client_objc = bus.get_object(busname, path)
                     clients[client_objc] = client
                     break
             else:
-                log.critical("Client not found on server: %r", name)
+                print("Client not found on server: {!r}"
+                      .format(name), file=sys.stderr)
                 sys.exit(1)
 
-    # Run all commands on clients
-    commands = commands_from_options(options)
-    for command in commands:
-        command.run(mandos_serv, mandos_serv_object_manager, clients)
-
-
-class Test_milliseconds_to_string(unittest.TestCase):
-    def test_all(self):
-        self.assertEqual(milliseconds_to_string(93785000),
-                         "1T02:03:05")
-    def test_no_days(self):
-        self.assertEqual(milliseconds_to_string(7385000), "02:03:05")
-    def test_all_zero(self):
-        self.assertEqual(milliseconds_to_string(0), "00:00:00")
-    def test_no_fractional_seconds(self):
-        self.assertEqual(milliseconds_to_string(400), "00:00:00")
-        self.assertEqual(milliseconds_to_string(900), "00:00:00")
-        self.assertEqual(milliseconds_to_string(1900), "00:00:01")
-
-class Test_string_to_delta(unittest.TestCase):
-    def test_handles_basic_rfc3339(self):
-        self.assertEqual(string_to_delta("PT0S"),
-                         datetime.timedelta())
-        self.assertEqual(string_to_delta("P0D"),
-                         datetime.timedelta())
-        self.assertEqual(string_to_delta("PT1S"),
-                         datetime.timedelta(0, 1))
-        self.assertEqual(string_to_delta("PT2H"),
-                         datetime.timedelta(0, 7200))
-    def test_falls_back_to_pre_1_6_1_with_warning(self):
-        # assertLogs only exists in Python 3.4
-        if hasattr(self, "assertLogs"):
-            with self.assertLogs(log, logging.WARNING):
-                value = string_to_delta("2h")
-        else:
-            class WarningFilter(logging.Filter):
-                """Don't show, but record the presence of, warnings"""
-                def filter(self, record):
-                    is_warning = record.levelno >= logging.WARNING
-                    self.found = is_warning or getattr(self, "found",
-                                                       False)
-                    return not is_warning
-            warning_filter = WarningFilter()
-            log.addFilter(warning_filter)
-            try:
-                value = string_to_delta("2h")
-            finally:
-                log.removeFilter(warning_filter)
-            self.assertTrue(getattr(warning_filter, "found", False))
-        self.assertEqual(value, datetime.timedelta(0, 7200))
-
-
-class TestCmd(unittest.TestCase):
-    """Abstract class for tests of command classes"""
-    def setUp(self):
-        testcase = self
-        class MockClient(object):
-            def __init__(self, name, **attributes):
-                self.__dbus_object_path__ = "objpath_{}".format(name)
-                self.attributes = attributes
-                self.attributes["Name"] = name
-                self.calls = []
-            def Set(self, interface, property, value, dbus_interface):
-                testcase.assertEqual(interface, client_interface)
-                testcase.assertEqual(dbus_interface,
-                                     dbus.PROPERTIES_IFACE)
-                self.attributes[property] = value
-            def Get(self, interface, property, dbus_interface):
-                testcase.assertEqual(interface, client_interface)
-                testcase.assertEqual(dbus_interface,
-                                     dbus.PROPERTIES_IFACE)
-                return self.attributes[property]
-            def Approve(self, approve, dbus_interface):
-                testcase.assertEqual(dbus_interface, client_interface)
-                self.calls.append(("Approve", (approve,
-                                               dbus_interface)))
-        self.client = MockClient(
-            "foo",
-            KeyID=("92ed150794387c03ce684574b1139a65"
-                   "94a34f895daaaf09fd8ea90a27cddb12"),
-            Secret=b"secret",
-            Host="foo.example.org",
-            Enabled=dbus.Boolean(True),
-            Timeout=300000,
-            LastCheckedOK="2019-02-03T00:00:00",
-            Created="2019-01-02T00:00:00",
-            Interval=120000,
-            Fingerprint=("778827225BA7DE539C5A"
-                         "7CFA59CFF7CDBD9A5920"),
-            CheckerRunning=dbus.Boolean(False),
-            LastEnabled="2019-01-03T00:00:00",
-            ApprovalPending=dbus.Boolean(False),
-            ApprovedByDefault=dbus.Boolean(True),
-            LastApprovalRequest="",
-            ApprovalDelay=0,
-            ApprovalDuration=1000,
-            Checker="fping -q -- %(host)s",
-            ExtendedTimeout=900000,
-            Expires="2019-02-04T00:00:00",
-            LastCheckerStatus=0)
-        self.other_client = MockClient(
-            "barbar",
-            KeyID=("0558568eedd67d622f5c83b35a115f79"
-                   "6ab612cff5ad227247e46c2b020f441c"),
-            Secret=b"secretbar",
-            Host="192.0.2.3",
-            Enabled=dbus.Boolean(True),
-            Timeout=300000,
-            LastCheckedOK="2019-02-04T00:00:00",
-            Created="2019-01-03T00:00:00",
-            Interval=120000,
-            Fingerprint=("3E393AEAEFB84C7E89E2"
-                         "F547B3A107558FCA3A27"),
-            CheckerRunning=dbus.Boolean(True),
-            LastEnabled="2019-01-04T00:00:00",
-            ApprovalPending=dbus.Boolean(False),
-            ApprovedByDefault=dbus.Boolean(False),
-            LastApprovalRequest="2019-01-03T00:00:00",
-            ApprovalDelay=30000,
-            ApprovalDuration=1000,
-            Checker=":",
-            ExtendedTimeout=900000,
-            Expires="2019-02-05T00:00:00",
-            LastCheckerStatus=-2)
-        self.clients =  collections.OrderedDict(
-            [
-                (self.client, self.client.attributes),
-                (self.other_client, self.other_client.attributes),
-            ])
-        self.one_client = {self.client: self.client.attributes}
-
-class TestPrintTableCmd(TestCmd):
-    def test_normal(self):
-        output = PrintTableCmd().output(None, self.clients.values())
-        expected_output = """
-Name   Enabled Timeout  Last Successful Check
-foo    Yes     00:05:00 2019-02-03T00:00:00  
-barbar Yes     00:05:00 2019-02-04T00:00:00  
-"""[1:-1]
-        self.assertEqual(output, expected_output)
-    def test_verbose(self):
-        output = PrintTableCmd(verbose=True).output(
-            None, self.clients.values())
-        expected_output = """
-Name   Enabled Timeout  Last Successful Check Created             Interval Host            Key ID                                                           Fingerprint                              Check Is Running Last Enabled        Approval Is Pending Approved By Default Last Approval Request Approval Delay Approval Duration Checker              Extended Timeout Expires             Last Checker Status
-foo    Yes     00:05:00 2019-02-03T00:00:00   2019-01-02T00:00:00 00:02:00 foo.example.org 92ed150794387c03ce684574b1139a6594a34f895daaaf09fd8ea90a27cddb12 778827225BA7DE539C5A7CFA59CFF7CDBD9A5920 No               2019-01-03T00:00:00 No                  Yes                                       00:00:00       00:00:01          fping -q -- %(host)s 00:15:00         2019-02-04T00:00:00 0                  
-barbar Yes     00:05:00 2019-02-04T00:00:00   2019-01-03T00:00:00 00:02:00 192.0.2.3       0558568eedd67d622f5c83b35a115f796ab612cff5ad227247e46c2b020f441c 3E393AEAEFB84C7E89E2F547B3A107558FCA3A27 Yes              2019-01-04T00:00:00 No                  No                  2019-01-03T00:00:00   00:00:30       00:00:01          :                    00:15:00         2019-02-05T00:00:00 -2                 
-"""[1:-1]
-        self.assertEqual(output, expected_output)
-    def test_one_client(self):
-        output = PrintTableCmd().output(None, self.one_client.values())
-        expected_output = """
-Name Enabled Timeout  Last Successful Check
-foo  Yes     00:05:00 2019-02-03T00:00:00  
-"""[1:-1]
-        self.assertEqual(output, expected_output)
-
-class TestDumpJSONCmd(TestCmd):
-    def setUp(self):
-        self.expected_json = {
-            "foo": {
-                "Name": "foo",
-                "KeyID": ("92ed150794387c03ce684574b1139a65"
-                          "94a34f895daaaf09fd8ea90a27cddb12"),
-                "Host": "foo.example.org",
-                "Enabled": True,
-                "Timeout": 300000,
-                "LastCheckedOK": "2019-02-03T00:00:00",
-                "Created": "2019-01-02T00:00:00",
-                "Interval": 120000,
-                "Fingerprint": ("778827225BA7DE539C5A"
-                                "7CFA59CFF7CDBD9A5920"),
-                "CheckerRunning": False,
-                "LastEnabled": "2019-01-03T00:00:00",
-                "ApprovalPending": False,
-                "ApprovedByDefault": True,
-                "LastApprovalRequest": "",
-                "ApprovalDelay": 0,
-                "ApprovalDuration": 1000,
-                "Checker": "fping -q -- %(host)s",
-                "ExtendedTimeout": 900000,
-                "Expires": "2019-02-04T00:00:00",
-                "LastCheckerStatus": 0,
-            },
-            "barbar": {
-                "Name": "barbar",
-                "KeyID": ("0558568eedd67d622f5c83b35a115f79"
-                          "6ab612cff5ad227247e46c2b020f441c"),
-                "Host": "192.0.2.3",
-                "Enabled": True,
-                "Timeout": 300000,
-                "LastCheckedOK": "2019-02-04T00:00:00",
-                "Created": "2019-01-03T00:00:00",
-                "Interval": 120000,
-                "Fingerprint": ("3E393AEAEFB84C7E89E2"
-                                "F547B3A107558FCA3A27"),
-                "CheckerRunning": True,
-                "LastEnabled": "2019-01-04T00:00:00",
-                "ApprovalPending": False,
-                "ApprovedByDefault": False,
-                "LastApprovalRequest": "2019-01-03T00:00:00",
-                "ApprovalDelay": 30000,
-                "ApprovalDuration": 1000,
-                "Checker": ":",
-                "ExtendedTimeout": 900000,
-                "Expires": "2019-02-05T00:00:00",
-                "LastCheckerStatus": -2,
-            },
-        }
-        return super(TestDumpJSONCmd, self).setUp()
-    def test_normal(self):
-        json_data = json.loads(DumpJSONCmd().output(None,
-                                                    self.clients))
-        self.assertDictEqual(json_data, self.expected_json)
-    def test_one_client(self):
-        clients = self.one_client
-        json_data = json.loads(DumpJSONCmd().output(None, clients))
-        expected_json = {"foo": self.expected_json["foo"]}
-        self.assertDictEqual(json_data, expected_json)
-
-class TestIsEnabledCmd(TestCmd):
-    def test_is_enabled(self):
-        self.assertTrue(all(IsEnabledCmd().is_enabled(client, properties)
-                            for client, properties in self.clients.items()))
-    def test_is_enabled_run_exits_successfully(self):
-        with self.assertRaises(SystemExit) as e:
-            IsEnabledCmd().run(None, None, self.one_client)
-        if e.exception.code is not None:
-            self.assertEqual(e.exception.code, 0)
-        else:
-            self.assertIsNone(e.exception.code)
-    def test_is_enabled_run_exits_with_failure(self):
-        self.client.attributes["Enabled"] = dbus.Boolean(False)
-        with self.assertRaises(SystemExit) as e:
-            IsEnabledCmd().run(None, None, self.one_client)
-        if isinstance(e.exception.code, int):
-            self.assertNotEqual(e.exception.code, 0)
-        else:
-            self.assertIsNotNone(e.exception.code)
-
-class TestRemoveCmd(TestCmd):
-    def test_remove(self):
-        class MockMandos(object):
-            def __init__(self):
-                self.calls = []
-            def RemoveClient(self, dbus_path):
-                self.calls.append(("RemoveClient", (dbus_path,)))
-        mandos = MockMandos()
-        super(TestRemoveCmd, self).setUp()
-        RemoveCmd().run(mandos, None, self.clients)
-        self.assertEqual(len(mandos.calls), 2)
-        for client in self.clients:
-            self.assertIn(("RemoveClient",
-                           (client.__dbus_object_path__,)),
-                          mandos.calls)
-
-class TestApproveCmd(TestCmd):
-    def test_approve(self):
-        ApproveCmd().run(None, None, self.clients)
-        for client in self.clients:
-            self.assertIn(("Approve", (True, client_interface)),
-                          client.calls)
-
-class TestDenyCmd(TestCmd):
-    def test_deny(self):
-        DenyCmd().run(None, None, self.clients)
-        for client in self.clients:
-            self.assertIn(("Approve", (False, client_interface)),
-                          client.calls)
-
-class TestEnableCmd(TestCmd):
-    def test_enable(self):
-        for client in self.clients:
-            client.attributes["Enabled"] = False
-
-        EnableCmd().run(None, None, self.clients)
-
-        for client in self.clients:
-            self.assertTrue(client.attributes["Enabled"])
-
-class TestDisableCmd(TestCmd):
-    def test_disable(self):
-        DisableCmd().run(None, None, self.clients)
-
-        for client in self.clients:
-            self.assertFalse(client.attributes["Enabled"])
-
-class Unique(object):
-    """Class for objects which exist only to be unique objects, since
-unittest.mock.sentinel only exists in Python 3.3"""
-
-class TestPropertyCmd(TestCmd):
-    """Abstract class for tests of PropertyCmd classes"""
-    def runTest(self):
-        if not hasattr(self, "command"):
-            return
-        values_to_get = getattr(self, "values_to_get",
-                                self.values_to_set)
-        for value_to_set, value_to_get in zip(self.values_to_set,
-                                              values_to_get):
-            for client in self.clients:
-                old_value = client.attributes[self.property]
-                self.assertNotIsInstance(old_value, Unique)
-                client.attributes[self.property] = Unique()
-            self.run_command(value_to_set, self.clients)
-            for client in self.clients:
-                value = client.attributes[self.property]
-                self.assertNotIsInstance(value, Unique)
-                self.assertEqual(value, value_to_get)
-    def run_command(self, value, clients):
-        self.command().run(None, None, clients)
-
-class TestBumpTimeoutCmd(TestPropertyCmd):
-    command = BumpTimeoutCmd
-    property = "LastCheckedOK"
-    values_to_set = [""]
-
-class TestStartCheckerCmd(TestPropertyCmd):
-    command = StartCheckerCmd
-    property = "CheckerRunning"
-    values_to_set = [dbus.Boolean(True)]
-
-class TestStopCheckerCmd(TestPropertyCmd):
-    command = StopCheckerCmd
-    property = "CheckerRunning"
-    values_to_set = [dbus.Boolean(False)]
-
-class TestApproveByDefaultCmd(TestPropertyCmd):
-    command = ApproveByDefaultCmd
-    property = "ApprovedByDefault"
-    values_to_set = [dbus.Boolean(True)]
-
-class TestDenyByDefaultCmd(TestPropertyCmd):
-    command = DenyByDefaultCmd
-    property = "ApprovedByDefault"
-    values_to_set = [dbus.Boolean(False)]
-
-class TestValueArgumentPropertyCmd(TestPropertyCmd):
-    """Abstract class for tests of PropertyCmd classes using the
-ValueArgumentMixIn"""
-    def runTest(self):
-        if type(self) is TestValueArgumentPropertyCmd:
-            return
-        return super(TestValueArgumentPropertyCmd, self).runTest()
-    def run_command(self, value, clients):
-        self.command(value).run(None, None, clients)
-
-class TestSetCheckerCmd(TestValueArgumentPropertyCmd):
-    command = SetCheckerCmd
-    property = "Checker"
-    values_to_set = ["", ":", "fping -q -- %s"]
-
-class TestSetHostCmd(TestValueArgumentPropertyCmd):
-    command = SetHostCmd
-    property = "Host"
-    values_to_set = ["192.0.2.3", "foo.example.org"]
-
-class TestSetSecretCmd(TestValueArgumentPropertyCmd):
-    command = SetSecretCmd
-    property = "Secret"
-    values_to_set = [io.BytesIO(b""),
-                     io.BytesIO(b"secret\0xyzzy\nbar")]
-    values_to_get = [b"", b"secret\0xyzzy\nbar"]
-
-class TestSetTimeoutCmd(TestValueArgumentPropertyCmd):
-    command = SetTimeoutCmd
-    property = "Timeout"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetExtendedTimeoutCmd(TestValueArgumentPropertyCmd):
-    command = SetExtendedTimeoutCmd
-    property = "ExtendedTimeout"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetIntervalCmd(TestValueArgumentPropertyCmd):
-    command = SetIntervalCmd
-    property = "Interval"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetApprovalDelayCmd(TestValueArgumentPropertyCmd):
-    command = SetApprovalDelayCmd
-    property = "ApprovalDelay"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class TestSetApprovalDurationCmd(TestValueArgumentPropertyCmd):
-    command = SetApprovalDurationCmd
-    property = "ApprovalDuration"
-    values_to_set = [datetime.timedelta(),
-                     datetime.timedelta(minutes=5),
-                     datetime.timedelta(seconds=1),
-                     datetime.timedelta(weeks=1),
-                     datetime.timedelta(weeks=52)]
-    values_to_get = [0, 300000, 1000, 604800000, 31449600000]
-
-class Test_command_from_options(unittest.TestCase):
-    def setUp(self):
-        self.parser = argparse.ArgumentParser()
-        add_command_line_options(self.parser)
-    def assert_command_from_args(self, args, command_cls, **cmd_attrs):
-        """Assert that parsing ARGS should result in an instance of
-COMMAND_CLS with (optionally) all supplied attributes (CMD_ATTRS)."""
-        options = self.parser.parse_args(args)
-        check_option_syntax(self.parser, options)
-        commands = commands_from_options(options)
-        self.assertEqual(len(commands), 1)
-        command = commands[0]
-        self.assertIsInstance(command, command_cls)
-        for key, value in cmd_attrs.items():
-            self.assertEqual(getattr(command, key), value)
-    def test_print_table(self):
-        self.assert_command_from_args([], PrintTableCmd,
-                                      verbose=False)
-
-    def test_print_table_verbose(self):
-        self.assert_command_from_args(["--verbose"], PrintTableCmd,
-                                      verbose=True)
-
-    def test_print_table_verbose_short(self):
-        self.assert_command_from_args(["-v"], PrintTableCmd,
-                                      verbose=True)
-
-    def test_enable(self):
-        self.assert_command_from_args(["--enable", "foo"], EnableCmd)
-
-    def test_enable_short(self):
-        self.assert_command_from_args(["-e", "foo"], EnableCmd)
-
-    def test_disable(self):
-        self.assert_command_from_args(["--disable", "foo"],
-                                      DisableCmd)
-
-    def test_disable_short(self):
-        self.assert_command_from_args(["-d", "foo"], DisableCmd)
-
-    def test_bump_timeout(self):
-        self.assert_command_from_args(["--bump-timeout", "foo"],
-                                      BumpTimeoutCmd)
-
-    def test_bump_timeout_short(self):
-        self.assert_command_from_args(["-b", "foo"], BumpTimeoutCmd)
-
-    def test_start_checker(self):
-        self.assert_command_from_args(["--start-checker", "foo"],
-                                      StartCheckerCmd)
-
-    def test_stop_checker(self):
-        self.assert_command_from_args(["--stop-checker", "foo"],
-                                      StopCheckerCmd)
-
-    def test_remove(self):
-        self.assert_command_from_args(["--remove", "foo"],
-                                      RemoveCmd)
-
-    def test_remove_short(self):
-        self.assert_command_from_args(["-r", "foo"], RemoveCmd)
-
-    def test_checker(self):
-        self.assert_command_from_args(["--checker", ":", "foo"],
-                                      SetCheckerCmd, value_to_set=":")
-
-    def test_checker_empty(self):
-        self.assert_command_from_args(["--checker", "", "foo"],
-                                      SetCheckerCmd, value_to_set="")
-
-    def test_checker_short(self):
-        self.assert_command_from_args(["-c", ":", "foo"],
-                                      SetCheckerCmd, value_to_set=":")
-
-    def test_timeout(self):
-        self.assert_command_from_args(["--timeout", "PT5M", "foo"],
-                                      SetTimeoutCmd,
-                                      value_to_set=300000)
-
-    def test_timeout_short(self):
-        self.assert_command_from_args(["-t", "PT5M", "foo"],
-                                      SetTimeoutCmd,
-                                      value_to_set=300000)
-
-    def test_extended_timeout(self):
-        self.assert_command_from_args(["--extended-timeout", "PT15M",
-                                       "foo"],
-                                      SetExtendedTimeoutCmd,
-                                      value_to_set=900000)
-
-    def test_interval(self):
-        self.assert_command_from_args(["--interval", "PT2M", "foo"],
-                                      SetIntervalCmd,
-                                      value_to_set=120000)
-
-    def test_interval_short(self):
-        self.assert_command_from_args(["-i", "PT2M", "foo"],
-                                      SetIntervalCmd,
-                                      value_to_set=120000)
-
-    def test_approve_by_default(self):
-        self.assert_command_from_args(["--approve-by-default", "foo"],
-                                      ApproveByDefaultCmd)
-
-    def test_deny_by_default(self):
-        self.assert_command_from_args(["--deny-by-default", "foo"],
-                                      DenyByDefaultCmd)
-
-    def test_approval_delay(self):
-        self.assert_command_from_args(["--approval-delay", "PT30S",
-                                       "foo"], SetApprovalDelayCmd,
-                                      value_to_set=30000)
-
-    def test_approval_duration(self):
-        self.assert_command_from_args(["--approval-duration", "PT1S",
-                                       "foo"], SetApprovalDurationCmd,
-                                      value_to_set=1000)
-
-    def test_host(self):
-        self.assert_command_from_args(["--host", "foo.example.org",
-                                       "foo"], SetHostCmd,
-                                      value_to_set="foo.example.org")
-
-    def test_host_short(self):
-        self.assert_command_from_args(["-H", "foo.example.org",
-                                       "foo"], SetHostCmd,
-                                      value_to_set="foo.example.org")
-
-    def test_secret_devnull(self):
-        self.assert_command_from_args(["--secret", os.path.devnull,
-                                       "foo"], SetSecretCmd,
-                                      value_to_set=b"")
-
-    def test_secret_tempfile(self):
-        with tempfile.NamedTemporaryFile(mode="r+b") as f:
-            value = b"secret\0xyzzy\nbar"
-            f.write(value)
-            f.seek(0)
-            self.assert_command_from_args(["--secret", f.name,
-                                           "foo"], SetSecretCmd,
-                                          value_to_set=value)
-
-    def test_secret_devnull_short(self):
-        self.assert_command_from_args(["-s", os.path.devnull, "foo"],
-                                      SetSecretCmd, value_to_set=b"")
-
-    def test_secret_tempfile_short(self):
-        with tempfile.NamedTemporaryFile(mode="r+b") as f:
-            value = b"secret\0xyzzy\nbar"
-            f.write(value)
-            f.seek(0)
-            self.assert_command_from_args(["-s", f.name, "foo"],
-                                          SetSecretCmd,
-                                          value_to_set=value)
-
-    def test_approve(self):
-        self.assert_command_from_args(["--approve", "foo"],
-                                      ApproveCmd)
-
-    def test_approve_short(self):
-        self.assert_command_from_args(["-A", "foo"], ApproveCmd)
-
-    def test_deny(self):
-        self.assert_command_from_args(["--deny", "foo"], DenyCmd)
-
-    def test_deny_short(self):
-        self.assert_command_from_args(["-D", "foo"], DenyCmd)
-
-    def test_dump_json(self):
-        self.assert_command_from_args(["--dump-json"], DumpJSONCmd)
-
-    def test_is_enabled(self):
-        self.assert_command_from_args(["--is-enabled", "foo"],
-                                      IsEnabledCmd)
-
-    def test_is_enabled_short(self):
-        self.assert_command_from_args(["-V", "foo"], IsEnabledCmd)
-
-    def test_deny_before_remove(self):
-        options = self.parser.parse_args(["--deny", "--remove", "foo"])
-        check_option_syntax(self.parser, options)
-        commands = commands_from_options(options)
-        self.assertEqual(len(commands), 2)
-        self.assertIsInstance(commands[0], DenyCmd)
-        self.assertIsInstance(commands[1], RemoveCmd)
-
-    def test_deny_before_remove_reversed(self):
-        options = self.parser.parse_args(["--remove", "--deny", "--all"])
-        check_option_syntax(self.parser, options)
-        commands = commands_from_options(options)
-        self.assertEqual(len(commands), 2)
-        self.assertIsInstance(commands[0], DenyCmd)
-        self.assertIsInstance(commands[1], RemoveCmd)
-
-
-class Test_check_option_syntax(unittest.TestCase):
-    # This mostly corresponds to the definition from has_actions() in
-    # check_option_syntax()
-    actions = {
-        # The actual values set here are not that important, but we do
-        # at least stick to the correct types, even though they are
-        # never used
-        "enable": True,
-        "disable": True,
-        "bump_timeout": True,
-        "start_checker": True,
-        "stop_checker": True,
-        "is_enabled": True,
-        "remove": True,
-        "checker": "x",
-        "timeout": datetime.timedelta(),
-        "extended_timeout": datetime.timedelta(),
-        "interval": datetime.timedelta(),
-        "approved_by_default": True,
-        "approval_delay": datetime.timedelta(),
-        "approval_duration": datetime.timedelta(),
-        "host": "x",
-        "secret": io.BytesIO(b"x"),
-        "approve": True,
-        "deny": True,
-    }
-
-    def setUp(self):
-        self.parser = argparse.ArgumentParser()
-        add_command_line_options(self.parser)
-
-    @contextlib.contextmanager
-    def assertParseError(self):
-        with self.assertRaises(SystemExit) as e:
-            with self.temporarily_suppress_stderr():
-                yield
-        # Exit code from argparse is guaranteed to be "2".  Reference:
-        # https://docs.python.org/3/library/argparse.html#exiting-methods
-        self.assertEqual(e.exception.code, 2)
-
-    @staticmethod
-    @contextlib.contextmanager
-    def temporarily_suppress_stderr():
-        null = os.open(os.path.devnull, os.O_RDWR)
-        stderrcopy = os.dup(sys.stderr.fileno())
-        os.dup2(null, sys.stderr.fileno())
-        os.close(null)
-        try:
-            yield
-        finally:
-            # restore stderr
-            os.dup2(stderrcopy, sys.stderr.fileno())
-            os.close(stderrcopy)
-
-    def check_option_syntax(self, options):
-        check_option_syntax(self.parser, options)
-
-    def test_actions_requires_client_or_all(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            with self.assertParseError():
-                self.check_option_syntax(options)
-
-    def test_actions_conflicts_with_verbose(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.verbose = True
-            with self.assertParseError():
-                self.check_option_syntax(options)
-
-    def test_dump_json_conflicts_with_verbose(self):
-        options = self.parser.parse_args()
-        options.dump_json = True
-        options.verbose = True
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_dump_json_conflicts_with_action(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.dump_json = True
-            with self.assertParseError():
-                self.check_option_syntax(options)
-
-    def test_all_can_not_be_alone(self):
-        options = self.parser.parse_args()
-        options.all = True
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_all_is_ok_with_any_action(self):
-        for action, value in self.actions.items():
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.all = True
-            self.check_option_syntax(options)
-
-    def test_is_enabled_fails_without_client(self):
-        options = self.parser.parse_args()
-        options.is_enabled = True
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_is_enabled_works_with_one_client(self):
-        options = self.parser.parse_args()
-        options.is_enabled = True
-        options.client = ["foo"]
-        self.check_option_syntax(options)
-
-    def test_is_enabled_fails_with_two_clients(self):
-        options = self.parser.parse_args()
-        options.is_enabled = True
-        options.client = ["foo", "barbar"]
-        with self.assertParseError():
-            self.check_option_syntax(options)
-
-    def test_remove_can_only_be_combined_with_action_deny(self):
-        for action, value in self.actions.items():
-            if action in {"remove", "deny"}:
-                continue
-            options = self.parser.parse_args()
-            setattr(options, action, value)
-            options.all = True
-            options.remove = True
-            with self.assertParseError():
-                self.check_option_syntax(options)
-
-
-
-def should_only_run_tests():
-    parser = argparse.ArgumentParser(add_help=False)
-    parser.add_argument("--check", action='store_true')
-    args, unknown_args = parser.parse_known_args()
-    run_tests = args.check
-    if run_tests:
-        # Remove --check argument from sys.argv
-        sys.argv[1:] = unknown_args
-    return run_tests
-
-# Add all tests from doctest strings
-def load_tests(loader, tests, none):
-    import doctest
-    tests.addTests(doctest.DocTestSuite())
-    return tests
+    if not has_actions(options) and clients:
+        if options.verbose or options.dump_json:
+            keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK",
+                        "Created", "Interval", "Host", "Fingerprint",
+                        "CheckerRunning", "LastEnabled",
+                        "ApprovalPending", "ApprovedByDefault",
+                        "LastApprovalRequest", "ApprovalDelay",
+                        "ApprovalDuration", "Checker",
+                        "ExtendedTimeout", "Expires",
+                        "LastCheckerStatus")
+        else:
+            keywords = defaultkeywords
+
+        if options.dump_json:
+            json.dump({client["Name"]: {key:
+                                        bool(client[key])
+                                        if isinstance(client[key],
+                                                      dbus.Boolean)
+                                        else client[key]
+                                        for key in keywords}
+                       for client in clients.values()},
+                      fp=sys.stdout, indent=4,
+                      separators=(',', ': '))
+            print()
+        else:
+            print_clients(clients.values(), keywords)
+    else:
+        # Process each client in the list by all selected options
+        for client in clients:
+
+            def set_client_prop(prop, value):
+                """Set a Client D-Bus property"""
+                client.Set(client_interface, prop, value,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+
+            def set_client_prop_ms(prop, value):
+                """Set a Client D-Bus property, converted
+                from a string to milliseconds."""
+                set_client_prop(prop,
+                                string_to_delta(value).total_seconds()
+                                * 1000)
+
+            if options.remove:
+                mandos_serv.RemoveClient(client.__dbus_object_path__)
+            if options.enable:
+                set_client_prop("Enabled", dbus.Boolean(True))
+            if options.disable:
+                set_client_prop("Enabled", dbus.Boolean(False))
+            if options.bump_timeout:
+                set_client_prop("LastCheckedOK", "")
+            if options.start_checker:
+                set_client_prop("CheckerRunning", dbus.Boolean(True))
+            if options.stop_checker:
+                set_client_prop("CheckerRunning", dbus.Boolean(False))
+            if options.is_enabled:
+                if client.Get(client_interface, "Enabled",
+                              dbus_interface=dbus.PROPERTIES_IFACE):
+                    sys.exit(0)
+                else:
+                    sys.exit(1)
+            if options.checker is not None:
+                set_client_prop("Checker", options.checker)
+            if options.host is not None:
+                set_client_prop("Host", options.host)
+            if options.interval is not None:
+                set_client_prop_ms("Interval", options.interval)
+            if options.approval_delay is not None:
+                set_client_prop_ms("ApprovalDelay",
+                                   options.approval_delay)
+            if options.approval_duration is not None:
+                set_client_prop_ms("ApprovalDuration",
+                                   options.approval_duration)
+            if options.timeout is not None:
+                set_client_prop_ms("Timeout", options.timeout)
+            if options.extended_timeout is not None:
+                set_client_prop_ms("ExtendedTimeout",
+                                   options.extended_timeout)
+            if options.secret is not None:
+                set_client_prop("Secret",
+                                dbus.ByteArray(options.secret.read()))
+            if options.approved_by_default is not None:
+                set_client_prop("ApprovedByDefault",
+                                dbus.Boolean(options
+                                             .approved_by_default))
+            if options.approve:
+                client.Approve(dbus.Boolean(True),
+                               dbus_interface=client_interface)
+            elif options.deny:
+                client.Approve(dbus.Boolean(False),
+                               dbus_interface=client_interface)
+
 
 if __name__ == "__main__":
-    if should_only_run_tests():
-        # Call using ./tdd-python-script --check [--verbose]
-        unittest.main()
-    else:
-        main()
+    main()

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2019-03-08 23:55:34 +0000
+++ mandos-ctl.xml	2017-02-23 19:11:11 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2019-03-09">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -39,8 +39,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -62,22 +60,6 @@
   <refsynopsisdiv>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
-      <group>
-	  <arg choice="plain"><option>--verbose</option></arg>
-	  <arg choice="plain"><option>-v</option></arg>
-	  <sbr/>
-	  <arg choice="plain"><option>--dump-json</option></arg>
-	  <arg choice="plain"><option>-j</option></arg>
-      </group>
-      <arg><option>--debug</option></arg>
-      <group>
-	<arg rep='repeat' choice='plain'>
-	  <replaceable>CLIENT</replaceable>
-	</arg>
-      </group>
-    </cmdsynopsis>
-    <cmdsynopsis>
-      <command>&COMMANDNAME;</command>
       <group choice="req">
 	<group>
 	  <arg choice="plain"><option>--enable</option></arg>
@@ -94,10 +76,18 @@
 	<sbr/>
 	<group>
 	  <arg choice="plain"><option>--start-checker</option></arg>
+	</group>
+	<sbr/>
+	<group>
 	  <arg choice="plain"><option>--stop-checker</option></arg>
 	</group>
 	<sbr/>
 	<group>
+	  <arg choice="plain"><option>--remove</option></arg>
+	  <arg choice="plain"><option>-r</option></arg>
+	</group>
+	<sbr/>
+	<group>
 	  <arg choice="plain"><option>--checker
 	  <replaceable>COMMAND</replaceable></option></arg>
 	  <arg choice="plain"><option>-c
@@ -141,6 +131,13 @@
 	</group>
 	<sbr/>
 	<group>
+	  <arg choice="plain"><option>--interval
+	  <replaceable>TIME</replaceable></option></arg>
+	  <arg choice="plain"><option>-i
+	  <replaceable>TIME</replaceable></option></arg>
+	</group>
+	<sbr/>
+	<group>
 	  <arg choice="plain"><option>--host
 	  <replaceable>STRING</replaceable></option></arg>
 	  <arg choice="plain"><option>-H
@@ -163,7 +160,6 @@
 	</group>
       </group>
       <sbr/>
-      <arg><option>--debug</option></arg>
       <group choice="req">
 	<arg choice="plain"><option>--all</option></arg>
 	<arg choice="plain"><option>-a</option></arg>
@@ -175,18 +171,13 @@
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
       <group>
-	<arg choice="plain"><option>--deny</option></arg>
-	<arg choice="plain"><option>-D</option></arg>
-      </group>
-      <group choice="req">
-	  <arg choice="plain"><option>--remove</option></arg>
-	  <arg choice="plain"><option>-r</option></arg>
-      </group>
-      <sbr/>
-      <arg><option>--debug</option></arg>
-      <group choice="req">
-	<arg choice="plain"><option>--all</option></arg>
-	<arg choice="plain"><option>-a</option></arg>
+	  <arg choice="plain"><option>--verbose</option></arg>
+	  <arg choice="plain"><option>-v</option></arg>
+	  <sbr/>
+	  <arg choice="plain"><option>--dump-json</option></arg>
+	  <arg choice="plain"><option>-j</option></arg>
+      </group>
+      <group>
 	<arg rep='repeat' choice='plain'>
 	  <replaceable>CLIENT</replaceable>
 	</arg>
@@ -198,7 +189,6 @@
 	<arg choice="plain"><option>--is-enabled</option></arg>
 	<arg choice="plain"><option>-V</option></arg>
       </group>
-      <arg><option>--debug</option></arg>
       <arg choice='plain'><replaceable>CLIENT</replaceable></arg>
     </cmdsynopsis>
     <cmdsynopsis>
@@ -512,15 +502,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--debug</option></term>
-	<listitem>
-	  <para>
-	    Show debug output; currently, this means show D-Bus calls.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>--check</option></term>
 	<listitem>
 	  <para>
@@ -598,7 +579,7 @@
       <para>
 
 <!-- do not wrap this line -->
-<userinput>&COMMANDNAME; --timeout="PT5M" --interval="PT1M" foo1.example.org foo2.example.org</userinput>
+<userinput>&COMMANDNAME; --timeout="5m" --interval="1m" foo1.example.org foo2.example.org</userinput>
 
       </para>
     </informalexample>

=== modified file 'mandos-keygen'
--- mandos-keygen	2019-02-11 06:31:42 +0000
+++ mandos-keygen	2017-08-20 14:08:59 +0000
@@ -1,29 +1,27 @@
 #!/bin/sh -e
 # 
-# Mandos key generator - create new keys for a Mandos client
-# 
-# Copyright © 2008-2019 Teddy Hogeborn
-# Copyright © 2008-2019 Björn Påhlsson
-# 
-# This file is part of Mandos.
-#
-# Mandos is free software: you can redistribute it and/or modify it
-# under the terms of the GNU General Public License as published by
+# Mandos key generator - create a new OpenPGP key for a Mandos client
+# 
+# Copyright © 2008-2017 Teddy Hogeborn
+# Copyright © 2008-2017 Björn Påhlsson
+# 
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
-#     Mandos is distributed in the hope that it will be useful, but
-#     WITHOUT ANY WARRANTY; without even the implied warranty of
+#     This program is distributed in the hope that it will be useful,
+#     but WITHOUT ANY WARRANTY; without even the implied warranty of
 #     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #     GNU General Public License for more details.
 # 
 # You should have received a copy of the GNU General Public License
-# along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.8.3"
+VERSION="1.7.15"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=RSA
@@ -34,7 +32,6 @@
 KEYEMAIL=""
 KEYCOMMENT=""
 KEYEXPIRE=0
-TLS_KEYTYPE=ed25519
 FORCE=no
 SSH=yes
 KEYCOMMENT_ORIG="$KEYCOMMENT"
@@ -45,8 +42,8 @@
 fi
 
 # Parse options
-TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:T:fS \
-    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,tls-keytype:,force,no-ssh \
+TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:fS \
+    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force,no-ssh \
     --name "$0" -- "$@"`
 
 help(){
@@ -64,23 +61,21 @@
   -v, --version         Show program's version number and exit
   -h, --help            Show this help message and exit
   -d DIR, --dir DIR     Target directory for key files
-  -t TYPE, --type TYPE  OpenPGP key type.  Default is RSA.
+  -t TYPE, --type TYPE  Key type.  Default is RSA.
   -l BITS, --length BITS
-                        OpenPGP key length in bits.  Default is 4096.
+                        Key length in bits.  Default is 4096.
   -s TYPE, --subtype TYPE
-                        OpenPGP subkey type.  Default is RSA.
+                        Subkey type.  Default is RSA.
   -L BITS, --sublength BITS
-                        OpenPGP subkey length in bits.  Default 4096.
+                        Subkey length in bits.  Default is 4096.
   -n NAME, --name NAME  Name of key.  Default is the FQDN.
   -e ADDRESS, --email ADDRESS
-                        Email address of OpenPGP key.  Default empty.
+                        Email address of key.  Default is empty.
   -c TEXT, --comment TEXT
-                        Comment field for OpenPGP key.  Default empty.
+                        Comment field for key.  The default is empty.
   -x TIME, --expire TIME
-                        OpenPGP key expire time.  Default is none.
+                        Key expire time.  Default is no expiration.
                         See gpg(1) for syntax.
-  -T TYPE, --tls-keytype TYPE
-                        TLS key type.  Default is ed25519.
   -f, --force           Force overwriting old key files.
 
 Password creation options:
@@ -109,7 +104,6 @@
 	-e|--email) KEYEMAIL="$2"; shift 2;;
 	-c|--comment) KEYCOMMENT="$2"; shift 2;;
 	-x|--expire) KEYEXPIRE="$2"; shift 2;;
-	-T|--tls-keytype) TLS_KEYTYPE="$2"; shift 2;;
 	-f|--force) FORCE=yes; shift;;
 	-S|--no-ssh) SSH=no; shift;;
 	-v|--version) echo "$0 $VERSION"; exit;;
@@ -125,8 +119,6 @@
 
 SECKEYFILE="$KEYDIR/seckey.txt"
 PUBKEYFILE="$KEYDIR/pubkey.txt"
-TLS_PRIVKEYFILE="$KEYDIR/tls-privkey.pem"
-TLS_PUBKEYFILE="$KEYDIR/tls-pubkey.pem"
 
 # Check for some invalid values
 if [ ! -d "$KEYDIR" ]; then
@@ -169,9 +161,7 @@
 	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|*) FORCE=0;;
     esac
     
-    if { [ -e "$SECKEYFILE" ] || [ -e "$PUBKEYFILE" ] \
-	     || [ -e "$TLS_PRIVKEYFILE" ] \
-	     || [ -e "$TLS_PUBKEYFILE" ]; } \
+    if { [ -e "$SECKEYFILE" ] || [ -e "$PUBKEYFILE" ]; } \
 	&& [ "$FORCE" -eq 0 ]; then
 	echo "Refusing to overwrite old key files; use --force" >&2
 	exit 1
@@ -187,7 +177,6 @@
     
     # Create temporary gpg batch file
     BATCHFILE="`mktemp -t mandos-keygen-batch.XXXXXXXXXX`"
-    TLS_PRIVKEYTMP="`mktemp -t mandos-keygen-privkey.XXXXXXXXXX`"
 fi
 
 if [ "$mode" = password ]; then
@@ -202,7 +191,6 @@
 trap "
 set +e; \
 test -n \"$SECFILE\" && shred --remove \"$SECFILE\"; \
-test -n \"$TLS_PRIVKEYTMP\" && shred --remove \"$TLS_PRIVKEYTMP\"; \
 shred --remove \"$RINGDIR\"/sec* 2>/dev/null;
 test -n \"$BATCHFILE\" && rm --force \"$BATCHFILE\"; \
 rm --recursive --force \"$RINGDIR\";
@@ -243,39 +231,6 @@
 	echo -n "Started: "
 	date
     fi
-
-    # Generate TLS private key
-    if certtool --generate-privkey --password='' \
-		--outfile "$TLS_PRIVKEYTMP" --sec-param ultra \
-		--key-type="$TLS_KEYTYPE" --pkcs8 --no-text 2>/dev/null; then
-	
-	# Backup any old key files
-	if cp --backup=numbered --force "$TLS_PRIVKEYFILE" "$TLS_PRIVKEYFILE" \
-	      2>/dev/null; then
-	    shred --remove "$TLS_PRIVKEYFILE" 2>/dev/null || :
-	fi
-	if cp --backup=numbered --force "$TLS_PUBKEYFILE" "$TLS_PUBKEYFILE" \
-	      2>/dev/null; then
-	    rm --force "$TLS_PUBKEYFILE"
-	fi
-	cp --archive "$TLS_PRIVKEYTMP" "$TLS_PRIVKEYFILE"
-	shred --remove "$TLS_PRIVKEYTMP" 2>/dev/null || :
-
-	## TLS public key
-
-	# First try certtool from GnuTLS
-	if ! certtool --password='' --load-privkey="$TLS_PRIVKEYFILE" \
-	     --outfile="$TLS_PUBKEYFILE" --pubkey-info --no-text \
-	     2>/dev/null; then
-	    # Otherwise try OpenSSL
-	    if ! openssl pkey -in "$TLS_PRIVKEYFILE" \
-		 -out "$TLS_PUBKEYFILE" -pubout; then
-		rm --force "$TLS_PUBKEYFILE"
-		# None of the commands succeded; give up
-		return 1
-	    fi
-	fi
-    fi
     
     # Make sure trustdb.gpg exists;
     # this is a workaround for Debian bug #737128
@@ -296,7 +251,7 @@
     # Backup any old key files
     if cp --backup=numbered --force "$SECKEYFILE" "$SECKEYFILE" \
 	2>/dev/null; then
-	shred --remove "$SECKEYFILE" 2>/dev/null || :
+	shred --remove "$SECKEYFILE"
     fi
     if cp --backup=numbered --force "$PUBKEYFILE" "$PUBKEYFILE" \
 	2>/dev/null; then
@@ -364,19 +319,6 @@
     
     test -n "$FINGERPRINT"
     
-    if [ -r "$TLS_PUBKEYFILE" ]; then
-       KEY_ID="$(certtool --key-id --hash=sha256 \
-    		       --infile="$TLS_PUBKEYFILE" 2>/dev/null || :)"
-
-       if [ -z "$KEY_ID" ]; then
-	   KEY_ID=$(openssl pkey -pubin -in "$TLS_PUBKEYFILE" \
-			    -outform der \
-			| openssl sha256 \
-			| sed --expression='s/^.*[^[:xdigit:]]//')
-       fi
-       test -n "$KEY_ID"
-    fi
-    
     FILECOMMENT="Encrypted password for a Mandos client"
     
     while [ ! -s "$SECFILE" ]; do
@@ -416,11 +358,6 @@
     cat <<-EOF
 	[$KEYNAME]
 	host = $KEYNAME
-	EOF
-    if [ -n "$KEY_ID" ]; then
-	echo "key_id = $KEY_ID"
-    fi
-    cat <<-EOF
 	fingerprint = $FINGERPRINT
 	secret =
 	EOF
@@ -444,7 +381,7 @@
 set +e
 # Remove the password file, if any
 if [ -n "$SECFILE" ]; then
-    shred --remove "$SECFILE" 2>/dev/null
+    shred --remove "$SECFILE"
 fi
 # Remove the key rings
 shred --remove "$RINGDIR"/sec* 2>/dev/null

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2019-02-10 04:20:26 +0000
+++ mandos-keygen.xml	2017-02-23 19:11:11 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -41,8 +41,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -128,13 +126,6 @@
       </group>
       <sbr/>
       <group>
-	<arg choice="plain"><option>--tls-keytype
-	<replaceable>KEYTYPE</replaceable></option></arg>
-	<arg choice="plain"><option>-T
-	<replaceable>KEYTYPE</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
 	<arg choice="plain"><option>--force</option></arg>
 	<arg choice="plain"><option>-f</option></arg>
       </group>
@@ -188,12 +179,12 @@
     <title>DESCRIPTION</title>
     <para>
       <command>&COMMANDNAME;</command> is a program to generate the
-      TLS and OpenPGP keys used by
+      OpenPGP key used by
       <citerefentry><refentrytitle>mandos-client</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>.  The keys are
-      normally written to /etc/keys/mandos for later installation into
-      the initrd image, but this, and most other things, can be
-      changed with command line options.
+      <manvolnum>8mandos</manvolnum></citerefentry>.  The key is
+      normally written to /etc/mandos for later installation into the
+      initrd image, but this, and most other things, can be changed
+      with command line options.
     </para>
     <para>
       This program can also be used with the
@@ -236,8 +227,8 @@
 	<replaceable>DIRECTORY</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Target directory for key files.  Default is <filename
-	    class="directory">/etc/keys/mandos</filename>.
+	    Target directory for key files.  Default is
+	    <filename class="directory">/etc/mandos</filename>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -249,7 +240,7 @@
 	<replaceable>TYPE</replaceable></option></term>
 	<listitem>
 	  <para>
-	    OpenPGP key type.  Default is <quote>RSA</quote>.
+	    Key type.  Default is <quote>RSA</quote>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -261,7 +252,7 @@
 	<replaceable>BITS</replaceable></option></term>
 	<listitem>
 	  <para>
-	    OpenPGP key length in bits.  Default is 4096.
+	    Key length in bits.  Default is 4096.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -273,7 +264,8 @@
 	<replaceable>KEYTYPE</replaceable></option></term>
 	<listitem>
 	  <para>
-	    OpenPGP subkey type.  Default is <quote>RSA</quote>
+	    Subkey type.  Default is <quote>RSA</quote> (Elgamal
+	    encryption-only).
 	  </para>
 	</listitem>
       </varlistentry>
@@ -285,7 +277,7 @@
 	<replaceable>BITS</replaceable></option></term>
 	<listitem>
 	  <para>
-	    OpenPGP subkey length in bits.  Default is 4096.
+	    Subkey length in bits.  Default is 4096.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -329,18 +321,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--tls-keytype
-	<replaceable>KEYTYPE</replaceable></option></term>
-	<term><option>-T
-	<replaceable>KEYTYPE</replaceable></option></term>
-	<listitem>
-	  <para>
-	    TLS key type.  Default is <quote>ed25519</quote>
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>--force</option></term>
 	<term><option>-f</option></term>
 	<listitem>
@@ -355,8 +335,8 @@
 	<listitem>
 	  <para>
 	    Prompt for a password and encrypt it with the key already
-	    present in either <filename>/etc/keys/mandos</filename> or
-	    the directory specified with the <option>--dir</option>
+	    present in either <filename>/etc/mandos</filename> or the
+	    directory specified with the <option>--dir</option>
 	    option.  Outputs, on standard output, a section suitable
 	    for inclusion in <citerefentry><refentrytitle
 	    >mandos-clients.conf</refentrytitle><manvolnum
@@ -402,9 +382,9 @@
     <title>OVERVIEW</title>
     <xi:include href="overview.xml"/>
     <para>
-      This program is a small utility to generate new TLS and OpenPGP
-      keys for new Mandos clients, and to generate sections for
-      inclusion in <filename>clients.conf</filename> on the server.
+      This program is a small utility to generate new OpenPGP keys for
+      new Mandos clients, and to generate sections for inclusion in
+      <filename>clients.conf</filename> on the server.
     </para>
   </refsect1>
   
@@ -442,7 +422,7 @@
     </para>
     <variablelist>
       <varlistentry>
-	<term><filename>/etc/keys/mandos/seckey.txt</filename></term>
+	<term><filename>/etc/mandos/seckey.txt</filename></term>
 	<listitem>
 	  <para>
 	    OpenPGP secret key file which will be created or
@@ -451,7 +431,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename>/etc/keys/mandos/pubkey.txt</filename></term>
+	<term><filename>/etc/mandos/pubkey.txt</filename></term>
 	<listitem>
 	  <para>
 	    OpenPGP public key file which will be created or
@@ -460,22 +440,6 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename>/etc/keys/mandos/tls-privkey.pem</filename></term>
-	<listitem>
-	  <para>
-	    Private key file which will be created or overwritten.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/etc/keys/mandos/tls-pubkey.pem</filename></term>
-	<listitem>
-	  <para>
-	    Public key file which will be created or overwritten.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
 	<term><filename class="directory">/tmp</filename></term>
 	<listitem>
 	  <para>
@@ -516,9 +480,9 @@
     </informalexample>
     <informalexample>
       <para>
-	Prompt for a password, encrypt it with the keys in <filename
-	class="directory">/etc/keys/mandos</filename> and output a
-	section suitable for <filename>clients.conf</filename>.
+	Prompt for a password, encrypt it with the key in <filename
+	class="directory">/etc/mandos</filename> and output a section
+	suitable for <filename>clients.conf</filename>.
       </para>
       <para>
 	<userinput>&COMMANDNAME; --password</userinput>
@@ -526,7 +490,7 @@
     </informalexample>
     <informalexample>
       <para>
-	Prompt for a password, encrypt it with the keys in the
+	Prompt for a password, encrypt it with the key in the
 	<filename>client-key</filename> directory and output a section
 	suitable for <filename>clients.conf</filename>.
       </para>

=== modified file 'mandos-monitor'
--- mandos-monitor	2019-02-11 06:31:42 +0000
+++ mandos-monitor	2017-02-23 20:35:20 +0000
@@ -3,23 +3,22 @@
 #
 # Mandos Monitor - Control and monitor the Mandos server
 #
-# Copyright © 2009-2019 Teddy Hogeborn
-# Copyright © 2009-2019 Björn Påhlsson
-#
-# This file is part of Mandos.
-#
-# Mandos is free software: you can redistribute it and/or modify it
-# under the terms of the GNU General Public License as published by
+# Copyright © 2009-2017 Teddy Hogeborn
+# Copyright © 2009-2017 Björn Påhlsson
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
-#     Mandos is distributed in the hope that it will be useful, but
-#     WITHOUT ANY WARRANTY; without even the implied warranty of
+#     This program is distributed in the hope that it will be useful,
+#     but WITHOUT ANY WARRANTY; without even the implied warranty of
 #     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #     GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
-# along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+# along with this program.  If not, see
+# <http://www.gnu.org/licenses/>.
 #
 # Contact the authors at <mandos@recompile.se>.
 #
@@ -59,7 +58,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.8.3"
+version = "1.7.15"
 
 try:
     dbus.OBJECT_MANAGER_IFACE
@@ -444,7 +443,7 @@
         self.clients_dict = {}
 
         # We will add Text widgets to this list
-        self.log = urwid.SimpleListWalker([])
+        self.log = []
         self.max_log_length = max_log_length
 
         self.log_level = log_level
@@ -503,7 +502,7 @@
         if self.max_log_length:
             if len(self.log) > self.max_log_length:
                 del self.log[0:len(self.log)-self.max_log_length-1]
-        self.logbox.set_focus(len(self.logbox.body.contents)-1,
+        self.logbox.set_focus(len(self.logbox.body.contents),
                               coming_from="above")
         self.refresh()
 

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2019-02-10 04:20:26 +0000
+++ mandos-monitor.xml	2017-02-23 19:11:11 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -39,8 +39,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2019-02-09 23:23:26 +0000
+++ mandos-options.xml	2015-07-20 03:03:33 +0000
@@ -48,11 +48,10 @@
   
   <para id="priority">
     GnuTLS priority string for the <acronym>TLS</acronym> handshake.
-    The default is
-    <quote><literal>SECURE128&#8203;:!CTYPE-X.509&#8203;:+CTYPE-RAWPK&#8203;:!RSA&#8203;:!VERS-ALL&#8203;:+VERS-TLS1.3&#8203;:%PROFILE_ULTRA</literal></quote>
-    when using raw public keys in TLS, and
-    <quote><literal>SECURE256&#8203;:!CTYPE-X.509&#8203;:+CTYPE-OPENPGP&#8203;:!RSA&#8203;:+SIGN-DSA-SHA256</literal></quote>
-    when using OpenPGP keys in TLS,.  See <citerefentry><refentrytitle
+    The default is <quote><literal
+    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA</literal>
+    <literal>:+SIGN-DSA-SHA256</literal></quote>.
+    See <citerefentry><refentrytitle
     >gnutls_priority_init</refentrytitle>
     <manvolnum>3</manvolnum></citerefentry> for the syntax.
     <emphasis>Warning</emphasis>: changing this may make the

=== removed file 'mandos-to-cryptroot-unlock'
--- mandos-to-cryptroot-unlock	2018-08-19 14:58:40 +0000
+++ mandos-to-cryptroot-unlock	1970-01-01 00:00:00 +0000
@@ -1,82 +0,0 @@
-#!/bin/sh
-# 
-# Script to get password from plugin-runner to cryptroot-unlock
-# 
-# Copyright © 2018 Teddy Hogeborn
-# Copyright © 2018 Björn Påhlsson
-# 
-# This file is part of Mandos.
-# 
-# Mandos is free software: you can redistribute it and/or modify it
-# under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-# 
-#     Mandos is distributed in the hope that it will be useful, but
-#     WITHOUT ANY WARRANTY; without even the implied warranty of
-#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#     GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <mandos@recompile.se>.
-
-# This script is made to run in the initramfs, and must not be run in
-# the normal system environment.
-
-# Temporary file for the password
-passfile=$(mktemp -p /run -t mandos.XXXXXX)
-trap "rm -f -- $passfile 2>/dev/null" EXIT
-
-# Disable the plugins which conflict with "askpass" as distributed by
-# cryptsetup.
-cat <<-EOF >>/conf/conf.d/mandos/plugin-runner.conf
-
-	--disable=askpass-fifo
-	--disable=password-prompt
-	--disable=plymouth
-EOF
-
-# In case a password is retrieved by other means than by plugin-runner
-# (such as typing it on the console into the prompt given by the
-# "askpass" program), this dummy plugin will be made to exit
-# successfully, thereby forcing plugin-runner to stop all its plugins
-# and also exit itself.
-cat <<-EOF > /lib/mandos/plugins.d/dummy
-	#!/bin/sh
-	
-	while [ -e /run/mandos-keep-running ]; do
-	    sleep 1
-	done
-	
-	# exit successfully to force plugin-runner to finish
-	exit 0
-EOF
-chmod u=rwx,go=rx /lib/mandos/plugins.d/dummy
-
-# This file is the flag which keeps the dummy plugin running
-touch /run/mandos-keep-running
-
-# Keep running plugin-runner and trying any password, until either a
-# password is accepted by cryptroot-unlock, or plugin-runner fails, or
-# the file /run/mandos-keep-running has been removed.
-while type cryptroot-unlock >/dev/null 2>&1; do
-    /lib/mandos/plugin-runner > "$passfile" &
-    echo $! > /run/mandos-plugin-runner.pid
-    wait %% || break
-
-    # Try this password ten times (or ten seconds)
-    for loop in 1 2 3 4 5 6 7 8 9 10; do
-	if [ -e /run/mandos-keep-running ]; then
-	    cryptroot-unlock < "$passfile" >/dev/null 2>&1 && break 2
-	    sleep 1
-	else
-	    break 2
-	fi
-    done
-done
-
-exec >/dev/null 2>&1
-
-rm -f /run/mandos-plugin-runner.pid /run/mandos-keep-running

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2019-02-10 04:20:26 +0000
+++ mandos.conf.xml	2017-02-23 19:11:11 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -42,8 +42,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'mandos.lsm'
--- mandos.lsm	2019-02-11 06:31:42 +0000
+++ mandos.lsm	2017-06-24 10:08:21 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.8.3
-Entered-date:	2019-02-11
+Version:	1.7.15
+Entered-date:	2017-06-24
 Description:	The Mandos system allows computers to have encrypted
 		root file systems and at the same time be capable of
 		remote and/or unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site:	https://www.recompile.se/mandos
-		182K mandos_1.8.3.orig.tar.gz
+		173K mandos_1.7.15.orig.tar.gz
 Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		182K mandos_1.8.3.orig.tar.gz
+		173K mandos_1.7.15.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.7, and
 		various other libraries.  While made for Debian
 		GNU/Linux, it is probably portable to other

=== modified file 'mandos.xml'
--- mandos.xml	2019-02-10 04:20:26 +0000
+++ mandos.xml	2017-02-23 19:11:11 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -41,8 +41,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -362,11 +360,11 @@
       start a TLS protocol handshake with a slight quirk: the Mandos
       server program acts as a TLS <quote>client</quote> while the
       connecting Mandos client acts as a TLS <quote>server</quote>.
-      The Mandos client must supply a TLS public key, and the key ID
-      of this public key is used by the Mandos server to look up (in a
-      list read from <filename>clients.conf</filename> at start time)
-      which binary blob to give the client.  No other authentication
-      or authorization is done by the server.
+      The Mandos client must supply an OpenPGP certificate, and the
+      fingerprint of this certificate is used by the Mandos server to
+      look up (in a list read from <filename>clients.conf</filename>
+      at start time) which binary blob to give the client.  No other
+      authentication or authorization is done by the server.
     </para>
     <table>
       <title>Mandos Protocol (Version 1)</title><tgroup cols="3"><thead>
@@ -392,7 +390,7 @@
 	</emphasis></entry>
       </row>
       <row>
-	<entry>Public key (part of TLS handshake)</entry>
+	<entry>OpenPGP public key (part of TLS handshake)</entry>
 	<entry>-><!-- &rarr; --></entry>
       </row>
       <row>
@@ -587,6 +585,10 @@
     <para>
       There is no fine-grained control over logging and debug output.
     </para>
+    <para>
+      This server does not check the expire time of clients’ OpenPGP
+      keys.
+    </para>
     <xi:include href="bugs.xml"/>
   </refsect1>
   
@@ -643,12 +645,12 @@
       <title>CLIENTS</title>
       <para>
 	The server only gives out its stored data to clients which
-	does have the correct key ID of the stored key ID.  This is
-	guaranteed by the fact that the client sends its public key in
-	the TLS handshake; this ensures it to be genuine.  The server
-	computes the key ID of the key itself and looks up the key ID
-	in its list of clients. The <filename>clients.conf</filename>
-	file (see
+	does have the OpenPGP key of the stored fingerprint.  This is
+	guaranteed by the fact that the client sends its OpenPGP
+	public key in the TLS handshake; this ensures it to be
+	genuine.  The server computes the fingerprint of the key
+	itself and looks up the fingerprint in its list of
+	clients. The <filename>clients.conf</filename> file (see
 	<citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
 	<manvolnum>5</manvolnum></citerefentry>)
 	<emphasis>must</emphasis> be made non-readable by anyone
@@ -712,7 +714,7 @@
 	<para>
 	  GnuTLS is the library this server uses to implement TLS for
 	  communicating securely with the client, and at the same time
-	  confidently get the client’s public key.
+	  confidently get the client’s public OpenPGP key.
 	</para>
       </listitem>
       </varlistentry>
@@ -771,28 +773,13 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 7250: <citetitle>Using Raw Public Keys in Transport
-	  Layer Security (TLS) and Datagram Transport Layer Security
-	  (DTLS)</citetitle>
-	</term>
-      <listitem>
-	<para>
-	  This is implemented by GnuTLS version 3.6.6 and is, if
-	  present, used by this server so that raw public keys can be
-	  used.
-	</para>
-      </listitem>
-      </varlistentry>
-      <varlistentry>
-	<term>
 	  RFC 6091: <citetitle>Using OpenPGP Keys for Transport Layer
 	  Security (TLS) Authentication</citetitle>
 	</term>
       <listitem>
 	<para>
-	  This is implemented by GnuTLS before version 3.6.0 and is,
-	  if present, used by this server so that OpenPGP keys can be
-	  used.
+	  This is implemented by GnuTLS and used by this server so
+	  that OpenPGP keys can be used.
 	</para>
       </listitem>
       </varlistentry>

=== modified file 'network-hooks.d/bridge'
--- network-hooks.d/bridge	2018-02-08 10:23:55 +0000
+++ network-hooks.d/bridge	2017-08-20 14:08:59 +0000
@@ -6,8 +6,8 @@
 # configuration file(s) should be copied into the
 # /etc/mandos/network-hooks.d directory.
 # 
-# Copyright © 2012-2018 Teddy Hogeborn
-# Copyright © 2012-2018 Björn Påhlsson
+# Copyright © 2012 Teddy Hogeborn
+# Copyright © 2012 Björn Påhlsson
 # 
 # Copying and distribution of this file, with or without modification,
 # are permitted in any medium without royalty provided the copyright

=== modified file 'network-hooks.d/openvpn'
--- network-hooks.d/openvpn	2018-02-08 10:23:55 +0000
+++ network-hooks.d/openvpn	2012-06-13 22:06:57 +0000
@@ -6,8 +6,8 @@
 # configuration file(s) should be copied into the
 # /etc/mandos/network-hooks.d directory.
 # 
-# Copyright © 2012-2018 Teddy Hogeborn
-# Copyright © 2012-2018 Björn Påhlsson
+# Copyright © 2012 Teddy Hogeborn
+# Copyright © 2012 Björn Påhlsson
 # 
 # Copying and distribution of this file, with or without modification,
 # are permitted in any medium without royalty provided the copyright

=== modified file 'network-hooks.d/wireless'
--- network-hooks.d/wireless	2018-02-08 10:23:55 +0000
+++ network-hooks.d/wireless	2012-06-13 22:06:57 +0000
@@ -6,8 +6,8 @@
 # configuration file(s) should be copied into the
 # /etc/mandos/network-hooks.d directory.
 # 
-# Copyright © 2012-2018 Teddy Hogeborn
-# Copyright © 2012-2018 Björn Påhlsson
+# Copyright © 2012 Teddy Hogeborn
+# Copyright © 2012 Björn Påhlsson
 # 
 # Copying and distribution of this file, with or without modification,
 # are permitted in any medium without royalty provided the copyright

=== modified file 'overview.xml'
--- overview.xml	2019-02-09 23:23:26 +0000
+++ overview.xml	2008-09-13 15:36:18 +0000
@@ -8,10 +8,10 @@
   program in the initial <acronym>RAM</acronym> disk environment which
   will communicate with a server over a network.  All network
   communication is encrypted using <acronym>TLS</acronym>.  The
-  clients are identified by the server using a TLS key; each client
-  has one unique to it.  The server sends the clients an encrypted
-  password.  The encrypted password is decrypted by the clients using
-  a separate OpenPGP key, and the password is then used to unlock the
-  root file system, whereupon the computers can continue booting
-  normally.
+  clients are identified by the server using an OpenPGP key; each
+  client has one unique to it.  The server sends the clients an
+  encrypted password.  The encrypted password is decrypted by the
+  clients using the same OpenPGP key, and the password is then used to
+  unlock the root file system, whereupon the computers can continue
+  booting normally.
 </para>

=== modified file 'plugin-helpers/mandos-client-iprouteadddel.c'
--- plugin-helpers/mandos-client-iprouteadddel.c	2018-02-18 01:29:21 +0000
+++ plugin-helpers/mandos-client-iprouteadddel.c	2017-02-23 19:11:11 +0000
@@ -2,28 +2,28 @@
 /* 
  * iprouteadddel - Add or delete direct route to a local IP address
  * 
- * Copyright © 2015-2018 Teddy Hogeborn
- * Copyright © 2015-2018 Björn Påhlsson
- * 
- * This file is part of Mandos.
- * 
- * Mandos is free software: you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- * 
- * Mandos is distributed in the hope that it will be useful, but
+ * Copyright © 2015-2017 Teddy Hogeborn
+ * Copyright © 2015-2017 Björn Påhlsson
+ * 
+ * This program is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation, either version 3 of the
+ * License, or (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
- * along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+ * along with this program.  If not, see
+ * <http://www.gnu.org/licenses/>.
  * 
  * Contact the authors at <mandos@recompile.se>.
  */
 
-#define _GNU_SOURCE		/* program_invocation_short_name */
+#define _GNU_SOURCE		/* asprintf(),
+				   program_invocation_short_name */
 #include <stdbool.h>		/* bool, false, true */
 #include <stdio.h>		/* fprintf(), stderr, FILE, vfprintf */
 #include <errno.h>		/* program_invocation_short_name,
@@ -243,7 +243,7 @@
   }
   /* Set interface index number on nexthop object */
   rtnl_route_nh_set_ifindex(nexthop, ifindex);
-  /* Set route to use nexthop object */
+  /* Set route tu use nexthop object */
   rtnl_route_add_nexthop(route, nexthop);
   /* Add or delete route? */
   if(arguments.add){

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2019-02-11 05:14:10 +0000
+++ plugin-runner.c	2017-02-23 19:11:11 +0000
@@ -2,23 +2,22 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2018 Teddy Hogeborn
- * Copyright © 2008-2018 Björn Påhlsson
- * 
- * This file is part of Mandos.
- * 
- * Mandos is free software: you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- * 
- * Mandos is distributed in the hope that it will be useful, but
+ * Copyright © 2008-2017 Teddy Hogeborn
+ * Copyright © 2008-2017 Björn Påhlsson
+ * 
+ * This program is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation, either version 3 of the
+ * License, or (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
- * along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+ * along with this program.  If not, see
+ * <http://www.gnu.org/licenses/>.
  * 
  * Contact the authors at <mandos@recompile.se>.
  */
@@ -564,12 +563,10 @@
     case '?':			/* --help */
       state->flags &= ~(unsigned int)ARGP_NO_EXIT; /* force exit */
       argp_state_help(state, state->out_stream, ARGP_HELP_STD_HELP);
-      __builtin_unreachable();
     case -3:			/* --usage */
       state->flags &= ~(unsigned int)ARGP_NO_EXIT; /* force exit */
       argp_state_help(state, state->out_stream,
 		      ARGP_HELP_USAGE | ARGP_HELP_EXIT_OK);
-      __builtin_unreachable();
     case 'V':			/* --version */
       fprintf(state->out_stream, "%s\n", argp_program_version);
       exit(EXIT_SUCCESS);
@@ -585,7 +582,6 @@
       if(arg[0] == '\0'){
 	break;
       }
-      /* FALLTHROUGH */
     default:
       return ARGP_ERR_UNKNOWN;
     }
@@ -1095,12 +1091,7 @@
     
     new_plugin->pid = pid;
     new_plugin->fd = pipefd[0];
-
-    if(debug){
-      fprintf(stderr, "Plugin %s started (PID %" PRIdMAX ")\n",
-	      new_plugin->name, (intmax_t) (new_plugin->pid));
-    }
-
+    
     /* Unblock SIGCHLD so signal handler can be run if this process
        has already completed */
     ret = (int)TEMP_FAILURE_RETRY(sigprocmask(SIG_UNBLOCK,

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2019-02-10 04:20:26 +0000
+++ plugin-runner.xml	2017-02-23 19:11:11 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -41,8 +41,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -635,7 +633,7 @@
       <para>
 
 <!-- do not wrap this line -->
-<userinput>cd /etc/keys/mandos; &COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/x86_64-linux-gnu/mandos/plugins.d --plugin-helper-dir /usr/lib/x86_64-linux-gnu/mandos/plugin-helpers --options-for=mandos-client:--pubkey=pubkey.txt,--seckey=seckey.txt,--tls-pubkey=tls-pubkey.pem,--tls-privkey=tls-privkey.pem</userinput>
+<userinput>cd /etc/keys/mandos; &COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/x86_64-linux-gnu/mandos/plugins.d --plugin-helper-dir /usr/lib/x86_64-linux-gnu/mandos/plugin-helpers --options-for=mandos-client:--pubkey=pubkey.txt,--seckey=seckey.txt</userinput>
 
       </para>
     </informalexample>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2019-02-11 07:06:55 +0000
+++ plugins.d/askpass-fifo.c	2017-02-23 19:11:11 +0000
@@ -2,23 +2,22 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2019 Teddy Hogeborn
- * Copyright © 2008-2019 Björn Påhlsson
- * 
- * This file is part of Mandos.
- * 
- * Mandos is free software: you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- * 
- * Mandos is distributed in the hope that it will be useful, but
+ * Copyright © 2008-2017 Teddy Hogeborn
+ * Copyright © 2008-2017 Björn Påhlsson
+ * 
+ * This program is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation, either version 3 of the
+ * License, or (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
- * along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+ * along with this program.  If not, see
+ * <http://www.gnu.org/licenses/>.
  * 
  * Contact the authors at <mandos@recompile.se>.
  */
@@ -65,16 +64,10 @@
     fprintf(stderr, ": ");
     fprintf(stderr, "%s\n", strerror(errnum));
     error(status, errno, "vasprintf while printing error");
-    if(status){
-      __builtin_unreachable();
-    }
     return;
   }
   fprintf(stderr, "Mandos plugin ");
   error(status, errnum, "%s", text);
-  if(status){
-    __builtin_unreachable();
-  }
   free(text);
 }
 
@@ -96,17 +89,14 @@
     case ENOTDIR:
     case ELOOP:
       error_plus(EX_OSFILE, errno, "mkfifo");
-      __builtin_unreachable();
     case ENAMETOOLONG:
     case ENOSPC:
     case EROFS:
     default:
       error_plus(EX_OSERR, errno, "mkfifo");
-      __builtin_unreachable();
     case ENOENT:
       /* no "/lib/cryptsetup"? */
       error_plus(EX_UNAVAILABLE, errno, "mkfifo");
-      __builtin_unreachable();
     case EEXIST:
       break;			/* not an error */
     }

=== modified file 'plugins.d/askpass-fifo.xml'
--- plugins.d/askpass-fifo.xml	2019-02-10 04:20:26 +0000
+++ plugins.d/askpass-fifo.xml	2017-02-23 19:11:11 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "askpass-fifo">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -41,8 +41,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2019-02-11 05:14:10 +0000
+++ plugins.d/mandos-client.c	2017-02-23 19:11:11 +0000
@@ -9,23 +9,22 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2019 Teddy Hogeborn
- * Copyright © 2008-2019 Björn Påhlsson
- * 
- * This file is part of Mandos.
- * 
- * Mandos is free software: you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- * 
- * Mandos is distributed in the hope that it will be useful, but
+ * Copyright © 2008-2017 Teddy Hogeborn
+ * Copyright © 2008-2017 Björn Påhlsson
+ * 
+ * This program is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation, either version 3 of the
+ * License, or (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
- * along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+ * along with this program.  If not, see
+ * <http://www.gnu.org/licenses/>.
  * 
  * Contact the authors at <mandos@recompile.se>.
  */
@@ -123,15 +122,9 @@
 				   gnutls_*
 				   init_gnutls_session(),
 				   GNUTLS_* */
-#if GNUTLS_VERSION_NUMBER < 0x030600
 #include <gnutls/openpgp.h>
 			 /* gnutls_certificate_set_openpgp_key_file(),
 			    GNUTLS_OPENPGP_FMT_BASE64 */
-#elif GNUTLS_VERSION_NUMBER >= 0x030606
-#include <gnutls/x509.h>	/* gnutls_pkcs_encrypt_flags_t,
-				 GNUTLS_PKCS_PLAIN,
-				 GNUTLS_PKCS_NULL_PASSWORD */
-#endif
 
 /* GPGME */
 #include <gpgme.h> 		/* All GPGME types, constants and
@@ -145,8 +138,6 @@
 #define PATHDIR "/conf/conf.d/mandos"
 #define SECKEY "seckey.txt"
 #define PUBKEY "pubkey.txt"
-#define TLS_PRIVKEY "tls-privkey.pem"
-#define TLS_PUBKEY "tls-pubkey.pem"
 #define HOOKDIR "/lib/mandos/network-hooks.d"
 
 bool debug = false;
@@ -280,58 +271,6 @@
   return true;
 }
 
-/* Set effective uid to 0, return errno */
-__attribute__((warn_unused_result))
-int raise_privileges(void){
-  int old_errno = errno;
-  int ret = 0;
-  if(seteuid(0) == -1){
-    ret = errno;
-  }
-  errno = old_errno;
-  return ret;
-}
-
-/* Set effective and real user ID to 0.  Return errno. */
-__attribute__((warn_unused_result))
-int raise_privileges_permanently(void){
-  int old_errno = errno;
-  int ret = raise_privileges();
-  if(ret != 0){
-    errno = old_errno;
-    return ret;
-  }
-  if(setuid(0) == -1){
-    ret = errno;
-  }
-  errno = old_errno;
-  return ret;
-}
-
-/* Set effective user ID to unprivileged saved user ID */
-__attribute__((warn_unused_result))
-int lower_privileges(void){
-  int old_errno = errno;
-  int ret = 0;
-  if(seteuid(uid) == -1){
-    ret = errno;
-  }
-  errno = old_errno;
-  return ret;
-}
-
-/* Lower privileges permanently */
-__attribute__((warn_unused_result))
-int lower_privileges_permanently(void){
-  int old_errno = errno;
-  int ret = 0;
-  if(setuid(uid) == -1){
-    ret = errno;
-  }
-  errno = old_errno;
-  return ret;
-}
-
 /* 
  * Initialize GPGME.
  */
@@ -357,56 +296,6 @@
       return false;
     }
     
-    /* Workaround for systems without a real-time clock; see also
-       Debian bug #894495: <https://bugs.debian.org/894495> */
-    do {
-      {
-	time_t currtime = time(NULL);
-	if(currtime != (time_t)-1){
-	  struct tm tm;
-	  if(gmtime_r(&currtime, &tm) == NULL) {
-	    perror_plus("gmtime_r");
-	    break;
-	  }
-	  if(tm.tm_year != 70 or tm.tm_mon != 0){
-	    break;
-	  }
-	  if(debug){
-	    fprintf_plus(stderr, "System clock is January 1970");
-	  }
-	} else {
-	  if(debug){
-	    fprintf_plus(stderr, "System clock is invalid");
-	  }
-	}
-      }
-      struct stat keystat;
-      ret = fstat(fd, &keystat);
-      if(ret != 0){
-	perror_plus("fstat");
-	break;
-      }
-      ret = raise_privileges();
-      if(ret != 0){
-	errno = ret;
-	perror_plus("Failed to raise privileges");
-	break;
-      }
-      if(debug){
-	fprintf_plus(stderr,
-		     "Setting system clock to key file mtime");
-      }
-      time_t keytime = keystat.st_mtim.tv_sec;
-      if(stime(&keytime) != 0){
-	perror_plus("stime");
-      }
-      ret = lower_privileges();
-      if(ret != 0){
-	errno = ret;
-	perror_plus("Failed to lower privileges");
-      }
-    } while(false);
-
     rc = gpgme_data_new_from_fd(&pgp_data, fd);
     if(rc != GPG_ERR_NO_ERROR){
       fprintf_plus(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
@@ -420,81 +309,6 @@
 		   gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
-    {
-      gpgme_import_result_t import_result
-	= gpgme_op_import_result(mc->ctx);
-      if((import_result->imported < 1
-	  or import_result->not_imported > 0)
-	 and import_result->unchanged == 0){
-	fprintf_plus(stderr, "bad gpgme_op_import_results:\n");
-	fprintf_plus(stderr,
-		     "The total number of considered keys: %d\n",
-		     import_result->considered);
-	fprintf_plus(stderr,
-		     "The number of keys without user ID: %d\n",
-		     import_result->no_user_id);
-	fprintf_plus(stderr,
-		     "The total number of imported keys: %d\n",
-		     import_result->imported);
-	fprintf_plus(stderr, "The number of imported RSA keys: %d\n",
-		     import_result->imported_rsa);
-	fprintf_plus(stderr, "The number of unchanged keys: %d\n",
-		     import_result->unchanged);
-	fprintf_plus(stderr, "The number of new user IDs: %d\n",
-		     import_result->new_user_ids);
-	fprintf_plus(stderr, "The number of new sub keys: %d\n",
-		     import_result->new_sub_keys);
-	fprintf_plus(stderr, "The number of new signatures: %d\n",
-		     import_result->new_signatures);
-	fprintf_plus(stderr, "The number of new revocations: %d\n",
-		     import_result->new_revocations);
-	fprintf_plus(stderr,
-		     "The total number of secret keys read: %d\n",
-		     import_result->secret_read);
-	fprintf_plus(stderr,
-		     "The number of imported secret keys: %d\n",
-		     import_result->secret_imported);
-	fprintf_plus(stderr,
-		     "The number of unchanged secret keys: %d\n",
-		     import_result->secret_unchanged);
-	fprintf_plus(stderr, "The number of keys not imported: %d\n",
-		     import_result->not_imported);
-	for(gpgme_import_status_t import_status
-	      = import_result->imports;
-	    import_status != NULL;
-	    import_status = import_status->next){
-	  fprintf_plus(stderr, "Import status for key: %s\n",
-		       import_status->fpr);
-	  if(import_status->result != GPG_ERR_NO_ERROR){
-	    fprintf_plus(stderr, "Import result: %s: %s\n",
-			 gpgme_strsource(import_status->result),
-			 gpgme_strerror(import_status->result));
-	  }
-	  fprintf_plus(stderr, "Key status:\n");
-	  fprintf_plus(stderr,
-		       import_status->status & GPGME_IMPORT_NEW
-		       ? "The key was new.\n"
-		       : "The key was not new.\n");
-	  fprintf_plus(stderr,
-		       import_status->status & GPGME_IMPORT_UID
-		       ? "The key contained new user IDs.\n"
-		       : "The key did not contain new user IDs.\n");
-	  fprintf_plus(stderr,
-		       import_status->status & GPGME_IMPORT_SIG
-		       ? "The key contained new signatures.\n"
-		       : "The key did not contain new signatures.\n");
-	  fprintf_plus(stderr,
-		       import_status->status & GPGME_IMPORT_SUBKEY
-		       ? "The key contained new sub keys.\n"
-		       : "The key did not contain new sub keys.\n");
-	  fprintf_plus(stderr,
-		       import_status->status & GPGME_IMPORT_SECRET
-		       ? "The key contained a secret key.\n"
-		       : "The key did not contain a secret key.\n");
-	}
-	return false;
-      }
-    }
     
     ret = close(fd);
     if(ret == -1){
@@ -541,8 +355,9 @@
   /* Create new GPGME "context" */
   rc = gpgme_new(&(mc->ctx));
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_new: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf_plus(stderr, "Mandos plugin mandos-client: "
+		 "bad gpgme_new: %s: %s\n", gpgme_strsource(rc),
+		 gpgme_strerror(rc));
     return false;
   }
   
@@ -584,7 +399,8 @@
   /* Create new empty GPGME data buffer for the plaintext */
   rc = gpgme_data_new(&dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_data_new: %s: %s\n",
+    fprintf_plus(stderr, "Mandos plugin mandos-client: "
+		 "bad gpgme_data_new: %s: %s\n",
 		 gpgme_strsource(rc), gpgme_strerror(rc));
     gpgme_data_release(dh_crypto);
     return -1;
@@ -603,23 +419,24 @@
       if(result == NULL){
 	fprintf_plus(stderr, "gpgme_op_decrypt_result failed\n");
       } else {
-	if(result->unsupported_algorithm != NULL) {
-	  fprintf_plus(stderr, "Unsupported algorithm: %s\n",
-		       result->unsupported_algorithm);
-	}
-	fprintf_plus(stderr, "Wrong key usage: %s\n",
-		     result->wrong_key_usage ? "Yes" : "No");
+	fprintf_plus(stderr, "Unsupported algorithm: %s\n",
+		     result->unsupported_algorithm);
+	fprintf_plus(stderr, "Wrong key usage: %u\n",
+		     result->wrong_key_usage);
 	if(result->file_name != NULL){
 	  fprintf_plus(stderr, "File name: %s\n", result->file_name);
 	}
-
-	for(gpgme_recipient_t r = result->recipients; r != NULL;
-	    r = r->next){
+	gpgme_recipient_t recipient;
+	recipient = result->recipients;
+	while(recipient != NULL){
 	  fprintf_plus(stderr, "Public key algorithm: %s\n",
-		       gpgme_pubkey_algo_name(r->pubkey_algo));
-	  fprintf_plus(stderr, "Key ID: %s\n", r->keyid);
+		       gpgme_pubkey_algo_name
+		       (recipient->pubkey_algo));
+	  fprintf_plus(stderr, "Key ID: %s\n", recipient->keyid);
 	  fprintf_plus(stderr, "Secret key available: %s\n",
-		       r->status == GPG_ERR_NO_SECKEY ? "No" : "Yes");
+		       recipient->status == GPG_ERR_NO_SECKEY
+		       ? "No" : "Yes");
+	  recipient = recipient->next;
 	}
       }
     }
@@ -707,6 +524,7 @@
 			      const char *dhparamsfilename,
 			      mandos_context *mc){
   int ret;
+  unsigned int uret;
   
   if(debug){
     fprintf_plus(stderr, "Initializing GnuTLS\n");
@@ -729,34 +547,18 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Attempting to use public key %s and"
-		 " private key %s as GnuTLS credentials\n",
+    fprintf_plus(stderr, "Attempting to use OpenPGP public key %s and"
+		 " secret key %s as GnuTLS credentials\n",
 		 pubkeyfilename,
 		 seckeyfilename);
   }
   
-#if GNUTLS_VERSION_NUMBER >= 0x030606
-  ret = gnutls_certificate_set_rawpk_key_file
-    (mc->cred, pubkeyfilename, seckeyfilename,
-     GNUTLS_X509_FMT_PEM,	/* format */
-     NULL,			/* pass */
-     /* key_usage */
-     GNUTLS_KEY_DIGITAL_SIGNATURE | GNUTLS_KEY_KEY_ENCIPHERMENT,
-     NULL, 			/* names */
-     0,				/* names_length */
-     /* privkey_flags */
-     GNUTLS_PKCS_PLAIN | GNUTLS_PKCS_NULL_PASSWORD,
-     0);			/* pkcs11_flags */
-#elif GNUTLS_VERSION_NUMBER < 0x030600
   ret = gnutls_certificate_set_openpgp_key_file
     (mc->cred, pubkeyfilename, seckeyfilename,
      GNUTLS_OPENPGP_FMT_BASE64);
-#else
-#error "Needs GnuTLS 3.6.6 or later, or before 3.6.0"
-#endif
   if(ret != GNUTLS_E_SUCCESS){
     fprintf_plus(stderr,
-		 "Error[%d] while reading the key pair ('%s',"
+		 "Error[%d] while reading the OpenPGP key pair ('%s',"
 		 " '%s')\n", ret, pubkeyfilename, seckeyfilename);
     fprintf_plus(stderr, "The GnuTLS error is: %s\n",
 		 safer_gnutls_strerror(ret));
@@ -810,10 +612,6 @@
 	}
 	params.size += (unsigned int)bytes_read;
       }
-      ret = close(dhpfile);
-      if(ret == -1){
-	perror_plus("close");
-      }
       if(params.data == NULL){
 	dhparamsfilename = NULL;
       }
@@ -833,7 +631,6 @@
   }
   if(dhparamsfilename == NULL){
     if(mc->dh_bits == 0){
-#if GNUTLS_VERSION_NUMBER < 0x030600
       /* Find out the optimal number of DH bits */
       /* Try to read the private key file */
       gnutls_datum_t buffer = { .data = NULL, .size = 0 };
@@ -919,7 +716,7 @@
 	  }
 	}
       }
-      unsigned int uret = gnutls_sec_param_to_pk_bits(GNUTLS_PK_DH, sec_param);
+      uret = gnutls_sec_param_to_pk_bits(GNUTLS_PK_DH, sec_param);
       if(uret != 0){
 	mc->dh_bits = uret;
 	if(debug){
@@ -937,22 +734,19 @@
 		     safer_gnutls_strerror(ret));
 	goto globalfail;
       }
-#endif
-    } else {			/* dh_bits != 0 */
-      if(debug){
-	fprintf_plus(stderr, "DH bits explicitly set to %u\n",
-		     mc->dh_bits);
-      }
-      ret = gnutls_dh_params_generate2(mc->dh_params, mc->dh_bits);
-      if(ret != GNUTLS_E_SUCCESS){
-	fprintf_plus(stderr, "Error in GnuTLS prime generation (%u"
-		     " bits): %s\n", mc->dh_bits,
-		     safer_gnutls_strerror(ret));
-	goto globalfail;
-      }
-      gnutls_certificate_set_dh_params(mc->cred, mc->dh_params);
+    } else if(debug){
+      fprintf_plus(stderr, "DH bits explicitly set to %u\n",
+		   mc->dh_bits);
+    }
+    ret = gnutls_dh_params_generate2(mc->dh_params, mc->dh_bits);
+    if(ret != GNUTLS_E_SUCCESS){
+      fprintf_plus(stderr, "Error in GnuTLS prime generation (%u"
+		   " bits): %s\n", mc->dh_bits,
+		   safer_gnutls_strerror(ret));
+      goto globalfail;
     }
   }
+  gnutls_certificate_set_dh_params(mc->cred, mc->dh_params);
   
   return 0;
   
@@ -969,14 +763,7 @@
   int ret;
   /* GnuTLS session creation */
   do {
-    ret = gnutls_init(session, (GNUTLS_SERVER
-#if GNUTLS_VERSION_NUMBER >= 0x030506
-				| GNUTLS_NO_TICKETS
-#endif
-#if GNUTLS_VERSION_NUMBER >= 0x030606
-				| GNUTLS_ENABLE_RAWPK
-#endif
-				));
+    ret = gnutls_init(session, GNUTLS_SERVER);
     if(quit_now){
       return -1;
     }
@@ -1030,6 +817,58 @@
 static void empty_log(__attribute__((unused)) AvahiLogLevel level,
 		      __attribute__((unused)) const char *txt){}
 
+/* Set effective uid to 0, return errno */
+__attribute__((warn_unused_result))
+int raise_privileges(void){
+  int old_errno = errno;
+  int ret = 0;
+  if(seteuid(0) == -1){
+    ret = errno;
+  }
+  errno = old_errno;
+  return ret;
+}
+
+/* Set effective and real user ID to 0.  Return errno. */
+__attribute__((warn_unused_result))
+int raise_privileges_permanently(void){
+  int old_errno = errno;
+  int ret = raise_privileges();
+  if(ret != 0){
+    errno = old_errno;
+    return ret;
+  }
+  if(setuid(0) == -1){
+    ret = errno;
+  }
+  errno = old_errno;
+  return ret;
+}
+
+/* Set effective user ID to unprivileged saved user ID */
+__attribute__((warn_unused_result))
+int lower_privileges(void){
+  int old_errno = errno;
+  int ret = 0;
+  if(seteuid(uid) == -1){
+    ret = errno;
+  }
+  errno = old_errno;
+  return ret;
+}
+
+/* Lower privileges permanently */
+__attribute__((warn_unused_result))
+int lower_privileges_permanently(void){
+  int old_errno = errno;
+  int ret = 0;
+  if(setuid(uid) == -1){
+    ret = errno;
+  }
+  errno = old_errno;
+  return ret;
+}
+
 /* Helper function to add_local_route() and delete_local_route() */
 __attribute__((nonnull, warn_unused_result))
 static bool add_delete_local_route(const bool add,
@@ -1815,18 +1654,8 @@
       perror_plus("ioctl SIOCGIFFLAGS");
       errno = old_errno;
     }
-    if((close(s) == -1) and debug){
-      old_errno = errno;
-      perror_plus("close");
-      errno = old_errno;
-    }
     return false;
   }
-  if((close(s) == -1) and debug){
-    old_errno = errno;
-    perror_plus("close");
-    errno = old_errno;
-  }
   return true;
 }
 
@@ -2093,20 +1922,19 @@
       return;
     }
   }
-  int devnull = (int)TEMP_FAILURE_RETRY(open("/dev/null", O_RDONLY));
-  if(devnull == -1){
-    perror_plus("open(\"/dev/null\", O_RDONLY)");
-    return;
-  }
   int numhooks = scandirat(hookdir_fd, ".", &direntries,
 			   runnable_hook, alphasort);
   if(numhooks == -1){
     perror_plus("scandir");
-    close(devnull);
     return;
   }
   struct dirent *direntry;
   int ret;
+  int devnull = (int)TEMP_FAILURE_RETRY(open("/dev/null", O_RDONLY));
+  if(devnull == -1){
+    perror_plus("open(\"/dev/null\", O_RDONLY)");
+    return;
+  }
   for(int i = 0; i < numhooks; i++){
     direntry = direntries[i];
     if(debug){
@@ -2461,16 +2289,8 @@
 
 int main(int argc, char *argv[]){
   mandos_context mc = { .server = NULL, .dh_bits = 0,
-#if GNUTLS_VERSION_NUMBER >= 0x030606
-			.priority = "SECURE128:!CTYPE-X.509"
-			":+CTYPE-RAWPK:!RSA:!VERS-ALL:+VERS-TLS1.3"
-			":%PROFILE_ULTRA",
-#elif GNUTLS_VERSION_NUMBER < 0x030600
 			.priority = "SECURE256:!CTYPE-X.509"
 			":+CTYPE-OPENPGP:!RSA:+SIGN-DSA-SHA256",
-#else
-#error "Needs GnuTLS 3.6.6 or later, or before 3.6.0"
-#endif
 			.current_server = NULL, .interfaces = NULL,
 			.interfaces_size = 0 };
   AvahiSServiceBrowser *sb = NULL;
@@ -2487,10 +2307,6 @@
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
   const char *seckey = PATHDIR "/" SECKEY;
   const char *pubkey = PATHDIR "/" PUBKEY;
-#if GNUTLS_VERSION_NUMBER >= 0x030606
-  const char *tls_privkey = PATHDIR "/" TLS_PRIVKEY;
-  const char *tls_pubkey = PATHDIR "/" TLS_PUBKEY;
-#endif
   const char *dh_params_file = NULL;
   char *interfaces_hooks = NULL;
   
@@ -2544,23 +2360,7 @@
       { .name = "pubkey", .key = 'p',
 	.arg = "FILE",
 	.doc = "OpenPGP public key file base name",
-	.group = 1 },
-      { .name = "tls-privkey", .key = 't',
-	.arg = "FILE",
-#if GNUTLS_VERSION_NUMBER >= 0x030606
-	.doc = "TLS private key file base name",
-#else
-	.doc = "Dummy; ignored (requires GnuTLS 3.6.6)",
-#endif
-	.group = 1 },
-      { .name = "tls-pubkey", .key = 'T',
-	.arg = "FILE",
-#if GNUTLS_VERSION_NUMBER >= 0x030606
-	.doc = "TLS public key file base name",
-#else
-	.doc = "Dummy; ignored (requires GnuTLS 3.6.6)",
-#endif
-	.group = 1 },
+	.group = 2 },
       { .name = "dh-bits", .key = 129,
 	.arg = "BITS",
 	.doc = "Bit length of the prime number used in the"
@@ -2622,16 +2422,6 @@
       case 'p':			/* --pubkey */
 	pubkey = arg;
 	break;
-      case 't':			/* --tls-privkey */
-#if GNUTLS_VERSION_NUMBER >= 0x030606
-	tls_privkey = arg;
-#endif
-	break;
-      case 'T':			/* --tls-pubkey */
-#if GNUTLS_VERSION_NUMBER >= 0x030606
-	tls_pubkey = arg;
-#endif
-	break;
       case 129:			/* --dh-bits */
 	errno = 0;
 	tmpmax = strtoimax(arg, &tmp, 10);
@@ -2672,11 +2462,9 @@
 	argp_state_help(state, state->out_stream,
 			(ARGP_HELP_STD_HELP | ARGP_HELP_EXIT_ERR)
 			& ~(unsigned int)ARGP_HELP_EXIT_OK);
-	__builtin_unreachable();
       case -3:			/* --usage */
 	argp_state_help(state, state->out_stream,
 			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
-	__builtin_unreachable();
       case 'V':			/* --version */
 	fprintf_plus(state->out_stream, "%s\n", argp_program_version);
 	exit(argp_err_exit_status);
@@ -2993,13 +2781,7 @@
     goto end;
   }
   
-#if GNUTLS_VERSION_NUMBER >= 0x030606
-  ret = init_gnutls_global(tls_pubkey, tls_privkey, dh_params_file, &mc);
-#elif GNUTLS_VERSION_NUMBER < 0x030600
   ret = init_gnutls_global(pubkey, seckey, dh_params_file, &mc);
-#else
-#error "Needs GnuTLS 3.6.6 or later, or before 3.6.0"
-#endif
   if(ret == -1){
     fprintf_plus(stderr, "init_gnutls_global failed\n");
     exitcode = EX_UNAVAILABLE;
@@ -3278,7 +3060,6 @@
 						| O_PATH));
     if(dir_fd == -1){
       perror_plus("open");
-      return;
     }
     int numentries = scandirat(dir_fd, ".", &direntries,
 			       notdotentries, alphasort);
@@ -3301,7 +3082,7 @@
 	    clean_dir_at(dir_fd, direntries[i]->d_name, level+1);
 	    dret = 0;
 	  }
-	  if((dret == -1) and (errno != ENOENT)){
+	  if(dret == -1){
 	    fprintf_plus(stderr, "unlink(\"%s/%s\"): %s\n", dirname,
 			 direntries[i]->d_name, strerror(errno));
 	  }
@@ -3311,6 +3092,9 @@
       
       /* need to clean even if 0 because man page doesn't specify */
       free(direntries);
+      if(numentries == -1){
+	perror_plus("scandirat");
+      }
       dret = unlinkat(base, dirname, AT_REMOVEDIR);
       if(dret == -1 and errno != ENOENT){
 	perror_plus("rmdir");

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2019-02-10 04:20:26 +0000
+++ plugins.d/mandos-client.xml	2017-02-23 19:11:11 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -41,8 +41,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -96,20 +94,6 @@
 	<replaceable>FILE</replaceable></option></arg>
       </group>
       <sbr/>
-      <group>
-	<arg choice="plain"><option>--tls-privkey
-	<replaceable>FILE</replaceable></option></arg>
-	<arg choice="plain"><option>-t
-	<replaceable>FILE</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--tls-pubkey
-	<replaceable>FILE</replaceable></option></arg>
-	<arg choice="plain"><option>-T
-	<replaceable>FILE</replaceable></option></arg>
-      </group>
-      <sbr/>
       <arg>
 	<option>--priority <replaceable>STRING</replaceable></option>
       </arg>
@@ -169,10 +153,10 @@
       brings up network interfaces, uses the interfaces’ IPv6
       link-local addresses to get network connectivity, uses Zeroconf
       to find servers on the local network, and communicates with
-      servers using TLS with a raw public key to ensure authenticity
-      and confidentiality.  This client program keeps running, trying
-      all servers on the network, until it receives a satisfactory
-      reply or a TERM signal.  After all servers have been tried, all
+      servers using TLS with an OpenPGP key to ensure authenticity and
+      confidentiality.  This client program keeps running, trying all
+      servers on the network, until it receives a satisfactory reply
+      or a TERM signal.  After all servers have been tried, all
       servers are periodically retried.  If no servers are found it
       will wait indefinitely for new servers to appear.
     </para>
@@ -322,34 +306,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--tls-pubkey=<replaceable
-	>FILE</replaceable></option></term>
-	<term><option>-T
-	<replaceable>FILE</replaceable></option></term>
-	<listitem>
-	  <para>
-	    TLS raw public key file name.  The default name is
-	    <quote><filename>/conf/conf.d/mandos/tls-pubkey.pem</filename
-	    ></quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
-
-      <varlistentry>
-	<term><option>--tls-privkey=<replaceable
-	>FILE</replaceable></option></term>
-	<term><option>-t
-	<replaceable>FILE</replaceable></option></term>
-	<listitem>
-	  <para>
-	    TLS secret key file name.  The default name is
-	    <quote><filename>/conf/conf.d/mandos/tls-privkey.pem</filename
-	    ></quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
-
-      <varlistentry>
 	<term><option>--priority=<replaceable
 	>STRING</replaceable></option></term>
 	<listitem>
@@ -365,10 +321,9 @@
 	  <para>
 	    Sets the number of bits to use for the prime number in the
 	    TLS Diffie-Hellman key exchange.  The default value is
-	    selected automatically based on the GnuTLS security
-	    profile set in its priority string.  Note that if the
-	    <option>--dh-params</option> option is used, the values
-	    from that file will be used instead.
+	    selected automatically based on the OpenPGP key.  Note
+	    that if the <option>--dh-params</option> option is used,
+	    the values from that file will be used instead.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -726,20 +681,6 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename>/conf/conf.d/mandos/tls-pubkey.pem</filename
-	></term>
-	<term><filename>/conf/conf.d/mandos/tls-privkey.pem</filename
-	></term>
-	<listitem>
-	  <para>
-	    Public and private raw key files, in <quote>PEM</quote>
-	    format.  These are the default file names, they can be
-	    changed with the <option>--tls-pubkey</option> and
-	    <option>--tls-privkey</option> options.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
 	<term><filename
 	class="directory">/lib/mandos/network-hooks.d</filename></term>
 	<listitem>
@@ -787,18 +728,18 @@
     </informalexample>
     <informalexample>
       <para>
-	Run in debug mode, and use custom keys:
+	Run in debug mode, and use a custom key:
       </para>
       <para>
 
 <!-- do not wrap this line -->
-<userinput>&COMMANDNAME; --debug --pubkey keydir/pubkey.txt --seckey keydir/seckey.txt --tls-pubkey keydir/tls-pubkey.pem --tls-privkey keydir/tls-privkey.pem</userinput>
+<userinput>&COMMANDNAME; --debug --pubkey keydir/pubkey.txt --seckey keydir/seckey.txt</userinput>
 
       </para>
     </informalexample>
     <informalexample>
       <para>
-	Run in debug mode, with custom keys, and do not use Zeroconf
+	Run in debug mode, with a custom key, and do not use Zeroconf
 	to locate a server; connect directly to the IPv6 link-local
 	address <quote><systemitem class="ipaddress"
 	>fe80::aede:48ff:fe71:f6f2</systemitem></quote>, port 4711,
@@ -807,7 +748,7 @@
       <para>
 
 <!-- do not wrap this line -->
-<userinput>&COMMANDNAME; --debug --pubkey keydir/pubkey.txt --seckey keydir/seckey.txt --tls-pubkey keydir/tls-pubkey.pem --tls-privkey keydir/tls-privkey.pem --connect fe80::aede:48ff:fe71:f6f2:4711 --interface eth2</userinput>
+<userinput>&COMMANDNAME; --debug --pubkey keydir/pubkey.txt --seckey keydir/seckey.txt --connect fe80::aede:48ff:fe71:f6f2:4711 --interface eth2</userinput>
 
       </para>
     </informalexample>
@@ -837,12 +778,12 @@
     <para>
       The only remaining weak point is that someone with physical
       access to the client hard drive might turn off the client
-      computer, read the OpenPGP and TLS keys directly from the hard
-      drive, and communicate with the server.  To safeguard against
-      this, the server is supposed to notice the client disappearing
-      and stop giving out the encrypted data.  Therefore, it is
-      important to set the timeout and checker interval values tightly
-      on the server.  See <citerefentry><refentrytitle
+      computer, read the OpenPGP keys directly from the hard drive,
+      and communicate with the server.  To safeguard against this, the
+      server is supposed to notice the client disappearing and stop
+      giving out the encrypted data.  Therefore, it is important to
+      set the timeout and checker interval values tightly on the
+      server.  See <citerefentry><refentrytitle
       >mandos</refentrytitle><manvolnum>8</manvolnum></citerefentry>.
     </para>
     <para>
@@ -908,7 +849,7 @@
 	<para>
 	  GnuTLS is the library this client uses to implement TLS for
 	  communicating securely with the server, and at the same time
-	  send the public key to the server.
+	  send the public OpenPGP key to the server.
 	</para>
       </listitem>
       </varlistentry>
@@ -980,28 +921,13 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 7250: <citetitle>Using Raw Public Keys in Transport
-	  Layer Security (TLS) and Datagram Transport Layer Security
-	  (DTLS)</citetitle>
-	</term>
-      <listitem>
-	<para>
-	  This is implemented by GnuTLS in version 3.6.6 and is, if
-	  present, used by this program so that raw public keys can be
-	  used.
-	</para>
-      </listitem>
-      </varlistentry>
-      <varlistentry>
-	<term>
 	  RFC 6091: <citetitle>Using OpenPGP Keys for Transport Layer
 	  Security</citetitle>
 	</term>
       <listitem>
 	<para>
-	  This is implemented by GnuTLS before version 3.6.0 and is,
-	  if present, used by this program so that OpenPGP keys can be
-	  used.
+	  This is implemented by GnuTLS and used by this program so
+	  that OpenPGP keys can be used.
 	</para>
       </listitem>
       </varlistentry>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2019-02-11 07:06:55 +0000
+++ plugins.d/password-prompt.c	2017-06-24 10:08:21 +0000
@@ -2,23 +2,22 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2019 Teddy Hogeborn
- * Copyright © 2008-2019 Björn Påhlsson
- * 
- * This file is part of Mandos.
- * 
- * Mandos is free software: you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- * 
- * Mandos is distributed in the hope that it will be useful, but
+ * Copyright © 2008-2017 Teddy Hogeborn
+ * Copyright © 2008-2017 Björn Påhlsson
+ * 
+ * This program is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation, either version 3 of the
+ * License, or (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
- * along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+ * along with this program.  If not, see
+ * <http://www.gnu.org/licenses/>.
  * 
  * Contact the authors at <mandos@recompile.se>.
  */
@@ -274,11 +273,9 @@
 	argp_state_help(state, state->out_stream,
 			(ARGP_HELP_STD_HELP | ARGP_HELP_EXIT_ERR)
 			& ~(unsigned int)ARGP_HELP_EXIT_OK);
-	__builtin_unreachable();
       case -3:			/* --usage */
 	argp_state_help(state, state->out_stream,
 			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
-	__builtin_unreachable();
       case 'V':			/* --version */
 	fprintf(state->out_stream, "%s\n", argp_program_version);
 	exit(argp_err_exit_status);

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2019-02-10 04:20:26 +0000
+++ plugins.d/password-prompt.xml	2017-02-23 19:11:11 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -41,8 +41,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2018-02-08 10:23:55 +0000
+++ plugins.d/plymouth.c	2017-02-23 19:11:11 +0000
@@ -2,23 +2,22 @@
 /*
  * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010-2018 Teddy Hogeborn
- * Copyright © 2010-2018 Björn Påhlsson
- * 
- * This file is part of Mandos.
- * 
- * Mandos is free software: you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- * 
- * Mandos is distributed in the hope that it will be useful, but
+ * Copyright © 2010-2017 Teddy Hogeborn
+ * Copyright © 2010-2017 Björn Påhlsson
+ * 
+ * This program is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation, either version 3 of the
+ * License, or (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
- * along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+ * along with this program.  If not, see
+ * <http://www.gnu.org/licenses/>.
  * 
  * Contact the authors at <mandos@recompile.se>.
  */
@@ -57,11 +56,9 @@
 sig_atomic_t interrupted_by_signal = 0;
 
 /* Used by Ubuntu 11.04 (Natty Narwahl) */
-const char plymouth_old_old_pid[] = "/dev/.initramfs/plymouth.pid";
+const char plymouth_old_pid[] = "/dev/.initramfs/plymouth.pid";
 /* Used by Ubuntu 11.10 (Oneiric Ocelot) */
-const char plymouth_old_pid[] = "/run/initramfs/plymouth.pid";
-/* Used by Debian 9 (stretch) */
-const char plymouth_pid[] = "/run/plymouth/pid";
+const char plymouth_pid[] = "/run/initramfs/plymouth.pid";
 
 const char plymouth_path[] = "/bin/plymouth";
 const char plymouthd_path[] = "/sbin/plymouthd";
@@ -284,18 +281,7 @@
   }
   /* Try the old pid file location */
   if(proc_id == 0){
-    pidfile = fopen(plymouth_old_pid, "r");
-    if(pidfile != NULL){
-      ret = fscanf(pidfile, "%" SCNuMAX, &proc_id);
-      if(ret != 1){
-	proc_id = 0;
-      }
-      fclose(pidfile);
-    }
-  }
-  /* Try the old old pid file location */
-  if(proc_id == 0){
-    pidfile = fopen(plymouth_old_old_pid, "r");
+    pidfile = fopen(plymouth_pid, "r");
     if(pidfile != NULL){
       ret = fscanf(pidfile, "%" SCNuMAX, &proc_id);
       if(ret != 1){
@@ -312,14 +298,9 @@
       error_plus(0, errno, "scandir");
     }
     if(ret > 0){
-      for(int i = ret-1; i >= 0; i--){
-	if(proc_id == 0){
-	  ret = sscanf(direntries[i]->d_name, "%" SCNuMAX, &proc_id);
-	  if(ret < 0){
-	    error_plus(0, errno, "sscanf");
-	  }
-	}
-	free(direntries[i]);
+      ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &proc_id);
+      if(ret < 0){
+	error_plus(0, errno, "sscanf");
       }
     }
     /* scandir might preallocate for this variable (man page unclear).
@@ -335,7 +316,7 @@
   return 0;
 }
 
-char **getargv(pid_t pid){
+const char * const * getargv(pid_t pid){
   int cl_fd;
   char *cmdline_filename;
   ssize_t sret;
@@ -402,7 +383,7 @@
     return NULL;
   }
   argz_extract(cmdline, cmdline_len, argv); /* Create argv */
-  return argv;
+  return (const char * const *)argv;
 }
 
 int main(__attribute__((unused))int argc,
@@ -483,10 +464,11 @@
   }
   kill_and_wait(plymouth_command_pid);
   
-  char **plymouthd_argv = NULL;
+  const char * const *plymouthd_argv;
   pid_t pid = get_pid();
   if(pid == 0){
     error_plus(0, 0, "plymouthd pid not found");
+    plymouthd_argv = plymouthd_default_argv;
   } else {
     plymouthd_argv = getargv(pid);
   }
@@ -495,21 +477,10 @@
 		       { plymouth_path, "quit", NULL },
 		       false, false);
   if(not bret){
-    if(plymouthd_argv != NULL){
-      free(*plymouthd_argv);
-      free(plymouthd_argv);
-    }
     exit(EXIT_FAILURE);
   }
-  bret = exec_and_wait(NULL, plymouthd_path,
-		       (plymouthd_argv != NULL)
-		       ? (const char * const *)plymouthd_argv
-		       : plymouthd_default_argv,
+  bret = exec_and_wait(NULL, plymouthd_path, plymouthd_argv,
 		       false, true);
-  if(plymouthd_argv != NULL){
-    free(*plymouthd_argv);
-    free(plymouthd_argv);
-  }
   if(not bret){
     exit(EXIT_FAILURE);
   }

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2019-02-10 04:20:26 +0000
+++ plugins.d/plymouth.xml	2017-02-23 19:11:11 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -39,8 +39,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2018-02-08 10:23:55 +0000
+++ plugins.d/splashy.c	2017-02-23 19:11:11 +0000
@@ -2,23 +2,22 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2018 Teddy Hogeborn
- * Copyright © 2008-2018 Björn Påhlsson
- * 
- * This file is part of Mandos.
- * 
- * Mandos is free software: you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- * 
- * Mandos is distributed in the hope that it will be useful, but
+ * Copyright © 2008-2017 Teddy Hogeborn
+ * Copyright © 2008-2017 Björn Påhlsson
+ * 
+ * This program is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation, either version 3 of the
+ * License, or (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
- * along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+ * along with this program.  If not, see
+ * <http://www.gnu.org/licenses/>.
  * 
  * Contact the authors at <mandos@recompile.se>.
  */

=== modified file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2019-02-10 04:20:26 +0000
+++ plugins.d/splashy.xml	2017-02-23 19:11:11 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "splashy">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -41,8 +41,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2018-02-08 10:23:55 +0000
+++ plugins.d/usplash.c	2017-02-23 19:11:11 +0000
@@ -2,23 +2,22 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2018 Teddy Hogeborn
- * Copyright © 2008-2018 Björn Påhlsson
- * 
- * This file is part of Mandos.
- * 
- * Mandos is free software: you can redistribute it and/or modify it
- * under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- * 
- * Mandos is distributed in the hope that it will be useful, but
+ * Copyright © 2008-2017 Teddy Hogeborn
+ * Copyright © 2008-2017 Björn Påhlsson
+ * 
+ * This program is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation, either version 3 of the
+ * License, or (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
- * along with Mandos.  If not, see <http://www.gnu.org/licenses/>.
+ * along with this program.  If not, see
+ * <http://www.gnu.org/licenses/>.
  * 
  * Contact the authors at <mandos@recompile.se>.
  */

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2019-02-10 04:20:26 +0000
+++ plugins.d/usplash.xml	2017-02-23 19:11:11 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "usplash">
-<!ENTITY TIMESTAMP "2019-02-10">
+<!ENTITY TIMESTAMP "2017-02-23">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -41,8 +41,6 @@
       <year>2015</year>
       <year>2016</year>
       <year>2017</year>
-      <year>2018</year>
-      <year>2019</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>

